import sys
sys.path = sys.path + ['', 'Linux']
import PythonCDM
from PythonCDM import *
## Create an Attribute Set and add an Attribute into the set...
attrs = AttributeSet()
attrval = AttributeValue(STRING, 'myAttrValue')
for i in ['1', '2', '3', '4', '5']:
    attr = Attribute('myAttr'+i, attrval)
    attrs.AddAttribute(attr)
## Print the Attribute Set:
print 'The Attribute Set object is:'
print attrs
## Print Attribute Set's elements:
print 'Attribute Set Elements:'
for i in range(attrs.size()):
    print 'Element', i, '(get()):', attrs.get(i)
    print 'Element', i, '([])   :', attrs[i]
## Create a Collection:
col = Collection('testCol', attrs, 'utf-8')
print 'Collection:', col
## Add a Document in the Collection:
col.CreateDocument('a_not_valid_path', ByteSequence('sample text'),
                   AnnotationSet(), attrs)
