if {$argc != 2} {
  puts stderr "usage: $argv0 resource-file output-file"
  exit -1
}

proc do {resource_name output_name} {
  set fd [open $resource_name]
  set data [string trim [read $fd]]
  close $fd
  set fd [open $output_name w]
  foreach line [split $data \n] {
    set line [string trim $line]
    switch -glob $line {
      {#define*} {
        foreach {_ name value} [split $line] {break}
        puts $fd "$name $value $value $name"
      }
    }
  }
  close $fd
};# do
do {*}$argv
exit 0
