##############################################################################
##  ColourValues.tcl:                                                       ##
## ---------------------                                                    ##
##  This file implements a colour selection dialog.                         ##
##                                                                          ##
##  Copyright 1998-2004 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Software and Knowledge Engineering Laboratory,                          ##
##  Institute of Informatics and Telecommunications,                        ##
##  N.C.S.R. "Demokritos"                                                   ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Text Engineering Platform.                                    ##
##############################################################################

###########################################################################
##  Author: George Petasis, petasis@iit.demokritos.gr                    ##
##   Some (140) Colour Values and their names...                         ##
###########################################################################
global Colour

 set Colour(aliceblue) #f0f8ff
 set Colour(antiquewhite) #faebd7
 set Colour(aqua) #00ffff
 set Colour(aquamarine) #7fffd4
 set Colour(azure) #f0ffff
 set Colour(beige) #f5f5dc
 set Colour(bisque) #ffe4c4
 set Colour(black) #000000
 set Colour(blanchedalmond) #ffebcd
 set Colour(blue) #0000ff
 set Colour(blueviolet) #8a2be2
 set Colour(brown) #a52a2a
 set Colour(burlywood) #deb887
 set Colour(cadetblue) #5f9ea0
 set Colour(chartreuse) #7fff00
 set Colour(chocolate) #d2691e
 set Colour(coral) #ff7f50
 set Colour(cornflowerblue) #6495ed
 set Colour(cornsilk) #fff8dc
 set Colour(crimson) #dc143c
 set Colour(cyan) #00ffff
 set Colour(darkblue) #00008b
 set Colour(darkcyan) #008b8b
 set Colour(darkgoldenrod) #b8b60b
 set Colour(darkgray) #a9a9a9
 set Colour(darkgreen) #006400
 set Colour(darkkhaki) #bdb76b
 set Colour(darkmagenta) #8b008b
 set Colour(darkolivegreen) #556b2f
 set Colour(darkorange) #ff8c00
 set Colour(darkorchid) #9932cc
 set Colour(darkred) #8b0000
 set Colour(darksalmon) #e9967a
 set Colour(darkseagreen) #8fbc8f
 set Colour(darkslateblue) #483d8b
 set Colour(darkslategray) #2f4f4f
 set Colour(darkturquoise) #00ced1
 set Colour(darkviolet) #9400d3
 set Colour(deeppink) #ff1493
 set Colour(deepskyblue) #00bfff
 set Colour(dimgray) #696969
 set Colour(dodgerblue) #1e90ff
 set Colour(firebrick) #b22222
 set Colour(floralwhite) #fffaf0
 set Colour(forestgreen) #228b22
 set Colour(fuchsia) #ff00ff
 set Colour(gainsboro) #dcdcdc
 set Colour(ghostwhite) #f8f8ff
 set Colour(gold) #ffd700
 set Colour(goldenrod) #daa520
 set Colour(gray) #808080
 set Colour(green) #008000
 set Colour(greenyellow) #adff2f
 set Colour(honeydew) #f0fff0
 set Colour(hotpink) #ff69b4
 set Colour(indianred) #cd5c5c
 set Colour(indigo) #4b0082
 set Colour(ivory) #fffff0
 set Colour(khaki) #f0e68c
 set Colour(lavender) #e6e6fa
 set Colour(lavenderblush) #fff0f5
 set Colour(lawngreen) #7cfc00
 set Colour(lemonchiffon) #fffacd
 set Colour(lightblue) #add8e6
 set Colour(lightcoral) #f08080
 set Colour(lightcyan) #e0ffff
 set Colour(lightgoldenrodyellow) #fafad2
 set Colour(lightgreen) #90ee90
 set Colour(lightgrey) #d3d3d3
 set Colour(lightpink) #ffb6c1
 set Colour(lightsalmon) #ffa07a
 set Colour(lightseagreen) #20b2aa
 set Colour(lightskyblue) #87cefa
 set Colour(lightslategray) #778899
 set Colour(lightsteelblue) #b0c4de
 set Colour(lightyellow) #ffffe0
 set Colour(lime) #00ff00
 set Colour(limegreen) #32cd32
 set Colour(linen) #faf0e6
 set Colour(magenta) #ff00ff
 set Colour(maroon) #800000
 set Colour(mediumaquamarine) #66cdaa
 set Colour(mediumblue) #0000cd
 set Colour(mediumorchid) #ba55d3
 set Colour(mediumpurple) #9370db
 set Colour(mediumseagreen) #3cb371
 set Colour(mediumslateblue) #7b68ee
 set Colour(mediumspringgreen) #00fa9a
 set Colour(mediumturquoise) #48d1cc
 set Colour(mediumvioletred) #c71585
 set Colour(midnightblue) #191970
 set Colour(mintcream) #f5fffa
 set Colour(mistyrose) #ffe4e1
 set Colour(moccasin) #ffe4b5
 set Colour(navajowhite) #ffdead
 set Colour(navy) #000080
 set Colour(oldlace) #fdf5e6
 set Colour(olive) #808000
 set Colour(olivedrab) #6b8e23
 set Colour(orange) #ffa500
 set Colour(orangered) #ff4500
 set Colour(orchid) #da70d6
 set Colour(palegoldenrod) #eee8aa
 set Colour(palegreen) #98fb98
 set Colour(paleturquoise) #afeeee
 set Colour(palevioletred) #db7093
 set Colour(papayawhip) #ffefd5
 set Colour(peachpuff) #ffdab9
 set Colour(peru) #cd853f
 set Colour(pink) #ffc0cd
 set Colour(plum) #dda0dd
 set Colour(powderblue) #b0e0e6
 set Colour(purple) #800080
 set Colour(red) #ff0000
 set Colour(rosybrown) #bc8f8f
 set Colour(royalblue) #4169e1
 set Colour(saddlebrown) #8b4513
 set Colour(salmon) #fa8072
 set Colour(sandybrown) #f4a460
 set Colour(seagreen) #2e8b57
 set Colour(seashell) #fff5ee
 set Colour(sienna) #a0522d
 set Colour(silver) #c0c0c0
 set Colour(skyblue) #87ceed
 set Colour(slateblue) #6a5acd
 set Colour(slategray) #708090
 set Colour(snow) #fffafa
 set Colour(springgreen) #00ff7f
 set Colour(steelblue) #4682b4
 set Colour(tan) #d2b48c
 set Colour(teal) #008080
 set Colour(thistle) #d8bfd8
 set Colour(tomato) #ff6347
 set Colour(turquoise) #40e0d0
 set Colour(violet) #ee82ee
 set Colour(wheat) #f5deb3
 set Colour(white) #ffffff
 set Colour(whitesmoke) #f5f5f5
 set Colour(yellow) #ffff00
 set Colour(yellowgreen) #a9cd32

#############################################################################
## For the given colour, choose between white/black as a proper colour     ##
## to be compined with...                                                  ##
#############################################################################
proc ChooseBetweenBW {colour} {
  global Colour
  #if {[info exists Colour($colour)]} {
  #  set col $Colour($colour)
  #  if {[string index $col 0] == "\#"} { ;# #???? value...
  #    set value [string range $col 1 end]
  #    set chars_per_value [expr [string length $value] / 3]
  #    set i 0
  #    set R [string range $value $i [expr $i + $chars_per_value -1]]
  #    incr i $chars_per_value
  #    set G [string range $value $i [expr $i + $chars_per_value -1]]
  #    incr i $chars_per_value
  #    set B [string range $value $i end]
  #    set light [expr 0x$R + 0x$G + 0x$B]
  #    if {$light > 390 } {return black} else {return white}
  #  }
  #}
  #return white
  if {[info exists Colour($colour)]} {
    set colour $Colour($colour)
  }
  set col [winfo rgb . $colour]
  # Note that the range of each value in the triple returned by
  # [winfo rgb] is 0-65535, and your eyes are more sensitive to
  # green than to red, and more to red than to blue.
  foreach {r g b} $col {break}
  if {$r+1.5*$g+0.5*$b > 100000} {
    return black
  } else {
    return white
  }
}

proc ChooseColorFromStdPalette {} {
  global Colour
  
  frame .form -background white -relief groove -borderwidth 2 
    label .form.nm -text "Color Name:" -background white
    label .form.name -width 20 -background white
    grid .form.nm .form.name -sticky ew -pady 5
    label .form.vl -text "Hex Value:" -background white
    entry .form.value -width 10 -background white -bd 1
    grid .form.vl .form.value -sticky ew -pady 5
  button .close -text "Close" -command {destroy .} -bd 1
  pack .form -side top -ipadx 10 -pady 20 
  frame .fr -relief ridge -borderwidth 2
  frame .fr.fr
  set win .fr.fr

  set index 0; set i 0
  foreach color [lsort [array names Colour]] {
    puts "  \{$Colour($color) [ChooseBetweenBW $color]\}"
    button $win.b$index -text {} -width 5 -foreground [ChooseBetweenBW $color] \
      -background $Colour($color) -relief raised -borderwidth 1 -command \
      ".form.name configure -text $color -background $Colour($color) \
          -foreground \[ChooseBetweenBW $color\]
       .form.value configure -background $Colour($color) \
          -foreground \[ChooseBetweenBW $color\]
       .form.value delete 0 end; .form.value insert end $Colour($color) 
       update"
      
    pack $win.b$index -side left -padx 1
    incr index
    if {$index > 19} {
      pack $win -padx 5 -pady 1
      set win .fr.fr$i
      frame $win
      incr i
      set index 0
    }
  }
  pack $win -padx 5 -pady 1
  pack .fr -padx 5 -pady 5 -fill x
  pack .close
}
ChooseColorFromStdPalette

## Try to parse the "rgb.txt" file...
set file /usr/X11R6/lib/X11/rgb.txt
if {[file exists $file]} {

proc ChooseColorFromRGB.TXT {FileName} {
  toplevel .rgb
  listbox .rgb.list -width 60 -height 24
  set file [open $FileName]
  while {[gets $file line] != -1} {
    foreach {r g b} $line {break}
    if {[catch {set colour \#[format %02X%02X%02X $r $g $b]}]} {continue}
    set CArray($colour) [ChooseBetweenBW $colour]
  }
  close $file
  foreach colour [lsort [array names CArray]] {
    set fg $CArray($colour)
    .rgb.list insert end "$colour + $fg"
    .rgb.list itemconfigure end -background $colour -foreground $fg
    puts "  \{$colour $fg\}"
  }
  pack .rgb.list -fill both -expand 1
}

ChooseColorFromRGB.TXT $file
}
