##############################################################################
##  Window.tcl:                                                             ##
## -------------                                                            ##
##  This file implements utilities and an interface that can be used to     ##
##  create tk toplevel windows that follow some standards, like having a    ##
##  status bar or a toolbar...                                              ##
##                                                                          ##
##  Copyright 1998-2004 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Software and Knowledge Engineering Laboratory,                          ##
##  Institute of Informatics and Telecommunications,                        ##
##  N.C.S.R. "Demokritos"                                                   ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Text Engineering Platform.                                    ##
##############################################################################

namespace eval ::Window {

## Create a window according to a type. Supported types are "application",
## "dialog" 
## The various types have the following predefined components:
##   "application": toolbar, statusbar
##   "dialog": toolbar, buttons
proc window {} {
}

};# namespace Window
