$doxydocs=
{
  classes => [
    {
      name => 'OCDM_Annotation',
      base => [
        {
          name => 'OCDM_Object',
          virtualness => 'non_virtual',
          protection => 'public'
        }
      ],
      includes => {
        local => 'no',
        name => 'OCDM.h'
      },
      all_members => [
        {
          name => 'AddSpan',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Annotation'
        },
        {
          name => 'AnnotationContainsPosition',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Annotation'
        },
        {
          name => 'AnnotationMatchesRange',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Annotation'
        },
        {
          name => 'AttributeExists',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Annotation'
        },
        {
          name => 'CompareAnnotations',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Annotation'
        },
        {
          name => 'deleteObject',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Object'
        },
        {
          name => 'DisplaceAnnotation',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Annotation'
        },
        {
          name => 'empty',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Object'
        },
        {
          name => 'ensureValidity',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Object'
        },
        {
          name => 'GetFirstSpanOffsets',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Annotation'
        },
        {
          name => 'GetId',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Annotation'
        },
        {
          name => 'getObject',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Object'
        },
        {
          name => 'getStoredObject',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Object'
        },
        {
          name => 'GetType',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Annotation'
        },
        {
          name => 'initObject',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Object'
        },
        {
          name => 'isEmpty',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Object'
        },
        {
          name => 'Log',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Object'
        },
        {
          name => 'objectType',
          virtualness => 'virtual',
          protection => 'public',
          scope => 'OCDM_Annotation'
        },
        {
          name => 'OCDM_Annotation',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Annotation'
        },
        {
          name => 'OCDM_Annotation',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Annotation'
        },
        {
          name => 'OCDM_Annotation',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Annotation'
        },
        {
          name => 'OCDM_Annotation',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCDM_Annotation'
        },
        {
          name => 'OCDM_Annotation',
          virtualness => 'non_virtual',
          protection => 'public',
          scope => 'OCD