##############################################################################
##  CollectionUtilities.tcl:                                                ##
## --------------------------------------------------                       ##
##  This file loads all packages that are parts of the                      ##
##  ELEP::CollectionUtilities package.                                      ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

## Load package: ELEP::CollectionUtilities::CollectionsViewer
package require  ELEP::CollectionUtilities::CollectionsViewer
## Load package: ELEP::CollectionUtilities::CollectionSimpleOperations
package require  ELEP::CollectionUtilities::CollectionSimpleOperations
## Load package: ELEP::CollectionUtilities::CollectionCreator
package require  ELEP::CollectionUtilities::CollectionCreator
## Load package: ELEP::CollectionUtilities::CollectionCreatorDialog
package require  ELEP::CollectionUtilities::CollectionCreatorDialog
## Load package: ELEP::CollectionUtilities::CollectionSimpleManagerToplevel
package require  ELEP::CollectionUtilities::CollectionSimpleManagerToplevel
## Load package: ELEP::CollectionUtilities::CollectionSynchroniser
package require  ELEP::CollectionUtilities::CollectionSynchroniser
## Load package: ELEP::CollectionUtilities::CollectionSynchroniserPostgreSQL
package require  ELEP::CollectionUtilities::CollectionSynchroniserPostgreSQL

package provide  ELEP::CollectionUtilities 1.0
