##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::CollectionUtilities library package.   ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval CollectionUtilities {
  };# namespace  CollectionUtilities
};# namespace  ::ELEP

package ifneeded ELEP::CollectionUtilities 1.0 \
        [list source [file join $dir CollectionUtilities.tcl]]
package ifneeded ELEP::CollectionUtilities::CollectionsViewer 1.0 \
        [list source [file join $dir CollectionsViewer.tcl]]
package ifneeded ELEP::CollectionUtilities::CollectionSimpleOperations 1.0 \
        [list source [file join $dir CollectionSimpleOperations.tcl]]
package ifneeded ELEP::CollectionUtilities::CollectionCreator 1.0 \
        [list source [file join $dir CollectionCreator.tcl]]
package ifneeded ELEP::CollectionUtilities::CollectionCreatorDialog 1.0 \
        [list source [file join $dir CollectionCreatorDialog.tcl]]
package ifneeded ELEP::CollectionUtilities::CollectionSimpleManagerToplevel 1.0\
        [list source [file join $dir CollectionSimpleManagerToplevel.tcl]]
package ifneeded ELEP::CollectionUtilities::CollectionSynchroniser 1.0 \
        [list source [file join $dir CollectionSynchroniser.tcl]]
package ifneeded ELEP::CollectionUtilities::CollectionSynchroniserTDBC 1.0 \
        [list source [file join $dir CollectionSynchroniserTDBC.tcl]]
package ifneeded ELEP::CollectionUtilities::CollectionSynchroniserPostgreSQL 1.0\
        [list source [file join $dir CollectionSynchroniserPostgreSQL.tcl]]
