##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::Database library package.              ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval Database {
  };# namespace  Database
};# namespace  ::ELEP

package ifneeded ELEP::Database::TDBC 1.0 \
        [list source [file join $dir TDBC.tcl]]
package ifneeded ELEP::Database::PostgreSQL 1.0 \
        [list source [file join $dir PostgreSQL.tcl]]
