##############################################################################
##  DocumentUtilities.tcl:                                                  ##
## --------------------------------------------------                       ##
##  This file loads all packages that are parts of the                      ##
##  ELEP::DocumentUtilities package.                                        ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

## Load package: ELEP::DocumentUtilities::EncodingDetection
package require  ELEP::DocumentUtilities::EncodingDetection
## Load package: ELEP::DocumentUtilities::HTMLUtilities
package require  ELEP::DocumentUtilities::HTMLUtilities
## Load package: ELEP::DocumentUtilities::NaiveTokenizer
package require  ELEP::DocumentUtilities::NaiveTokenizer

package provide  ELEP::DocumentUtilities 1.0
