##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::DocumentUtilities library package.     ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval DocumentUtilities {
  };# namespace  DocumentUtilities
};# namespace  ::ELEP

package ifneeded ELEP::DocumentUtilities 1.0 \
        [list source [file join $dir DocumentUtilities.tcl]]
package ifneeded ELEP::DocumentUtilities::EncodingDetection 1.0 \
        [list source [file join $dir EncodingDetection.tcl]]
package ifneeded ELEP::DocumentUtilities::HTMLUtilities 1.0 \
        [list source [file join $dir HTMLUtilities.tcl]]
package ifneeded ELEP::DocumentUtilities::NaiveTokenizer 1.0 \
        [list source [file join $dir NaiveTokenizer.tcl]]
package ifneeded ELEP::DocumentUtilities::HashTableGazetteer 1.0 \
        [list source [file join $dir HashTableGazetteer.tcl]]
