##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::ExportConverters library package.      ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval ExportConverters {
  };# namespace  ExportConverters
};# namespace  ::ELEP

package ifneeded ELEP::ExportConverters 1.0 \
        [list source [file join $dir ExportConverters.tcl]]
package ifneeded ELEP::ExportConverters::XMLExporter 1.0 \
        [list source [file join $dir XMLExporter.tcl]]
package ifneeded ELEP::ExportConverters:: 1.0 \
        [list source [file join $dir .tcl]]
package ifneeded ELEP::ExportConverters:: 1.0 \
        [list source [file join $dir .tcl]]
package ifneeded ELEP::ExportConverters:: 1.0 \
        [list source [file join $dir .tcl]]
package ifneeded ELEP::ExportConverters:: 1.0\
        [list source [file join $dir .tcl]]
