##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::FileUtilities library package.         ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval FileUtilities {
  };# namespace  FileUtilities
};# namespace  ::ELEP

package ifneeded ELEP::FileUtilities::URI 1.0 \
        [list source [file join $dir URI.tcl]]
package ifneeded ELEP::FileUtilities::HTMLPageDownloader 1.0 \
        [list source [file join $dir HTMLPageDownloader.tcl]]
package ifneeded ELEP::FileUtilities::HTMLPageLinkCrawler 1.0 \
        [list source [file join $dir HTMLPageLinkCrawler.tcl]]
package ifneeded ELEP::FileUtilities::Crawler 1.0 \
        [list source [file join $dir Crawler.tcl]]
