##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::FlowControl library package.           ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval FlowControl {
    variable FlowControl
    if {![info exists FlowControl(tkpath)]} {
      set FlowControl(tkpath) 0
    }
  };# namespace  FlowControl
};# namespace  ::ELEP

package ifneeded ELEP::FlowControl::Canvas 1.0 \
        [list source [file join $dir Canvas.tcl]]
package ifneeded ELEP::FlowControl::Item 1.0 \
        [list source [file join $dir Item.tcl]]
package ifneeded ELEP::FlowControl::GradientItem 1.0 \
        [list source [file join $dir GradientItem.tcl]]
package ifneeded ELEP::FlowControl::ComponentItem 1.0 \
        [list source [file join $dir ComponentItem.tcl]]
package ifneeded ELEP::FlowControl::ConnectionItem 1.0 \
        [list source [file join $dir ConnectionItem.tcl]]
package ifneeded ELEP::FlowControl::GraphManager 1.0 \
        [list source [file join $dir GraphManager.tcl]]
package ifneeded ELEP::FlowControl::GraphLayoutSpring 1.0 \
        [list source [file join $dir GraphLayoutSpring.tcl]]
package ifneeded ELEP::FlowControl::GraphLayoutDot 1.0 \
        [list source [file join $dir GraphLayoutDot.tcl]]
package ifneeded ELEP::FlowControl::GraphNode 1.0 \
        [list source [file join $dir GraphNode.tcl]]
package ifneeded ELEP::FlowControl::GraphEdge 1.0 \
        [list source [file join $dir GraphEdge.tcl]]
