##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::ImportHandlers library package.        ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval ImportHandlers {
  };# namespace  ImportHandlers
};# namespace  ::ELEP

package ifneeded ELEP::ImportHandlers 1.0 \
        [list source [file join $dir ImportHandlers.tcl]]
package ifneeded ELEP::ImportHandlers::Alignment_TradosWinAlign 1.0 \
        [list source [file join $dir Alignment_TradosWinAlign.tcl]]
package ifneeded ELEP::ImportHandlers::CASAM 1.0 \
        [list source [file join $dir CASAM.tcl]]
package ifneeded ELEP::ImportHandlers::SYNC3 1.0 \
        [list source [file join $dir SYNC3.tcl]]
package ifneeded ELEP::ImportHandlers:: 1.0 \
        [list source [file join $dir .tcl]]
package ifneeded ELEP::ImportHandlers:: 1.0\
        [list source [file join $dir .tcl]]
