##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::MachineLearning library package.       ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval MachineLearning {
    namespace eval Clustering {
    };# namespace Clustering
  };# namespace   MachineLearning
};# namespace   ::ELEP

package ifneeded ELEP::MachineLearning::Clustering::AbstractClusterer 1.0 \
        [list source [file join $dir Clustering AbstractClusterer.tcl]]
package ifneeded ELEP::MachineLearning::Clustering::NFoldCrossValidation 1.0 \
        [list source [file join $dir Clustering NFoldCrossValidation.tcl]]
package ifneeded ELEP::MachineLearning::Clustering::SimpleKMeans 1.0 \
        [list source [file join $dir Clustering SimpleKMeans.tcl]]
