##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::Ontology library package.              ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval Ontology {
  };# namespace  Ontology
};# namespace  ::ELEP

package ifneeded ELEP::Ontology::RDFParser 1.0 \
        [list source [file join $dir RDFParser.tcl]]
package ifneeded ELEP::Ontology::OWLParser 1.0 \
        [list source [file join $dir OWLParser.tcl]]
package ifneeded ELEP::Ontology::OWLHierarchyViewer 1.0 \
        [list source [file join $dir OWLHierarchyViewer.tcl]]
package ifneeded ELEP::Ontology::OWLViewer 1.0 \
        [list source [file join $dir OWLViewer.tcl]]
package ifneeded ELEP::Ontology::RacerPro 1.0 \
        [list source [file join $dir RacerPro.tcl]]
package ifneeded ELEP::Ontology::ABoxInstancesViewer 1.0 \
        [list source [file join $dir ABoxInstancesViewer.tcl]]
package ifneeded ELEP::Ontology::ABoxViewer 1.0 \
        [list source [file join $dir ABoxViewer.tcl]]
