##############################################################################
##  HTMLTagBase.tcl:                                                        ##
## --------------------------------------------------                       ##
##  This class provides facilities for adding tags in an HTML widget.       ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

switch -glob [package require Tkhtml] {
  2.* {source [file dirname [info script]]/HTMLTagBase-2.tcl}
  3.* {source [file dirname [info script]]/HTMLTagBase-3.tcl}
  default {error "unsupported TkHtml version: [package require Tkhtml]!"}
}
