##############################################################################
##  ViewerBase.tcl:                                                         ##
## --------------------------------------------------                       ##
##  This file loads all packages that are parts of the ELEP::ViewerBase     ##
##  package.                                                                ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

## Load package: ELEP::ViewerBase::ColourPairs
package require  ELEP::ViewerBase::ColourPairs
## Load package: ELEP::ViewerBase::ColourManager
package require  ELEP::ViewerBase::ColourManager
## Load package: ELEP::ViewerBase::AnnotatorSpecificationReader
package require  ELEP::ViewerBase::AnnotatorSpecificationReader
## Load package: ELEP::ViewerBase::AnnotationSpecificationSelector
package require  ELEP::ViewerBase::AnnotationSpecificationSelector
## Load package: ELEP::ViewerBase::TemplateSpecificationSelector
package require  ELEP::ViewerBase::TemplateSpecificationSelector
## Load package: ELEP::ViewerBase::MultiAttributedAnnotationSpecificationSelector
package require  ELEP::ViewerBase::MultiAttributedAnnotationSpecificationSelector
## Load package: ELEP::ViewerBase::AnnotationAndTemplateSpecificationSelector
package require  ELEP::ViewerBase::AnnotationAndTemplateSpecificationSelector
## Load package: ELEP::ViewerBase::CollectionSelector
package require  ELEP::ViewerBase::CollectionSelector
## Load package: ELEP::ViewerBase::DocumentSelector
package require  ELEP::ViewerBase::DocumentSelector
## Load package: ELEP::ViewerBase::HTMLTagBase
package require  ELEP::ViewerBase::HTMLTagBase
## Load package: ELEP::ViewerBase::TextWidgetDisplay
package require  ELEP::ViewerBase::TextWidgetDisplay
## Load package: ELEP::ViewerBase::TextWidgetDisplayAlignment
package require  ELEP::ViewerBase::TextWidgetDisplayAlignment
## Load package: ELEP::ViewerBase::HtmlWidgetDisplay
package require  ELEP::ViewerBase::HtmlWidgetDisplay
## Load package: ELEP::ViewerBase::1ClickSelector
package require  ELEP::ViewerBase::1ClickSelector
## Load package: ELEP::ViewerBase::AutomaticTagger
package require  ELEP::ViewerBase::AutomaticTagger
## Load package: ELEP::ViewerBase::ButtonAnnotator
package require  ELEP::ViewerBase::ButtonAnnotator
## Load package: ELEP::ViewerBase::CoreferenceAnnotator
package require  ELEP::ViewerBase::CoreferenceAnnotator
## Load package: ELEP::ViewerBase::TemplateFiller
package require  ELEP::ViewerBase::TemplateFiller
## Load package: ELEP::ViewerBase::AnnotationSelector
package require  ELEP::ViewerBase::AnnotationSelector
## Load package: ELEP::ViewerBase::AnnotationHighlighter
package require  ELEP::ViewerBase::AnnotationHighlighter
## Load package: ELEP::ViewerBase::EventDefiner
package require  ELEP::ViewerBase::EventDefiner
## Load package: ELEP::ViewerBase::AttributesWidget
package require  ELEP::ViewerBase::AttributesWidget

package provide  ELEP::ViewerBase 1.0
