##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::WebSearch library package.             ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval WebSearch {
  };# namespace  WebSearch
};# namespace  ::ELEP

package ifneeded ELEP::WebSearch::Google 1.0 \
        [list source [file join $dir Google.tcl]]
package ifneeded ELEP::WebSearch::Yahoo 1.0 \
        [list source [file join $dir Yahoo.tcl]]
package ifneeded ELEP::WebSearch::Technorati 1.0 \
        [list source [file join $dir Technorati.tcl]]
