##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::WindowUtilities library package.       ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval WindowUtilities {
  };# namespace  WindowUtilities
};# namespace  ::ELEP

package ifneeded ELEP::WindowUtilities 1.0 \
        [list source [file join $dir WindowUtilities.tcl]]
package ifneeded ELEP::WindowUtilities::WidgetBase 1.0 \
        [list source [file join $dir WidgetBase.tcl]]
package ifneeded ELEP::WindowUtilities::ToplevelWindow 1.0 \
        [list source [file join $dir Toplevel.tcl]]
package ifneeded ELEP::WindowUtilities::RibbonToplevelWindow 1.0 \
        [list source [file join $dir RibbonToplevel.tcl]]
package ifneeded ELEP::WindowUtilities::DialogWindow 1.0 \
        [list source [file join $dir Dialog.tcl]]
package ifneeded ELEP::WindowUtilities::ConsoleWindow 1.0 \
        [list source [file join $dir ConsoleWindow.tcl]]
package ifneeded ELEP::WindowUtilities::ObjectListenerServer 1.0 \
        [list source [file join $dir ObjectListenerServer.tcl]]
package ifneeded ELEP::WindowUtilities::ObjectListenerClient 1.0 \
        [list source [file join $dir ObjectListenerClient.tcl]]
package ifneeded ELEP::WindowUtilities::ProgressWidget 1.0 \
        [list source [file join $dir ProgressWidget.tcl]]
