if {0} {
  proc print_packages {} {
    foreach package [lsort [package names]] {
      if {[string match ELEP* $package]} { puts "  $package" }
    }
  };# print_packages
  
  foreach package {ELEP::VisualAnnotators::HtmlTemplateFiller
                   ELEP::CollectionUtilities::CollectionSimpleManagerToplevel} {
    catch {package require $package} error
    puts "package $package -> $error"
  }
  print_packages
}

set IdleCommands execute_this
set IdleCommands test_cv
set IdleCommands flow_control

proc flow_control {} {
  toplevel .x
  ScrolledWindow .x.sw
  canvas .x.sw.c -background white
  .x.sw setwidget .x.sw.c
  pack .x.sw -fill both -expand 1
};# flow_control

proc test_cv {} {
  package require ELEP::CollectionUtilities::CollectionSimpleManagerToplevel
  set x [ELEP::CollectionUtilities::CollectionSimpleManagerToplevel .xxxx#auto]
  $x show
}

proc execute_this {} {
creole_AnnotatorTemplateFillerOnHTML {} {}
return
  catch {
    #creole_AnnotatorTemplateFillerOnHTML {} {}
    test_cv
  } error
  puts $error
  puts $::errorInfo
  
  #toplevel .x
  #set myHv3 [::hv3::hv3 .x.html]
  #pack $myHv3 -fill both -expand true
  #set obj [ELEP::ViewerBase::HTMLTagBase #auto $myHv3]
  #set fd [open /disk2a/users/petasis/Ellogon/ellogon2.0/lib_sources/htmlwidget/hv/index.html]
  #set html [read $fd]
  #close $fd
  #$obj setHTML $html
}
