/*****************************************************************************
 *  EmbedAPI.h:                                                              *
 * ----------------------                                                    *
 *  This file defines an API for embeding Ellogon in a C application.        *
 *                                                                           *
 *  Copyright 1998-2009 by:                                                  *
 *  Georgios Petasis,                                                        *
 *  Software and Knowledge Engineering Laboratory,                           *
 *  Institute of Informatics and Telecommunications,                         *
 *  National Center for Scientific Research (N.C.S.R.) "Demokritos",         *
 *  Athens, Greece.                                                          *
 *  E-mail: petasis@iit.demokritos.gr                                        *
 *                                                                           *
 *  This file is part of the "Ellogon" Text Engineering Platform.            *
 *  For licencing information, please refer to the licence conditions of     *
 *  "Ellogon" Text Engineering Platform.                                     *
 *****************************************************************************/
#include "tcl.h"

Tcl_Interp *Ellogon_Init(int argc, char **argv);
int Ellogon_CreateInstance(Tcl_Interp *interp,
                           const char *path_to_ellogon,
                           int argc, char **argv);
int Ellogon_InstanceEval(Tcl_Interp *interp, int instance, const char *cmd);
