package ifneeded TclAgent 1.0 [list ::TclAgent::pload [file normalize $dir]]

namespace eval ::TclAgent {
  proc pload {dir} {
    switch -glob $::tcl_platform(machine) {
      *_64    {set bits x86_64}
      default {set bits x86_32}
    }
    switch -- $::tcl_platform(platform) {
      windows {
        update idle
        load $dir/Windows/$bits/TclAgent.dll
        package provide TclAgent 1.0
      }
      default {error "Unsupported platform: \"$::tcl_platform(platform)\""}
    }
  };# pload
};# namespace eval ::TclAgent
