/*
 * %pkgName%.h --
 *
 *	This header file contains the function declarations needed for
 *	all of the source files in this package.
 *
 * Copyright (c) %year% %author%.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#ifndef _%pkgNameUpper%
#define _%pkgNameUpper%

/*
 * Define package-related information
 */
#define PACKAGE_NAME     "%pkgName%"
#define PACKAGE_VERSION  "1.0"

#include <tcl.h>

/*
 * Windows needs to know which symbols to export.  Unix does not.
 * BUILD_%pkgName% should be undefined for Unix.
 */

#ifdef BUILD_%pkgNameUpper%
#undef TCL_STORAGE_CLASS
#define TCL_STORAGE_CLASS DLLEXPORT
#endif /* BUILD_%pkgNameUpper% */

%prototypes%

/*
 * Only the %pkgNameTitle%_Init and %pkgNameTitle%_SafeInit functions
 * are exported.
 */

EXTERN int %pkgNameTitle%_Init     _ANSI_ARGS_((Tcl_Interp * interp));
EXTERN int %pkgNameTitle%_SafeInit _ANSI_ARGS_((Tcl_Interp * interp));

#endif /* _%pkgNameUpper% */
