namespace eval ::%pkgName% {
  proc loadPackage {dir} {
    if {[string equal $::tcl_platform(platform) windows]} {
      set binDir Windows
    } else {
      set binDir $::tcl_platform(os)
    }
    ## As a first step, check whether we have a binary in a platfrom specific
    ## folder...
    if {[file exists $dir/$binDir/lib%pkgName%[info \
                                                sharedlibextension]]} {
       ## Try to load the binary...
       if {[catch {load $dir/$binDir/lib%pkgName%[info \
                                                sharedlibextension]} error]} {
         ## Load the binary as usual...
         load $dir/lib%pkgName%[info sharedlibextension]
       }
    }
  };# loadPackage
};# namespace eval ::%pkgName%

package ifneeded %pkgName% 1.0  [list ::%pkgName%::loadPackage $dir]
