/***************************************************************************
*
*       %%ModuleName%%.java - %%Date%%
*       This is a java coupled (Java) Component for use with 
*       %%Program%%, version %%Version%%...
*
***************************************************************************/

import tcl.lang.*;
import %%Program%%.JCDM.*;

/* 
 * Class: creole_%%ModuleName%%
 * This is the class of interest, as it implements the basic function
 * required by the %%Program%% platform in order to succesfully load this
 * plug-in module. This function is the main function of the module, responsible
 * for doing the basic processing...
 */
class creole_%%ModuleName%% implements Command {
  /* Location of this module (%%ModuleName%%) */
  public static String creole_%%ModuleName%%_home;
  
  public void cmdProc(Interp interp, TclObject argv[]) throws TclException {
    /*
     * %%Program%% Components require at least one argument. If more are
     * required by the component, please update the following three lines of
     * code accordingly...
     */
    if (argv.length < 2) {
      throw new TclNumArgsException(interp, 1, argv, "Document ?args?");
    }
    OCDM_Document Doc = new OCDM_Document(argv[1].toString());
    Doc.SetProcessStatus(0); // Status Value: [0-100], Remove method to disable

    /* Put your code here... */

    // Record the fact that we ran and exit normally
    Doc.PutAttribute(new OCDM_Attribute("%%ModuleName%%",
                         new OCDM_AttributeValue(OCDM.OCDM_STRING, "")));
    
    // IMPORTANT: Don't forget to call the delete() method of any
    // %%Program%% object that has been assigned in a variable, after
    // you don't need it anymore! (Else, the whole application may crash!)
    Doc.delete();
  } /* creole_%%ModuleName%%::cmdProc */
} /* class creole_%%ModuleName%% */


/* Function: creole_%%ModuleName%%_Initialize
    Use this function in order to do some initialisation. This function will
    be called just before creole_%%ModuleName%% in the following
    situations:
     *) If the user has opened a whole Collection, this function will be 
        called just before the first document in Collection gets proccessed 
        with creole_%%ModuleName%%
     *) If the user has opened a single Document, this function will be called
        just before calling creole_%%ModuleName%%
    Please, refer to the %%Program%%'s Programming Manual for more 
    information on this function... */
class creole_%%ModuleName%%_Initialize implements Command {
  /* Location of this module (%%ModuleName%%) */
  public static String creole_%%ModuleName%%_home;
  
  public void cmdProc(Interp interp, TclObject argv[]) throws TclException {
    // if (argv.length < 3) {
    //   throw new TclNumArgsException(interp, 1, argv,
    //                                            "Collection Document ?args?");
    // }
    // OCDM_Collection Col = new OCDM_Collection(argv[1].toString());
    // OCDM_Document   Doc = new OCDM_Document(argv[2].toString());
    
    /* Do some initilization here... */

    // IMPORTANT: Don't forget to call the delete() method of any
    // %%Program%% object that has been assigned in a variable, after
    // you don't need it anymore! (Else, the whole application may crash!)
    // Col.delete();
    // Doc.delete();
  } /* creole_%%ModuleName%%_Initialize::cmdProc */
} /* class creole_%%ModuleName%%_Initialize */


/*  Function: creole_%%ModuleName%%_Finish
    Use this function in order to do some Clean-Up. This function will
    be called after all calls to creole_%%ModuleName%% in the following 
    situations:
     *) If the user has opened a whole Collection, this function will be 
        called just after the last document in Collection gets proccessed with 
        creole_%%ModuleName%%
     *) If the user has opened a single Document, this function will be called
        just after calling creole_%%ModuleName%%
    Please, refer to the %%Program%%'s Programming Manual for more 
    information on this function... */
class creole_%%ModuleName%%_Finish implements Command {
  /* Location of this module (%%ModuleName%%) */
  public static String creole_%%ModuleName%%_home;

  public void cmdProc(Interp interp, TclObject argv[]) throws TclException {
    // if (argv.length < 3) {
    //   throw new TclNumArgsException(interp, 1, argv,
    //                                            "Collection Document ?args?");
    // }
    // OCDM_Collection Col = new OCDM_Collection(argv[1].toString());
    // OCDM_Document   Doc = new OCDM_Document(argv[2].toString());
    
    /* Clean-Up... */

    // IMPORTANT: Don't forget to call the delete() method of any
    // %%Program%% object that has been assigned in a variable, after
    // you don't need it anymore! (Else, the whole application may crash!)
    // Col.delete();
    // Doc.delete();
  } /* creole_%%ModuleName%%_Finish::cmdProc */
} /* class creole_%%ModuleName%%_Finish */

/**********************************************************************
 **               --   Ignore the Following Code   --              
 **  The following Java code takes care the interfaces to the %%Program%%
 **  platform. Please modify with care...
 **********************************************************************/

/* 
 * This class implements a simple Tcl extension package and registers the
 * Components commands with the main %%Program%% Tcl interpreter.
 * Modify with care...
 */
public class %%ModuleName%% extends Extension {
  public void init(Interp interp) {
    /* Register the Module Main Command */
    interp.createCommand("creole_%%ModuleName%%",
                         new creole_%%ModuleName%%());
    interp.createCommand("creole_%%ModuleName%%_Initialize",
                         new creole_%%ModuleName%%_Initialize());
    interp.createCommand("creole_%%ModuleName%%_Finish",
                         new creole_%%ModuleName%%_Finish());
  }

  public static void SetComponentHome(String path) {
    creole_%%ModuleName%%.creole_%%ModuleName%%_home =
    creole_%%ModuleName%%_Initialize.creole_%%ModuleName%%_home =
    creole_%%ModuleName%%_Finish.creole_%%ModuleName%%_home =
                                                                           path;
  }
} /* class %%ModuleName%% */

/* 
 * End of %%ModuleName%%.java
 */
