"""
%%ModuleName%%.py - %%Date%%

This is a python loose coupled Component for use with
%%Program%%, version %%Version%%...
"""

from PythonCDM import *

# The location of the Component is stored in the global variable with
# name "creole_%%ModuleName%%_home"

class %%ModuleName%%(object):
    # Use this method in order to do some initialisation. This method will
    # be called just before %%ModuleName%%() in the following situations:
    #  *) If the user has opened a whole Collection, this method will be 
    #     called just before the first document in Collection gets proccessed 
    #     with %%ModuleName%%()
    #  *) If the user has opened a single Document, this method will be called
    #     just before calling %%ModuleName%%()
    # Please, refer to the %%Program%%'s Programming Manual for more 
    # information on this method...
    def initialize(self, collection_name, document_name, *args):
        pass

    # Use this method in order to do some Clean-Up. This method will
    # be called after all calls to %%ModuleName%%() in the following 
    # situations:
    #  *) If the user has opened a whole Collection, this method will be 
    #     called just after the last document in Collection gets proccessed with
    #     %%ModuleName%%()
    #  *) If the user has opened a single Document, this method will be called
    #     just after calling %%ModuleName%%()
    # Please, refer to the %%Program%%'s Programming Manual for more 
    # information on this method...
    def finish(self, collection_name, document_name, *args):
        pass

    def __call__(self, document_name, *args):
        document = Document(document_name)
        # Status Value: [0-100], Remove method to disable
        document.SetProcessStatus(0)

        # Put your code here...

        # record the fact that we ran and exit normally
        document['%%ModuleName%%'] = AttributeValue(STRING, '')

    def set_home(path):
        self.component_home = path


###########################################################################
##              -->>   Ignore the Following Code   <<--              
## The following code takes care the interfaces to the %%Program%%
## platform. Please modify with care...
###########################################################################
proxy = %%ModuleName%%()
creole_%%ModuleName%% = proxy
creole_%%ModuleName%%_Initialize = proxy.initialize
creole_%%ModuleName%%_Finish = proxy.finish
creole_%%ModuleName%%_SetComponentHome = proxy.set_home
#
# End of File %%ModuleName%%.py
#
