##########################################################################
#
#       %%ModuleName%%.pm - %%Date%%
#       This is a perl loose coupled Component for use with 
#       %%Program%%, version %%Version%%...
#
##########################################################################

use PerlCDM;

# The location of the Component is stored in the global variable with
# name "creole_%%ModuleName%%_home"

## creole_%%ModuleName%%
#  
sub creole_%%ModuleName%% {
  # %%Program%% Components require at least one argument. If more are
  # required by the component, please update the following three lines of
  # code accordingly...
  if (@_ < 1) {
    die "creole_%%ModuleName%% requires at least one argument," .
        " the Document to be processed!"
  }
  # %%Program%% will always place the Document that we have to process as the
  # first argument of the subroutine...
  my $doc = PerlCDM::Document->new(@_[0]);
  # Status Value: [0-100], Remove method to disable
  $doc->SetProcessStatus(0);
  
  # Put your code here...
  # $DocId = $doc->GetId();
  # print "Document Id: \"$DocId\"\n";

  # record the fact that we ran and exit normally
  my $AttrVal = PerlCDM::AttributeValue->new($PerlCDM::STRING, "");
  my $Attr    = PerlCDM::Attribute->new("%%ModuleName%%", $AttrVal);
  $doc->PutAttribute($Attr);
};# creole_%%ModuleName%%


## Procedure: creole_%%ModuleName%%_Initialize
#   Use this function in order to do some initialisation. This function will
#   be called just before creole_%%ModuleName%% in the following situations:
#    *) If the user has opened a whole Collection, this function will be 
#       called just before the first document in Collection gets proccessed 
#       with creole_%%ModuleName%%
#    *) If the user has opened a single Document, this function will be called
#       just before calling creole_%%ModuleName%%
#   Please, refer to the %%Program%%'s Programming Manual for more 
#   information on this function...
sub creole_%%ModuleName%%_Initialize {
  if (@_ < 2) {
    die "creole_%%ModuleName%%_Initialize requires at least two arguments," .
        " the Collection and Document to be processed!"
  }
  # my $col = PerlCDM::Collection->new(@_[0]);
  # my $doc = PerlCDM::Document->new(@_[1]);
  # Do some initilisation here...
  # print "$creole_perl_home\n";
};# creole_%%ModuleName%%_Initialize

## Procedure: creole_%%ModuleName%%_Finish
#   Use this function in order to do some Clean-Up. This function will
#   be called after all calls to creole_%%ModuleName%% in the following 
#   situations:
#    *) If the user has opened a whole Collection, this function will be 
#       called just after the last document in Collection gets proccessed with 
#       creole_%%ModuleName%%
#    *) If the user has opened a single Document, this function will be called
#       just after calling creole_%%ModuleName%%
#   Please, refer to the %%Program%%'s Programming Manual for more 
#   information on this function...
sub creole_%%ModuleName%%_Finish {
  if (@_ < 1) {
    die "creole_%%ModuleName%%_Finish requires at least one argument," .
        " the Collection to be processed!"
  }
  # my $col = PerlCDM::Collection->new(@_[0]);
  # Clean-Up...
};# creole_%%ModuleName%%_Finish

#
# End of File %%ModuleName%%.pm
#
