##########################################################################
# 
#	%%ModuleName%%.tcl - %%Date%%
#       This is a loosed coupled (Tcl) Component for use with 
#       %%Program%%, version %%Version%%...
#
##########################################################################


# Location of this module (%%ModuleName%%)
global creole_%%ModuleName%%_home

## creole_%%ModuleName%%
#  
proc creole_%%ModuleName%% {doc args} {
  global creole_%%ModuleName%%_home
  # set current_dir [pwd]
  # cd $creole_%%ModuleName%%_home

  ## Under %%Program%%, the window that desplays the "wait" message can
  ## additionally display a progress bar. In order to activate this feature,
  ## you must execute the command "ggi_wait_update document percent"
  ## In fact, if you enclose the command in a catch block, this module will
  ## also run under GATE without problems. The second argument to the 
  ## ggi_wait_update procedure is the percent, which is in the range [0,100]
  ## Setting percent a negative value causes the progress bar to disappear.
  ##   catch {ggi_wait_update $doc 0}
  
  ## Put your code here...

  # record the fact that we ran and exit normally
  # cd $current_dir
  tip_PutAttribute $doc [tip_CreateAttribute %%ModuleName%% \
                             [tip_CreateAttributeValue GDM_STRING {}]]
};# creole_%%ModuleName%%


## Procedure: creole_%%ModuleName%%_Initialize
#   Use this function in order to do some initialisation. This function will
#   be called just before creole_%%ModuleName%% in the following situations:
#    *) If the user has opened a whole Collection, this function will be 
#       called just before the first document in Collection gets proccessed 
#       with creole_%%ModuleName%%
#    *) If the user has opened a single Document, this function will be called
#       just before calling creole_%%ModuleName%%
#   Please, refer to the %%Program%%'s Programming Manual for more 
#   information on this function...
proc creole_%%ModuleName%%_Initialize {col doc args} {
  global creole_%%ModuleName%%_home
  ## Do some initilisation here...
};# creole_%%ModuleName%%_Initialize

## Procedure: creole_%%ModuleName%%_Finish
#   Use this function in order to do some Clean-Up. This function will
#   be called after all calls to creole_%%ModuleName%% in the following 
#   situations:
#    *) If the user has opened a whole Collection, this function will be 
#       called just after the last document in Collection gets proccessed with 
#       creole_%%ModuleName%%
#    *) If the user has opened a single Document, this function will be called
#       just after calling creole_%%ModuleName%%
#   Please, refer to the %%Program%%'s Programming Manual for more 
#   information on this function...
proc creole_%%ModuleName%%_Finish {col doc args} {
  global creole_%%ModuleName%%_home
  ## Clean-Up...
};# creole_%%ModuleName%%_Finish

#
# End of File %%ModuleName%%.tcl
#
