# English Tips Database
# Encoding: iso8859-7

global TipDatabase
set TipDatabase(Greek) {
{{Handle Toolbars...} 
 {Each Toolbar has a special Handler, from which you can:
    1. Make a Toolbar a seperate floating window:
       Just Double-Click on the Toolbar Handle...
    2. Hide a Toolbar:
       Click on the Toolber with the right-most button and select "Hide" from
       the menu that appears...}}

{{Using the Console...}
 {By using the Console, you can execute commands directly inside the platform.
The full TIPSTER API is available, as well as the extremely powerfull Tcl with
its Graphical Extension Tk...
Note also that Console is powerful enough to allow command completion, history,
tab expansion and many other features!}}

{{Using the Right Mouse Button...} 
 {Use the Right Mouse Button:
  In many situations you will get a Context Sensitive Menu...}}

{{Change Document Encoding...} 
 {In order to change the encoding of a single Document, do the following:
    1. Open the Edit Collections Dialog.
    2. Select the desired Document.
    3. Click on the "Update Document" Button.
Note this action will remove all Attributes and Annotations from Document!}}

{{Change Collection Encoding...}
 {In order to change the encoding of a Collection, do the following:
    1. Open the Edit Collections Dialog.
    2. Select the desired Collection.
    3. Click on the "Edit Collection" Button.
    4. Change the Collection's Encoding.
    5. Click "Ok".
Note this action will reset Collection, removing all Attributes and Annotations from all Documents!}} 

{{Rename a Collection...}
{In order to change the name of a Collection, do the following:
    1. Open the Edit Collections Dialog.
    2. Click with the right-most mouse button on the desired Collection.
    3. From the menu that will appear, select "Rename the Selected Selection...".
    4. In the dialog that will appear, enter the desired name.
    5. Click "Ok".}}

{{Using Drag-n-Drop...}
 {You can use Drag-n-Drop in the Systems window (main window), in order
to move Systems arround. You can move a System into an existing Folder by
dragging the System to the desired Folder.}}

{{Moving a System in the Root Folder...}
{You can move a System located inside a Folder to the Root Folder, by dragging
the desired System to "Available Systems" label.}}

{{Moving a Module inside a System Graph...}
{You can move a module inside a System graph, by holding the "Control" button
pressed while using the left-most mouse button to move the module. While the
module is dragged to the new position, the current coordinates of the module
are shown in the middle of the System graph window...}}

{{Modifying the Grid Settings of a System Graph...}
{Each System graph has a grid assosiated with it. This grid is not visible,
but affects the movements of the modules that the System can have. The default
value of this grid is set to 1 pixel in both horizontal and vertical directions.
In order to change the default setting, do the following:
    1. Open the desired System window.
    2. Select the menu labeled "Layout".
    3. Select "Set Grid..." entry of the "Layout" menu.
    4. In the dialog that will appear, enter the desired grid settings.
    5. Click "Ok".}}

{{Change Communication Language...}
{You can change the Language that the application uses to communicate with the
user (all the menus, messages and dialogs), by clicking on the flag that exists
in most of the windows. A menu will appear that will display all the available
communication languages. Just select the desired one...}}

{{The Notion of the Keyboard Language...}
{Beside the Communication Language that the application uses in order to
communicate with the user, there is also the notion of the "Keyboard Language".
This language is used by the application in order to communicate with the
operating system. Directory and file names from the disk, as well as the
keyboard interaction is affected by this option. In general, this setting
affects all interactions between the application and the operating system,
except the manipulation of Collections and Documents...}}

{{Collections and Saved Disk Representations...}
{The application is capable of saving and retrieving Collections in two
different formats. The first format is called "Native" and is the proposed
format of this application. The second format is called "Gate" and is the
format that the GATE Natural Language Platform uses in order to save its
Collections.
   It is recomended to use the "Native" format as the main format for Collections.
The main advantages over the "Gate" format are increased processing speed
(regarding of course disk input/output) and reduced disk space. On the other
hand, Collections in "Gate" format can by recognized and manipulated by the
"Gate" NLP platform. The format that a Collection uses is defined when the
Collection is created, but the user can change the format extremely easy by
using the corresponding utilities...}}

{{Changing Collection Formats...}
{You can change the format that a Collection uses in order to be stored in
disk as follows:
    1. Open the Edit Collections Dialog.
    2. Click with the right-most mouse button on the desired Collection.
    3. From the menu that will appear, select "Change Collection Format...".
    4. In the dialog that will appear, select the desired format.
    5. Click "Ok".
(The time used by the convertion utility mainly depends on the size of the
Collection: Processing time increases with the Collection size...)}}

{{Handling Collections in "Gate" Format...}
{Although this application can handle Collections in "Gate" format (for
example Collections created by the GATE NLP Platform), this option is not
enabled by default. In order to enable handling of Collections in "Gate"
format, do the following:
    1. In the Systems Window (main window), select "Options..." from the
       "File" menu.
    2. Select the "Collections" tab from the dialog that will appear.
    3. Click on the option "Enable GATE Collection Management" so as to become
       selected.
    4. Click on "Ok".
(The same dialog is accessible from the Collections Dialog, by selecting
"Options..." from the "View" menu...)}}
}
