# 
#        EBrill/creole_config.tcl - configuration file
#
#        Wednesday November 22 18:47:34 (GTB Standard Time) 2006
#        
#        $Id: template_config.tcl, Ellogon, version 1.8.0... 
#            (Georgios Petasis, 23/11/1998), petasis@iit.demokritos.gr   $


set creole_config(EBrill) \
{  
    title {English POS Tagger}
    pre_conditions {
        collection_attributes      {}
        document_attributes        {language_english}
        annotations                {token {sentence constituents}}
    }
    post_conditions {
        collection_attributes      {}
        document_attributes        {EBrill}
        annotations                {{token pos}}
    }
    viewers {
      token HTMLAnnotationExplorer {View annotations...}
      $::creole_HBrill_home/GreekTags.html text_file {Greek POS Tag Definitions}
    }
    parameters {
      Language %COMBO% {english greek}
    }
    coupling loose
    description {Author: petasis, Wed Nov 22 6:46:48  GTB Standard Time 2006}
    module_encoding iso8859-1
    type module
};# EBrill

## Compatibility Mode: Use 0 for Ellogon mode, 1 for GATE compatibility
## mode...
set ::CDM::ComponentMode(creole_EBrill) 0

#
# End of File
#
