#define CTRACE 1
#include <stdarg.h>
static void u_ct_(char *, int, ...);
#line 1 "contextual-rule-learn.c"
/*  Copyright @ 1993 MIT and University of Pennsylvania*/
/* Written by Eric Brill */

#include <stdio.h>
#line 4 "contextual-rule-learn.c"

#include <fcntl.h>
#line 5 "contextual-rule-learn.c"

#include <string.h>
#line 6 "contextual-rule-learn.c"

#include <malloc.h>
#line 7 "contextual-rule-learn.c"

#include <unistd.h>
#line 8 "contextual-rule-learn.c"

#include "lex.h"
#line 9 "contextual-rule-learn.c"

#include "darray.h"
#line 10 "contextual-rule-learn.c"

#include "registry.h"
#line 11 "contextual-rule-learn.c"

#include "memory.h"
#line 12 "contextual-rule-learn.c"

#include "useful.h"
#line 13 "contextual-rule-learn.c"


#define THRESHOLD 2  /* SPECIFY THE THRESHOLD FOR LEARNING.  WHEN NO RULES */
#line 15 "contextual-rule-learn.c"

		     /* CAN BE FOUND WHOSE IMPROVEMENT IS GREATER THAN THE */
		     /* THRESHOLD, LEARNING STOPS */

/* NUMTAGS and NUMWDS are (roughly) guesses of the max number of words
   or tags that could appear to the right of a particular tag */

#define NUMTAGS 100  
#line 22 "contextual-rule-learn.c"

#define NUMWDS  300
#line 23 "contextual-rule-learn.c"



void implement_change();
char staart[] = "STAART";
char **correct_tag_corpus,**word_corpus,**guess_tag_corpus;
int correct_tag_corpus_index,word_corpus_index,guess_tag_corpus_index;
int localbest;
char localbestthing[100];
char *wrong,*right;
char *tempforcreate;

/*    argv 0 = correct
           1 = guess
	   2 = file for rules
	   3 = lexicon file from lexical rule corpus
*/
/********************************************************************/
void increment_array(thehash,thestr) 
     Registry *thehash;
     char  *thestr;
{
  int *numforhash;

char *_ct;t_ct_("\n 41 increment_array(thehash,thestr)"); t_ct_("\n 48   if ((numforhash = (int *)Registry_get(*thehash,thestr)) != NULL)"); 
  if (((numforhash = (int *)Registry_get((u_ct_("  /* *thehash",sizeof(*thehash),*thehash), *thehash),(u_ct_("  /* thestr",sizeof(thestr),thestr), thestr)), u_ct_("  /* numforhash",sizeof(numforhash),numforhash), numforhash)) != NULL){ {t_ct_(" {"); t_ct_("\n 49     (*numforhash)++;"); 
    ((*numforhash)++, u_ct_("    /* (*numforhash)",sizeof((*numforhash)),(*numforhash)), (*numforhash)-1); t_ct_("\n 50   }"); 
  }}
  else{t_ct_("\n 51   else");  {t_ct_(" {"); t_ct_("\n 52     numforhash = (int *)malloc(sizeof(int));"); 
    (numforhash = (int *)malloc(sizeof(int)), u_ct_("    /* numforhash",sizeof(numforhash),numforhash), numforhash);t_ct_("\n 53     *numforhash = 1;"); 
    (*numforhash = 1, u_ct_("    /* *numforhash",sizeof(*numforhash),*numforhash), *numforhash);t_ct_("\n 54     Registry_add(*thehash,thestr, (int *)numforhash);"); 
    Registry_add((u_ct_("    /* *thehash",sizeof(*thehash),*thehash), *thehash),(u_ct_("    /* thestr",sizeof(thestr),thestr), thestr), (u_ct_("    /* (int *)numforhash",sizeof((int *)numforhash),(int *)numforhash), (int *)numforhash)); t_ct_("\n 55   }"); 
  }}t_ct_("\n    /* return */"); 
}
/***********************************************************************/
void increment_array_create(thehash,thestr)
     Registry *thehash;
     char  *thestr;
{
  int *numforhash;

char *_ct;t_ct_("\n 58 increment_array_create(thehash,thestr)"); t_ct_("\n 65   if ((numforhash = (int *)Registry_get(*thehash,thestr)) != NULL)"); 
  if (((numforhash = (int *)Registry_get((u_ct_("  /* *thehash",sizeof(*thehash),*thehash), *thehash),(u_ct_("  /* thestr",sizeof(thestr),thestr), thestr)), u_ct_("  /* numforhash",sizeof(numforhash),numforhash), numforhash)) != NULL){ {t_ct_(" {"); t_ct_("\n 66     (*numforhash)++;"); 
    ((*numforhash)++, u_ct_("    /* (*numforhash)",sizeof((*numforhash)),(*numforhash)), (*numforhash)-1); t_ct_("\n 67   }"); 
  }}
  else{t_ct_("\n 68   else");  {t_ct_(" {"); t_ct_("\n 69     numforhash = (int *)malloc(sizeof(int));"); 
    (numforhash = (int *)malloc(sizeof(int)), u_ct_("    /* numforhash",sizeof(numforhash),numforhash), numforhash);t_ct_("\n 70     *numforhash = 1;"); 
    (*numforhash = 1, u_ct_("    /* *numforhash",sizeof(*numforhash),*numforhash), *numforhash);t_ct_("\n 71     tempforcreate = malloc((1+strlen(thestr))*sizeof(char));"); 
    (tempforcreate = malloc((1+(strlen((s_ct_("    /* thestr",thestr), thestr)), u_ct_("    /* strlen(thestr)",sizeof(strlen(thestr)),strlen(thestr)), strlen(thestr)))*sizeof(char)), u_ct_("    /* tempforcreate",sizeof(tempforcreate),tempforcreate), tempforcreate);t_ct_("\n 72     strcpy(tempforcreate,thestr);"); 
    (strcpy(tempforcreate,(s_ct_("    /* thestr",thestr), thestr)), s_ct_("    /* tempforcreate",tempforcreate), tempforcreate);t_ct_("\n 73     Registry_add(*thehash,tempforcreate,(int *)numforhash);"); 
    Registry_add((u_ct_("    /* *thehash",sizeof(*thehash),*thehash), *thehash),(u_ct_("    /* tempforcreate",sizeof(tempforcreate),tempforcreate), tempforcreate),(u_ct_("    /* (int *)numforhash",sizeof((int *)numforhash),(int *)numforhash), (int *)numforhash)); t_ct_("\n 74   }"); 
  }}t_ct_("\n    /* return */"); 
}
/***********************************************************************/
/********************************************************************/
void decrement_array(thehash,thestr)
     Registry *thehash;
     char  *thestr;
{
  int *numforhash;

char *_ct;t_ct_("\n 78 decrement_array(thehash,thestr)"); t_ct_("\n 85   if ((numforhash = (int *)Registry_get(*thehash,thestr)) != NULL)"); 
  if (((numforhash = (int *)Registry_get((u_ct_("  /* *thehash",sizeof(*thehash),*thehash), *thehash),(u_ct_("  /* thestr",sizeof(thestr),thestr), thestr)), u_ct_("  /* numforhash",sizeof(numforhash),numforhash), numforhash)) != NULL){ {t_ct_(" {"); t_ct_("\n 86     (*numforhash)--;"); 
    ((*numforhash)--, u_ct_("    /* (*numforhash)",sizeof((*numforhash)),(*numforhash)), (*numforhash)+1); t_ct_("\n 87   }"); 
  }}
  else{t_ct_("\n 88   else");  {t_ct_(" {"); t_ct_("\n 89     numforhash = (int *)malloc(sizeof(int));"); 
    (numforhash = (int *)malloc(sizeof(int)), u_ct_("    /* numforhash",sizeof(numforhash),numforhash), numforhash);t_ct_("\n 90     *numforhash = -1;"); 
    (*numforhash = -1, u_ct_("    /* *numforhash",sizeof(*numforhash),*numforhash), *numforhash);t_ct_("\n 91     Registry_add(*thehash,thestr, (int *)numforhash);"); 
    Registry_add((u_ct_("    /* *thehash",sizeof(*thehash),*thehash), *thehash),(u_ct_("    /* thestr",sizeof(thestr),thestr), thestr), (u_ct_("    /* (int *)numforhash",sizeof((int *)numforhash),(int *)numforhash), (int *)numforhash)); t_ct_("\n 92   }"); 
  }}t_ct_("\n    /* return */"); 
}
/***********************************************************************/
void decrement_array_create(thehash,thestr)
     Registry *thehash;
     char  *thestr;
{
  int *numforhash;

char *_ct;t_ct_("\n 95 decrement_array_create(thehash,thestr)"); t_ct_("\n102   if ((numforhash = (int *)Registry_get(*thehash,thestr)) != NULL)"); 
  if (((numforhash = (int *)Registry_get((u_ct_("  /* *thehash",sizeof(*thehash),*thehash), *thehash),(u_ct_("  /* thestr",sizeof(thestr),thestr), thestr)), u_ct_("  /* numforhash",sizeof(numforhash),numforhash), numforhash)) != NULL){ {t_ct_(" {"); t_ct_("\n103     (*numforhash)--;"); 
    ((*numforhash)--, u_ct_("    /* (*numforhash)",sizeof((*numforhash)),(*numforhash)), (*numforhash)+1); t_ct_("\n104   }"); 
  }}
  else{t_ct_("\n105   else");  {t_ct_(" {"); t_ct_("\n106     numforhash = (int *)malloc(sizeof(int));"); 
    (numforhash = (int *)malloc(sizeof(int)), u_ct_("    /* numforhash",sizeof(numforhash),numforhash), numforhash);t_ct_("\n107     *numforhash = -1;"); 
    (*numforhash = -1, u_ct_("    /* *numforhash",sizeof(*numforhash),*numforhash), *numforhash);t_ct_("\n108     tempforcreate = malloc((1+strlen(thestr))*sizeof(char));"); 
    (tempforcreate = malloc((1+(strlen((s_ct_("    /* thestr",thestr), thestr)), u_ct_("    /* strlen(thestr)",sizeof(strlen(thestr)),strlen(thestr)), strlen(thestr)))*sizeof(char)), u_ct_("    /* tempforcreate",sizeof(tempforcreate),tempforcreate), tempforcreate);t_ct_("\n109     strcpy(tempforcreate,thestr);"); 
    (strcpy(tempforcreate,(s_ct_("    /* thestr",thestr), thestr)), s_ct_("    /* tempforcreate",tempforcreate), tempforcreate);t_ct_("\n110     Registry_add(*thehash,tempforcreate,(int *)numforhash);"); 
    Registry_add((u_ct_("    /* *thehash",sizeof(*thehash),*thehash), *thehash),(u_ct_("    /* tempforcreate",sizeof(tempforcreate),tempforcreate), tempforcreate),(u_ct_("    /* (int *)numforhash",sizeof((int *)numforhash),(int *)numforhash), (int *)numforhash)); t_ct_("\n111   }"); 
  }}t_ct_("\n    /* return */"); 
}
/***********************************************************************/
void check_counts(goodhash,label)
     Registry *goodhash;
     char *label;
{
  Darray tempkey,tempval;
  int tempcount,*hashtempstr,hashtempval,tempbest;
  int FREEFLAG;
  char *_ct;t_ct_("\n114 check_counts(goodhash,label)"); t_ct_("\n122   FREEFLAG = 0;"); 
  (FREEFLAG = 0, u_ct_("  /* FREEFLAG",sizeof(FREEFLAG),FREEFLAG), FREEFLAG);
t_ct_("\n124   if (strcmp(label,\"PREVBIGRAM\") == 0 ||\n      strcmp(label,\"NEXTBIGRAM\") == 0 ||\n      strcmp(label,\"WDPREVTAG\") == 0 ||\n      strcmp(label,\"WDNEXTTAG\") == 0 ||\n      strcmp(label,\"WDAND2AFT\") == 0 ||\n      strcmp(label,\"WDAND2BFR\") == 0 ||\n      strcmp(label,\"WDAND2TAGAFT\") == 0 ||\n      strcmp(label,\"WDAND2TAGBFR\") == 0 ||\n      strcmp(label,\"RBIGRAM\") == 0 ||\n      strcmp(label,\"LBIGRAM\") == 0 ||\n      strcmp(label,\"SURROUNDTAG\") == 0)"); 
  if ((strcmp((s_ct_("  /* label",label), label),"PREVBIGRAM"), u_ct_("  /* strcmp(label,\"PREVBIGRAM\")",sizeof(strcmp(label,"PREVBIGRAM")),strcmp(label,"PREVBIGRAM")), strcmp(label,"PREVBIGRAM")) == 0 ||
      (strcmp((s_ct_("  /* label",label), label),"NEXTBIGRAM"), u_ct_("  /* strcmp(label,\"NEXTBIGRAM\")",sizeof(strcmp(label,"NEXTBIGRAM")),strcmp(label,"NEXTBIGRAM")), strcmp(label,"NEXTBIGRAM")) == 0 ||
      (strcmp((s_ct_("  /* label",label), label),"WDPREVTAG"), u_ct_("  /* strcmp(label,\"WDPREVTAG\")",sizeof(strcmp(label,"WDPREVTAG")),strcmp(label,"WDPREVTAG")), strcmp(label,"WDPREVTAG")) == 0 ||
      (strcmp((s_ct_("  /* label",label), label),"WDNEXTTAG"), u_ct_("  /* strcmp(label,\"WDNEXTTAG\")",sizeof(strcmp(label,"WDNEXTTAG")),strcmp(label,"WDNEXTTAG")), strcmp(label,"WDNEXTTAG")) == 0 ||
      (strcmp((s_ct_("  /* label",label), label),"WDAND2AFT"), u_ct_("  /* strcmp(label,\"WDAND2AFT\")",sizeof(strcmp(label,"WDAND2AFT")),strcmp(label,"WDAND2AFT")), strcmp(label,"WDAND2AFT")) == 0 ||
      strcmp(label,"WDAND2BFR") == 0 ||
      strcmp(label,"WDAND2TAGAFT") == 0 ||
      strcmp(label,"WDAND2TAGBFR") == 0 ||
      strcmp(label,"RBIGRAM") == 0 ||
      strcmp(label,"LBIGRAM") == 0 ||
      strcmp(label,"SURROUNDTAG") == 0){ t_ct_("\n135     FREEFLAG = 1;"); 
    (FREEFLAG = 1, u_ct_("    /* FREEFLAG",sizeof(FREEFLAG),FREEFLAG), FREEFLAG);}
t_ct_("\n137   tempkey = Darray_create();"); 
  (tempkey = Darray_create(), u_ct_("  /* tempkey",sizeof(tempkey),tempkey), tempkey);t_ct_("\n138   Darray_hint(tempkey,10,Registry_entry_count(*goodhash));"); 
  Darray_hint((u_ct_("  /* tempkey",sizeof(tempkey),tempkey), tempkey),10,Registry_entry_count((u_ct_("  /* *goodhash",sizeof(*goodhash),*goodhash), *goodhash)));t_ct_("\n139   tempval = Darray_create();"); 
  (tempval = Darray_create(), u_ct_("  /* tempval",sizeof(tempval),tempval), tempval);t_ct_("\n140   Darray_hint(tempval,10,Registry_entry_count(*goodhash));"); 
  Darray_hint((u_ct_("  /* tempval",sizeof(tempval),tempval), tempval),10,Registry_entry_count((u_ct_("  /* *goodhash",sizeof(*goodhash),*goodhash), *goodhash)));
t_ct_("\n142   Registry_fetch_contents(*goodhash,tempkey,tempval);"); 
  Registry_fetch_contents((u_ct_("  /* *goodhash",sizeof(*goodhash),*goodhash), *goodhash),(u_ct_("  /* tempkey",sizeof(tempkey),tempkey), tempkey),(u_ct_("  /* tempval",sizeof(tempval),tempval), tempval));t_ct_("\n143   for (tempcount=0;tempcount<Darray_len(tempkey);++tempcount)"); 
  for ((tempcount=0, u_ct_("  /* tempcount",sizeof(tempcount),tempcount), tempcount);(u_ct_("  /* tempcount",sizeof(tempcount),tempcount), tempcount)<Darray_len((u_ct_("  /* tempkey",sizeof(tempkey),tempkey), tempkey));t_ct_("\n143   for (tempcount=0;tempcount<Darray_len(tempkey);++tempcount)"),(++tempcount, u_ct_("  /* tempcount",sizeof(tempcount),tempcount), tempcount)){ {t_ct_(" {"); t_ct_("\n144     if ( (tempbest = *(int *)Darray_get(tempval,tempcount)) > localbest)"); 
    if ( ((tempbest = *(int *)Darray_get((u_ct_("    /* tempval",sizeof(tempval),tempval), tempval),(u_ct_("    /* tempcount",sizeof(tempcount),tempcount), tempcount)), u_ct_("    /* tempbest",sizeof(tempbest),tempbest), tempbest)) > (u_ct_("    /* localbest",sizeof(localbest),localbest), localbest)){ {t_ct_(" {"); t_ct_("\n145       localbest = tempbest;"); 
      (localbest = (tempbest, u_ct_("      /* tempbest",sizeof(tempbest),tempbest), tempbest), u_ct_("      /* localbest",sizeof(localbest),localbest), localbest);t_ct_("\n146       sprintf(localbestthing,\"%s %s %s %s\",wrong,right,label,Darray_get(tempkey,tempcount));"); 
      sprintf((u_ct_("      /* localbestthing",sizeof(localbestthing),localbestthing), localbestthing),"%s %s %s %s",(u_ct_("      /* wrong",sizeof(wrong),wrong), wrong),(u_ct_("      /* right",sizeof(right),right), right),(u_ct_("      /* label",sizeof(label),label), label),Darray_get((u_ct_("      /* tempkey",sizeof(tempkey),tempkey), tempkey),(u_ct_("      /* tempcount",sizeof(tempcount),tempcount), tempcount))); t_ct_("\n147     }"); 
    }}t_ct_("\n148     free(Darray_get(tempval,tempcount));"); 
    free(Darray_get((u_ct_("    /* tempval",sizeof(tempval),tempval), tempval),(u_ct_("    /* tempcount",sizeof(tempcount),tempcount), tempcount)));t_ct_("\n149     if (FREEFLAG)"); 
    if ((u_ct_("    /* FREEFLAG",sizeof(FREEFLAG),FREEFLAG), FREEFLAG)){t_ct_("\n150       free(Darray_get(tempkey,tempcount));"); 
      free(Darray_get((u_ct_("      /* tempkey",sizeof(tempkey),tempkey), tempkey),(u_ct_("      /* tempcount",sizeof(tempcount),tempcount), tempcount)));}t_ct_("\n151   }"); 
  }}t_ct_("\n152   Darray_destroy(tempval);"); 
  Darray_destroy((u_ct_("  /* tempval",sizeof(tempval),tempval), tempval));t_ct_("\n153   Darray_destroy(tempkey);"); 
  Darray_destroy((u_ct_("  /* tempkey",sizeof(tempkey),tempkey), tempkey));t_ct_("\n154   Registry_destroy(*goodhash);"); 
  Registry_destroy((u_ct_("  /* *goodhash",sizeof(*goodhash),*goodhash), *goodhash));t_ct_("\n    /* return */"); 
}

/**********************************************************************/

void init_hash(thehash,numhint)
     Registry *thehash;
     int numhint;
{char *_ct;t_ct_("\n159 init_hash(thehash,numhint)"); t_ct_("\n163   *thehash =  Registry_create(Registry_strcmp,Registry_strhash);"); 
  (*thehash =  Registry_create((u_ct_("  /* Registry_strcmp",sizeof(Registry_strcmp),Registry_strcmp), Registry_strcmp),(u_ct_("  /* Registry_strhash",sizeof(Registry_strhash),Registry_strhash), Registry_strhash)), u_ct_("  /* *thehash",sizeof(*thehash),*thehash), *thehash);t_ct_("\n164   Registry_size_hint(*thehash,numhint);"); 
  Registry_size_hint((u_ct_("  /* *thehash",sizeof(*thehash),*thehash), *thehash),(u_ct_("  /* numhint",sizeof(numhint),numhint), numhint));t_ct_("\n    /* return */"); 
}
/***********************************************************************/


main(argc, argv)

     int             argc;
     char           *argv[];
{



Darray errorlist,temperrorkey,temperrorval;
Registry errorlistcount,SEENTAGGING,WORDS;

FILE *correct_file, *guess_file, *error_list,*correct_out;
char line[5000];  /* input line buffer */
char **split_ptr,**split_ptr2;

char tempfile1[128],tempfile2[128];


char wdpair[1024],*wdpair2;
char *tempstr,*tempstr2;
int CONTINUE = 10000;
int count,count2,count3,numwrong,lengthcount;
char globalprint[500];
char systemcall[900];
char forpasting[500];
int globalbest = 0;
char flag[20];
Registry curwd,wdand2aft,wdand2bfr;
Registry wdand2tagaft,wdand2tagbfr;
Registry wdnexttag,wdprevtag;
Registry rbigram,lbigram;
Registry next1tag,prev1tag;
Registry next1or2tag,prev1or2tag;
Registry next1or2or3tag,prev1or2or3tag;
Registry next1wd,prev1wd;
Registry next1or2wd,prev1or2wd;
Registry nextbigram,prevbigram;
Registry surroundtag;
Registry next2tag,prev2tag;
Registry next2wd,prev2wd;
int printscore;
FILE *allowedmovefile;
char **perl_split_ptr,**perl_split_ptr2,*atempstr,atempstr2[1024];
char space[500];
char onewdbfr[512],onewdaft[512];
char onetagbfr[512],twotagbfr[512],onetagaft[512],twotagaft[512];
int linenums,tagnums;
int words_in_good,words_in_bad;
char *_ct;t_ct_("\n169 main(argc, argv)"); t_ct_("\n218 linenums=tagnums=0;"); 
(linenums=(tagnums=0, u_ct_("/* tagnums",sizeof(tagnums),tagnums), tagnums), u_ct_("/* linenums",sizeof(linenums),linenums), linenums); /* used to count number of words/tags in lexicon, for */
		    /* sizing the associative arrays */
t_ct_("\n221 words_in_bad = words_in_good = 0;"); 
(words_in_bad = (words_in_good = 0, u_ct_("/* words_in_good",sizeof(words_in_good),words_in_good), words_in_good), u_ct_("/* words_in_bad",sizeof(words_in_bad),words_in_bad), words_in_bad);

t_ct_("\n224 tmpnam(tempfile1);"); 
tmpnam((u_ct_("/* tempfile1",sizeof(tempfile1),tempfile1), tempfile1));t_ct_("\n225 tmpnam(tempfile2);"); 
tmpnam((u_ct_("/* tempfile2",sizeof(tempfile2),tempfile2), tempfile2));


/* just count number of words,tags for sizing arrays */t_ct_("\n229 allowedmovefile = fopen(argv[4],\"r\");"); 
(allowedmovefile = fopen((u_ct_("/* argv[4]",sizeof(argv[4]),argv[4]), argv[4]),"r"), u_ct_("/* allowedmovefile",sizeof(allowedmovefile),allowedmovefile), allowedmovefile);
while(fgets(line,sizeof(line),allowedmovefile) != NULL) {
  if (not_just_blank(line)) {
    ++linenums;t_ct_("\n233     line[strlen(line) - 1] = '\\0';"); 
    (line[(strlen((s_ct_("    /* line",line), line)), u_ct_("    /* strlen(line)",sizeof(strlen(line)),strlen(line)), strlen(line)) - 1] = '\0', u_ct_("    /* line[strlen(line) - 1]",sizeof(line[strlen(line) - 1]),line[strlen(line) - 1]), line[strlen(line) - 1]);t_ct_("\n234     tagnums += num_words(line);"); 
    (tagnums += num_words((u_ct_("    /* line",sizeof(line),line), line)), u_ct_("    /* tagnums",sizeof(tagnums),tagnums), tagnums);t_ct_("\n    /* return */"); 
  }
}
fclose(allowedmovefile);

/*SEENTAGGING is a hash table of word/tag pairs, from the lexicon*/
SEENTAGGING = Registry_create(Registry_strcmp,Registry_strhash);
Registry_size_hint(SEENTAGGING,tagnums);
/* WORDS is a hash table of all words in the lexicon */
WORDS = Registry_create(Registry_strcmp,Registry_strhash);
Registry_size_hint(WORDS,linenums);

allowedmovefile = fopen(argv[4], "r"); /* read in the lexicon to record all */
				       /* tags seen with all words in the */
				       /* lexicon */
while(fgets(line,sizeof(line),allowedmovefile) != NULL) {
  if (not_just_blank(line)) {
    line[strlen(line) - 1] = '\0';
    perl_split_ptr = perl_split(line);
    perl_split_ptr2 = perl_split_ptr;
    ++perl_split_ptr;
    atempstr= mystrdup(*perl_split_ptr2);
    Registry_add(WORDS,atempstr,(char *)1);
    while(*perl_split_ptr != NULL) {
      sprintf(space,"%s %s",*perl_split_ptr2,
	      *perl_split_ptr);
      atempstr=mystrdup(space);
      Registry_add(SEENTAGGING,atempstr,(char *)1);
      ++perl_split_ptr; }
    free(*perl_split_ptr2);
    free(perl_split_ptr2);
  }
}
fclose(allowedmovefile);

/* read through the gold standard once just for sizing array */
correct_file = fopen(argv[1],"r");
while(fgets(line,sizeof(line),correct_file) != NULL) {
  if (not_just_blank(line)) {
    line[strlen(line) - 1] = '\0';
    words_in_good += 2; /* add two start of sent tokens */
    words_in_good += num_words(line) + 1;
  }
}
fclose(correct_file);


correct_tag_corpus = (char **)malloc(sizeof(char *) * words_in_good);
word_corpus = (char **)malloc(sizeof(char *) * words_in_good);

/* read in the manually tagged gold standard corpus*/
correct_file = fopen(argv[1],"r");
correct_tag_corpus_index = 0;
word_corpus_index = 0;
printf("Petasis 2 OK\n");
while(fgets(line,sizeof(line),correct_file) != NULL) {
  if (not_just_blank(line)) {
    correct_tag_corpus[correct_tag_corpus_index++] = staart;
    correct_tag_corpus[correct_tag_corpus_index++] = staart;
    word_corpus[word_corpus_index++] = staart;
    word_corpus[word_corpus_index++] = staart;
    line[strlen(line)-1] = '\0';
    split_ptr = perl_split_independent(line);
    perl_split_ptr2 = split_ptr;
    while (*split_ptr != NULL) {
      word_corpus[word_corpus_index++] = *split_ptr;
      /*Darray_addh(word_corpus,*split_ptr);*/
      /*  while ((*(++*split_ptr)) != '/') { }*/
      *split_ptr = strrchr(*split_ptr,'/');
      **split_ptr = '\0';
      correct_tag_corpus[correct_tag_corpus_index++] = ++*split_ptr;
      /*Darray_addh(correct_tag_corpus,++*split_ptr);*/
      ++split_ptr;
    }
    free(perl_split_ptr2);
  }
}
fclose(correct_file);
printf("Petasis 3 OK\n");
printf("READ IN CORRECT FILE\n");

/* read through dummy-tagged file once to size an array*/
guess_file = fopen(argv[2],"r");
while(fgets(line,sizeof(line),guess_file) != NULL) {
  if (not_just_blank(line)) {
    line[strlen(line) - 1] = '\0';
    words_in_bad += 2; /* add two start of sent tokens */
    words_in_bad += num_words(line) + 1;
  }
}
fclose(guess_file);

/* the gold standard and the dummy-tagged corpus had better have the same
   number of words */
if (words_in_good != words_in_bad) {
  printf("%s and %s do not have the same number of words\n",argv[1],argv[2]);
  exit(0);/* read in the guess corpus*/
}
  

  guess_tag_corpus = (char **)malloc(sizeof(char *) * words_in_bad);
  guess_file  = fopen(argv[2],"r"); /* read in our guess-tag corpus */
  guess_tag_corpus_index = 0;
  while(fgets(line,sizeof(line),guess_file) != NULL) {
    if (not_just_blank(line)) { 
      guess_tag_corpus[guess_tag_corpus_index++] = staart;
      guess_tag_corpus[guess_tag_corpus_index++] = staart;
      line[strlen(line)-1] = '\0';
      split_ptr = perl_split_independent(line); 
      split_ptr2 = split_ptr;
      while (*split_ptr != NULL) {
	tempstr = strrchr(*split_ptr,'/');
	tempstr++;
	tempstr2  = mystrdup(tempstr);
	guess_tag_corpus[guess_tag_corpus_index++] = tempstr2;
	free(*split_ptr);
	++split_ptr;
      }
      free(split_ptr2);
    }
  }
  fclose(guess_file);

printf("READ IN BAD FILE\n");


/* this is the rule learning loop.
				 we continue learning rules until the score
				 of the best rule found drops below the
				 THRESHOLD *//* generate and sort confusion matrix ( tag x confused for tag y 
   with count z */
while(CONTINUE > THRESHOLD) { 


  printf("\n");
  printf("==========BEGINNING A LEARNING ITERATION===========\n");
  errorlist = Darray_create();
  Darray_hint(errorlist,10,500);
  temperrorkey = Darray_create();
  temperrorval = Darray_create();
  Darray_hint(temperrorkey,10,500);
  Darray_hint(temperrorval,10,500);

  init_hash(&errorlistcount,500);


  printscore=0;
  for(count=0;count<guess_tag_corpus_index;++count) {
    if
      (strcmp(guess_tag_corpus[count],correct_tag_corpus[count]) 
        != 0) { 
	++printscore; 
	sprintf(forpasting,"%s %s",guess_tag_corpus[count],
		                       correct_tag_corpus[count]);
	increment_array_create(&errorlistcount,forpasting);
      } 
  }

  error_list = fopen(tempfile1,"a");
  Registry_fetch_contents(errorlistcount,temperrorkey,temperrorval);  
  for (count=0;count<Darray_len(temperrorkey);++count) {
    if (*(int *)Darray_get(temperrorval,count) > THRESHOLD)
      fprintf(error_list,"%d %s\n",*(int *)Darray_get(temperrorval,count),
	                    Darray_get(temperrorkey,count));
    free(Darray_get(temperrorval,count));
    free(Darray_get(temperrorkey,count));
  }
  fclose(error_list);
  Darray_destroy(temperrorval);
  Darray_destroy(temperrorkey);
  Registry_destroy(errorlistcount);

  printf("NUMBER OF ERRORS: %d\n",printscore);

/* DUMB DUMB DUMB*/
  sprintf(systemcall,"cat %s | sort -rn > %s",tempfile1,tempfile2);
  printf("Petasis 1: Executing\n%s\n",systemcall);
  system(systemcall);
  sprintf(systemcall,"mv %s %s",tempfile2,tempfile1);
  printf("Petasis 2: Executing\n%s\n",systemcall);
  system(systemcall);
  
  error_list = fopen(tempfile1,"r");
  while(fgets(line,sizeof(line),error_list) != NULL) {
    line[strlen(line)-1] = '\0';
    tempstr = mystrdup(line);
    Darray_addh(errorlist,tempstr); 
  }
  fclose(error_list);
  sprintf(systemcall,"/bin/rm %s",tempfile1);
  printf("Petasis 3: Executing\n%s\n",systemcall);
  system(systemcall);

  globalbest= 0;
  strcpy(globalprint,"");
  
  /* for each pair of tags in the confusion matrix . . .*/
  for (count=0;count<Darray_len(errorlist);++count) {

    localbest =0;
    strcpy(localbestthing,"");

    split_ptr = perl_split_independent(Darray_get(errorlist,count));

    wrong = split_ptr[1]; /* this is the bad tag in the confusion matrix */
    right = split_ptr[2]; /* this is the good tag */
    numwrong = atoi(split_ptr[0]); /* this is the number of confusions */
    if (numwrong > globalbest) {
      
      printf("From confusion matrix, tagged as: %s should be: %s\n",wrong,right);
      printf("Best rule found for this iteration so far: %d %s\n",globalbest,globalprint);
      init_hash(&curwd,NUMWDS/2);
      init_hash(&wdand2aft,(NUMWDS*NUMWDS)/4);
      init_hash(&wdand2bfr,(NUMWDS*NUMWDS)/4);
      init_hash(&wdand2tagaft,(NUMWDS*NUMTAGS)/4);
      init_hash(&wdand2tagbfr,(NUMWDS*NUMTAGS)/4);
      init_hash(&rbigram,(NUMWDS*NUMWDS)/4);
      init_hash(&lbigram,(NUMWDS*NUMWDS)/4);
      init_hash(&wdnexttag,(NUMWDS*NUMTAGS)/4);
      init_hash(&wdprevtag,(NUMWDS*NUMTAGS)/4);
      init_hash(&next1tag,NUMTAGS/2);
      init_hash(&prev1tag,NUMTAGS/2);
      init_hash(&next1or2tag,NUMTAGS/2);
      init_hash(&prev1or2tag,NUMTAGS/2);
      init_hash(&next1wd,NUMWDS/2);
      init_hash(&prev1wd,NUMWDS/2);
      init_hash(&next1or2wd,NUMWDS/2);
      init_hash(&prev1or2wd,NUMWDS/2);
      init_hash(&next1or2or3tag,NUMTAGS/2);
      init_hash(&prev1or2or3tag,NUMTAGS/2);
      init_hash(&nextbigram,NUMTAGS);
      init_hash(&prevbigram,NUMTAGS);
      init_hash(&surroundtag,NUMTAGS);
      init_hash(&next2tag,NUMTAGS/2);
      init_hash(&prev2tag,NUMTAGS/2);
      init_hash(&next2wd,NUMWDS/2);
      init_hash(&prev2wd,NUMWDS/2);

/* a proposed transformation tag X --> tag Y can have 3 outcomes.
   if neither X nor Y is the correct tag, then the transformation
   has no effect.  If X is correct, then the change is detremental.
   if Y is correct, then it is a good change. */

      lengthcount = correct_tag_corpus_index;
      for(count2=0;count2<lengthcount;++count2){
	sprintf(atempstr2,"%s %s",word_corpus[count2],right);
	if (Registry_get(WORDS,word_corpus[count2]) &&
	    ! Registry_get(SEENTAGGING,atempstr2)) 
	  strcpy(flag,"NOMATCH");
	else if (strcmp(guess_tag_corpus[count2],wrong) == 0 &&
	    strcmp(correct_tag_corpus[count2],right) == 0 ) 
	  strcpy(flag,"BADMATCH");
	else if (strcmp(guess_tag_corpus[count2],wrong) == 0 &&
	    strcmp(correct_tag_corpus[count2],wrong) == 0 ) 
	  strcpy(flag,"GOODMATCH");
	else 
	  strcpy(flag,"NOMATCH");


/* ok, the terminology is a bit screwed up.  If we have a "BADMATCH", that */
/* means the current tagging is bad, and the transformation will fix it */
/* ( a good thing ) */
	if (strcmp(flag,"BADMATCH") == 0) {
	  increment_array(&curwd,word_corpus[count2]);
	  if (count2 != lengthcount-1) {
	    strcpy(onewdaft,word_corpus[count2+1]);
	    strcpy(onetagaft,guess_tag_corpus[count2+1]);
	    sprintf(wdpair,"%s %s",word_corpus[count2],
		                 word_corpus[count2+1]);
    	    increment_array_create(&rbigram,wdpair);
	    sprintf(wdpair,"%s %s",word_corpus[count2],
		                  guess_tag_corpus[count2+1]);
	    increment_array_create(&wdnexttag,wdpair);
	    increment_array(&next1or2tag,
			    guess_tag_corpus[count2+1]);
	    increment_array(&next1or2or3tag,
			    guess_tag_corpus[count2+1]);
	    increment_array(&next1tag,guess_tag_corpus[count2+1]);
	    increment_array(&next1wd,word_corpus[count2+1]);
	    increment_array(&next1or2wd,word_corpus[count2+1]);
	  }
	  if (count2 < lengthcount-2) {
	    strcpy(twotagaft,guess_tag_corpus[count2+2]);
	    sprintf(forpasting,"%s %s",guess_tag_corpus[count2+1],
		                       guess_tag_corpus[count2+2]);
	    increment_array_create(&nextbigram,forpasting);
	    sprintf(forpasting,"%s %s",word_corpus[count2],
		                       word_corpus[count2+2]);
	    increment_array_create(&wdand2aft,forpasting);
	    sprintf(forpasting,"%s %s",word_corpus[count2],
		                       guess_tag_corpus[count2+2]);
	    increment_array_create(&wdand2tagaft,forpasting);
	    increment_array(&next2tag,guess_tag_corpus[count2+2]);
	    increment_array(&next2wd,word_corpus[count2+2]);
	    if (strcmp(guess_tag_corpus[count2+2],onetagaft) != 0)
	    { 
	      increment_array(&next1or2tag,
			      guess_tag_corpus[count2+2]);
	      increment_array(&next1or2or3tag,
			      guess_tag_corpus[count2+2]);
	    }
	    if (strcmp(word_corpus[count2+2],onewdaft) != 0)
	      increment_array(&next1or2wd,word_corpus[count2+2]);
	  }
	  if (count2 < lengthcount-3) {
	    if (strcmp(guess_tag_corpus[count2+3],onetagaft) != 0
		&&
		strcmp(guess_tag_corpus[count2+3],twotagaft) != 0)
	    increment_array(&next1or2or3tag,
			    guess_tag_corpus[count2+3]);
	  }
	  if (count2 != 0) {
	    strcpy(onewdbfr,word_corpus[count2-1]);
	    strcpy(onetagbfr,guess_tag_corpus[count2-1]);
	    sprintf(wdpair,"%s %s",word_corpus[count2-1],
		                  word_corpus[count2]);
    	    increment_array_create(&lbigram,wdpair);
	    sprintf(wdpair,"%s %s",guess_tag_corpus[count2-1],
		                  word_corpus[count2]);
    	    increment_array_create(&wdprevtag,wdpair);
	    increment_array(&prev1tag,guess_tag_corpus[count2-1]);
	    increment_array(&prev1wd,word_corpus[count2-1]);
	    increment_array(&prev1or2wd,word_corpus[count2-1]);
	    increment_array(&prev1or2tag,
			    guess_tag_corpus[count2-1]);
	    increment_array(&prev1or2or3tag,
			    guess_tag_corpus[count2-1]);
	    if (count2 < lengthcount-1) {
	      sprintf(forpasting,"%s %s",guess_tag_corpus[count2-1],
		                       guess_tag_corpus[count2+1]);
	      increment_array_create(&surroundtag,forpasting);
	    }
	  }
	  if (count2 > 1) {
	    strcpy(twotagbfr,guess_tag_corpus[count2-2]);
	    sprintf(forpasting,"%s %s",guess_tag_corpus[count2-2],
		                       guess_tag_corpus[count2-1]);
	    increment_array_create(&prevbigram,forpasting);
	    sprintf(forpasting,"%s %s",word_corpus[count2-2],
		                       word_corpus[count2]);
	    increment_array_create(&wdand2bfr,forpasting);
	    sprintf(forpasting,"%s %s",guess_tag_corpus[count2-2],
		                       word_corpus[count2]);
	    increment_array_create(&wdand2tagbfr,forpasting);
	    increment_array(&prev2tag,guess_tag_corpus[count2-2]);
	    increment_array(&prev2wd,word_corpus[count2-2]);
	    if (strcmp(guess_tag_corpus[count2-2],onetagbfr) !=
		0){ 
	      increment_array(&prev1or2tag,
			     guess_tag_corpus[count2-2]);
	      increment_array(&prev1or2or3tag,
			      guess_tag_corpus[count2-2]);
	    }
	    if (strcmp(word_corpus[count2-2],onewdbfr) !=
		0)
	      increment_array(&prev1or2wd,word_corpus[count2-2]);
	  }
	  if (count2 > 2) {
	    if (strcmp(guess_tag_corpus[count2-3],onetagbfr) != 0
		&&
		strcmp(guess_tag_corpus[count2-3],twotagbfr) != 0)
	    increment_array(&prev1or2or3tag,
			    guess_tag_corpus[count2-3]);/* this is the case where the current tagging is correct, and therefore the *//* transformation will hurt */
	  }
	}



	else if (strcmp(flag,"GOODMATCH") == 0) {
	  decrement_array(&curwd,word_corpus[count2]);
	  if (count2 != lengthcount-1) {
	    strcpy(onewdaft,word_corpus[count2+1]);
	    strcpy(onetagaft,guess_tag_corpus[count2+1]);
            sprintf(wdpair,"%s %s",word_corpus[count2],
		                  word_corpus[count2+1]);
    	    decrement_array_create(&rbigram,wdpair);
	    sprintf(wdpair,"%s %s",word_corpus[count2],
		                  guess_tag_corpus[count2+1]);
    	    decrement_array_create(&wdnexttag,wdpair);
	    decrement_array(&next1tag,guess_tag_corpus[count2+1]);
	    decrement_array(&next1wd,word_corpus[count2+1]);
	    decrement_array(&next1or2wd,word_corpus[count2+1]);
	    decrement_array(&next1or2tag,
			    guess_tag_corpus[count2+1]);
	    decrement_array(&next1or2or3tag,
			    guess_tag_corpus[count2+1]);
	  }
	  if (count2 < lengthcount-2) {
	    strcpy(twotagaft,guess_tag_corpus[count2+2]);
	    sprintf(forpasting,"%s %s",guess_tag_corpus[count2+1],
		                       guess_tag_corpus[count2+2]);
	    decrement_array_create(&nextbigram,forpasting);
	    sprintf(forpasting,"%s %s",word_corpus[count2],
		                       word_corpus[count2+2]);
	    decrement_array_create(&wdand2aft,forpasting);
	    sprintf(forpasting,"%s %s",word_corpus[count2],
		                       guess_tag_corpus[count2+2]);
	    decrement_array_create(&wdand2tagaft,forpasting);
	    decrement_array(&next2tag,guess_tag_corpus[count2+2]);
	    decrement_array(&next2wd,word_corpus[count2+2]);
	    if (strcmp(guess_tag_corpus[count2+2],onetagaft) !=0) {
	      decrement_array(&next1or2tag,
			      guess_tag_corpus[count2+2]);
	      decrement_array(&next1or2or3tag,
			      guess_tag_corpus[count2+2]); }
	    if (strcmp(word_corpus[count2+2],onewdaft) !=0)
	      decrement_array(&next1or2wd,word_corpus[count2+2]);
	  }
	  if (count2 < lengthcount-3) {
	    if (strcmp(guess_tag_corpus[count2+3],onetagaft) !=0 
		&&
		strcmp(guess_tag_corpus[count2+3],twotagaft) !=0 )
	      decrement_array(&next1or2or3tag,
			      guess_tag_corpus[count2+3]);
	  }
	  if (count2 != 0) {
	    strcpy(onewdbfr,word_corpus[count2-1]);
	    strcpy(onetagbfr,guess_tag_corpus[count2-1]);
	    sprintf(wdpair,"%s %s",word_corpus[count2-1],
		                  word_corpus[count2]);
    	    decrement_array_create(&lbigram,wdpair);
	    sprintf(wdpair,"%s %s",guess_tag_corpus[count2-1],
		                  word_corpus[count2]);
    	    decrement_array_create(&wdprevtag,wdpair);
	    decrement_array(&prev1tag,guess_tag_corpus[count2-1]);
	    decrement_array(&prev1wd,word_corpus[count2-1]);
	    decrement_array(&prev1or2wd,word_corpus[count2-1]);
	    decrement_array(&prev1or2tag,
			    guess_tag_corpus[count2-1]);
	    decrement_array(&prev1or2or3tag,
			    guess_tag_corpus[count2-1]);
	    if (count2 < lengthcount-1) {
	      sprintf(forpasting,"%s %s",guess_tag_corpus[count2-1],
		                       guess_tag_corpus[count2+1]);
	      decrement_array_create(&surroundtag,forpasting);
	    }
	  }
	  if (count2 >1 ) { 
	    strcpy(twotagbfr,guess_tag_corpus[count2-2]);
	    sprintf(forpasting,"%s %s",guess_tag_corpus[count2-2],
		                       guess_tag_corpus[count2-1]);
	    decrement_array_create(&prevbigram,forpasting);
	    sprintf(forpasting,"%s %s",word_corpus[count2-2],
		                       word_corpus[count2]);
	    decrement_array_create(&wdand2bfr,forpasting);
	    sprintf(forpasting,"%s %s",guess_tag_corpus[count2-2],
		                       word_corpus[count2]);
	    decrement_array_create(&wdand2tagbfr,forpasting);
	    decrement_array(&prev2tag,guess_tag_corpus[count2-2]);
	    decrement_array(&prev2wd,word_corpus[count2-2]);
	    if (strcmp(guess_tag_corpus[count2-2],onetagbfr) != 0)
	    { 
	      decrement_array(&prev1or2tag,
			      guess_tag_corpus[count2-2]);
	      decrement_array(&prev1or2or3tag,
			      guess_tag_corpus[count2-2]); }
	    if (strcmp(word_corpus[count2-2],onewdbfr) != 0)
	      decrement_array(&prev1or2wd,word_corpus[count2-2]);
	  }
	  if (count2 > 2) {
	    if (strcmp(guess_tag_corpus[count2-3],onetagbfr) != 0 
		&&
		strcmp(guess_tag_corpus[count2-3],twotagbfr) != 0)
	    decrement_array(&prev1or2or3tag,
			    guess_tag_corpus[count2-3]);/* now we go through all of the contexts we've recorded, and see which *//* contextual trigger provides the biggest win */
	  }
	}
      }  



check_counts(&prev1tag,"PREVTAG");
check_counts(&next1tag,"NEXTTAG");
check_counts(&next1or2tag,"NEXT1OR2TAG");
check_counts(&prev1or2tag,"PREV1OR2TAG");
check_counts(&next1wd,"NEXTWD");
check_counts(&prev1wd,"PREVWD");
check_counts(&rbigram,"RBIGRAM");
check_counts(&lbigram,"LBIGRAM");
check_counts(&wdnexttag,"WDNEXTTAG");
check_counts(&wdprevtag,"WDPREVTAG");
check_counts(&next1or2wd,"NEXT1OR2WD");
check_counts(&prev1or2wd,"PREV1OR2WD");
check_counts(&next1or2or3tag,"NEXT1OR2OR3TAG");
check_counts(&prev1or2or3tag,"PREV1OR2OR3TAG");
check_counts(&prevbigram,"PREVBIGRAM");
check_counts(&nextbigram,"NEXTBIGRAM");
check_counts(&surroundtag,"SURROUNDTAG");
check_counts(&next2tag,"NEXT2TAG");
check_counts(&prev2tag,"PREV2TAG");
check_counts(&next2wd,"NEXT2WD");
check_counts(&prev2wd,"PREV2WD");
check_counts(&curwd,"CURWD");
check_counts(&wdand2aft,"WDAND2AFT");
check_counts(&wdand2bfr,"WDAND2BFR");
check_counts(&wdand2tagaft,"WDAND2TAGAFT");
check_counts(&wdand2tagbfr,"WDAND2TAGBFR");



    if (localbest > globalbest) {
      globalbest = localbest;
      strcpy(globalprint,localbestthing);}
    }
  }
  free(split_ptr[0]);
  free(split_ptr[1]);
  free(split_ptr[2]);
  free(split_ptr);
  for (count=0;count<strlen(globalprint);++count)
    if (*(globalprint+count) == '\'') 
      *(globalprint+count) = '\b'; 
  implement_change(globalprint,guess_tag_corpus,word_corpus,
		   word_corpus_index,&WORDS,&SEENTAGGING);
  for (count=0;count<strlen(globalprint);++count)
    if (*(globalprint+count) == '\b') 
      *(globalprint+count) = '\''; 
  correct_out = fopen(argv[3],"a");
  fprintf(correct_out,"%s\n",globalprint);
  fclose(correct_out);
  CONTINUE = globalbest; 
  for (count=0;count<Darray_len(errorlist);++count)
    free(Darray_get(errorlist,count));
  Darray_destroy(errorlist);
	 /*************  The code below is for updating the corpus by applying
                the learned rule ***************************************/
}
}




void change_the_tag(theentry,thetag,theposition)
  char **theentry, *thetag;
  int theposition;

{{char *_ct;t_ct_("\n256 Registry_add(WORDS,atempstr,(char *)"); }t_ct_("\n771   free(theentry[theposition]);"); 
  free((theentry[(u_ct_("  /* theposition",sizeof(theposition),theposition), theposition)], u_ct_("  /* theentry[theposition]",sizeof(theentry[theposition]),theentry[theposition]), theentry[theposition]));t_ct_("\n772   theentry[theposition] = mystrdup(thetag);"); 
  (theentry[(u_ct_("  /* theposition",sizeof(theposition),theposition), theposition)] = mystrdup((u_ct_("  /* thetag",sizeof(thetag),thetag), thetag)), u_ct_("  /* theentry[theposition]",sizeof(theentry[theposition]),theentry[theposition]), theentry[theposition]);t_ct_("\n    /* return */"); 
}


void implement_change(thearg,thetagcorpus,thewordcorpus,corpuslen,
		 wordreg,seentaggingreg)
char *thearg;
char **thetagcorpus,**thewordcorpus;
int corpuslen;
Registry *wordreg,*seentaggingreg;
{

	char            line[5000];	/* input line buffer */
	char          **split_ptr;
	int             count,tempcount1,tempcount2,ccount;
	char            old[100], *new, when[300], tag[100], lft[100],
	                rght[100], 
	                prev1[100], prev2[100], next1[100], next2[100], 
	                curtag[100],
	                tempstr[300],word[300];
	char **perl_split_ptr,**perl_split_ptr2,*atempstr,atempstr2[256],
	      space[500],curwd[100];
{char *_ct;t_ct_("\n776 implement_change(thearg,thetagcorpus,thewordcorpus,corpuslen,\n\t\t wordreg,seenta"); }t_ct_("\n795 \tstrcpy(line,thearg);"); 
	(strcpy(line,(s_ct_("\t/* thearg",thearg), thearg)), s_ct_("\t/* line",line), line);t_ct_("\n796 \tfor (ccount=0;ccount<strlen(line);++ccount)"); 
	for ((ccount=0, u_ct_("\t/* ccount",sizeof(ccount),ccount), ccount);(u_ct_("\t/* ccount",sizeof(ccount),ccount), ccount)<(strlen((s_ct_("\t/* line",line), line)), u_ct_("\t/* strlen(line)",sizeof(strlen(line)),strlen(line)), strlen(line));t_ct_("\n796 \tfor (ccount=0;ccount<strlen(line);++ccount)"),(++ccount, u_ct_("\t/* ccount",sizeof(ccount),ccount), ccount)){ /*patch for sing quote*/t_ct_("\n797 \t  if (*(line+ccount) == '\\b')"); 
	  if (*((u_ct_("\t  /* line",sizeof(line),line), line)+(u_ct_("\t  /* ccount",sizeof(ccount),ccount), ccount)) == '\b'){ t_ct_("\n798 \t    *(line+ccount) = '\\'';"); 
	    (*((u_ct_("\t    /* line",sizeof(line),line), line)+(u_ct_("\t    /* ccount",sizeof(ccount),ccount), ccount)) = '\'', u_ct_("\t    /* *(line+ccount)",sizeof(*(line+ccount)),*(line+ccount)), *(line+ccount));} }t_ct_("\n799 \tif (strlen(line) > 1)"); 
	if ((strlen((s_ct_("\t/* line",line), line)), u_ct_("\t/* strlen(line)",sizeof(strlen(line)),strlen(line)), strlen(line)) > 1){ {t_ct_(" {"); t_ct_("\n800 \t  split_ptr = perl_split(line);"); 
	  (split_ptr = perl_split((u_ct_("\t  /* line",sizeof(line),line), line)), u_ct_("\t  /* split_ptr",sizeof(split_ptr),split_ptr), split_ptr);t_ct_("\n801 \t  strcpy(old, split_ptr[0]);"); 
	  (strcpy(old, (s_ct_("\t  /* split_ptr[0]",split_ptr[0]), split_ptr[0])), s_ct_("\t  /* old",old), old);t_ct_("\n802 \t  new = mystrdup(split_ptr[1]);"); 
	  (new = mystrdup((u_ct_("\t  /* split_ptr[1]",sizeof(split_ptr[1]),split_ptr[1]), split_ptr[1])), u_ct_("\t  /* new",sizeof(new),new), new);t_ct_("\n803 \t  strcpy(when, split_ptr[2]);"); 
	  (strcpy(when, (s_ct_("\t  /* split_ptr[2]",split_ptr[2]), split_ptr[2])), s_ct_("\t  /* when",when), when);
	  t_ct_("\n805 \t  if (strcmp(when, \"NEXTTAG\") == 0 ||\n\t      strcmp(when, \"NEXT2TAG\") == 0 ||\n\t      strcmp(when, \"NEXT1OR2TAG\") == 0 ||\n\t      strcmp(when, \"NEXT1OR2OR3TAG\") == 0 ||\n\t      strcmp(when, \"PREVTAG\") == 0 ||\n\t      strcmp(when, \"PREV2TAG\") == 0 ||\n\t      strcmp(when, \"PREV1OR2TAG\") == 0 ||\n\t      strcmp(when, \"PREV1OR2OR3TAG\") == 0)"); 
	  if ((strcmp((s_ct_("\t  /* when",when), when), "NEXTTAG"), u_ct_("\t  /* strcmp(when, \"NEXTTAG\")",sizeof(strcmp(when, "NEXTTAG")),strcmp(when, "NEXTTAG")), strcmp(when, "NEXTTAG")) == 0 ||
	      (strcmp((s_ct_("\t  /* when",when), when), "NEXT2TAG"), u_ct_("\t  /* strcmp(when, \"NEXT2TAG\")",sizeof(strcmp(when, "NEXT2TAG")),strcmp(when, "NEXT2TAG")), strcmp(when, "NEXT2TAG")) == 0 ||
	      (strcmp((s_ct_("\t  /* when",when), when), "NEXT1OR2TAG"), u_ct_("\t  /* strcmp(when, \"NEXT1OR2TAG\")",sizeof(strcmp(when, "NEXT1OR2TAG")),strcmp(when, "NEXT1OR2TAG")), strcmp(when, "NEXT1OR2TAG")) == 0 ||
	      (strcmp((s_ct_("\t  /* when",when), when), "NEXT1OR2OR3TAG"), u_ct_("\t  /* strcmp(when, \"NEXT1OR2OR3TAG\")",sizeof(strcmp(when, "NEXT1OR2OR3TAG")),strcmp(when, "NEXT1OR2OR3TAG")), strcmp(when, "NEXT1OR2OR3TAG")) == 0 ||
	      (strcmp((s_ct_("\t  /* when",when), when), "PREVTAG"), u_ct_("\t  /* strcmp(when, \"PREVTAG\")",sizeof(strcmp(when, "PREVTAG")),strcmp(when, "PREVTAG")), strcmp(when, "PREVTAG")) == 0 ||
	      strcmp(when, "PREV2TAG") == 0 ||
	      strcmp(when, "PREV1OR2TAG") == 0 ||
	      strcmp(when, "PREV1OR2OR3TAG") == 0){ {t_ct_(" {"); t_ct_("\n813 \t    strcpy(tag, split_ptr[3]);"); 
	    (strcpy(tag, (s_ct_("\t    /* split_ptr[3]",split_ptr[3]), split_ptr[3])), s_ct_("\t    /* tag",tag), tag);t_ct_("\n814 \t  }"); 
	  }} 
	  else{t_ct_("\n815 \t  else"); t_ct_(" if (strcmp(when, \"NEXTWD\") == 0 ||\n\t\t   strcmp(when,\"CURWD\") == 0 || \n\t\t   strcmp(when, \"NEXT2WD\") == 0 ||\n\t\t   strcmp(when, \"NEXT1OR2WD\") == 0 ||\n\t\t   strcmp(when, \"NEXT1OR2OR3WD\") == 0 ||\n\t\t   strcmp(when, \"PREVWD\") == 0 ||\n\t\t   strcmp(when, \"PREV2WD\") == 0 ||\n\t\t   strcmp(when, \"PREV1OR2WD\") == 0 ||\n\t\t   strcmp(when, \"PREV1OR2OR3WD\") == 0)");  if ((strcmp((s_ct_("\t  /* when",when), when), "NEXTWD"), u_ct_("\t  /* strcmp(when, \"NEXTWD\")",sizeof(strcmp(when, "NEXTWD")),strcmp(when, "NEXTWD")), strcmp(when, "NEXTWD")) == 0 ||
		   (strcmp((s_ct_("\t  /* when",when), when),"CURWD"), u_ct_("\t  /* strcmp(when,\"CURWD\")",sizeof(strcmp(when,"CURWD")),strcmp(when,"CURWD")), strcmp(when,"CURWD")) == 0 || 
		   (strcmp((s_ct_("\t  /* when",when), when), "NEXT2WD"), u_ct_("\t  /* strcmp(when, \"NEXT2WD\")",sizeof(strcmp(when, "NEXT2WD")),strcmp(when, "NEXT2WD")), strcmp(when, "NEXT2WD")) == 0 ||
		   (strcmp((s_ct_("\t  /* when",when), when), "NEXT1OR2WD"), u_ct_("\t  /* strcmp(when, \"NEXT1OR2WD\")",sizeof(strcmp(when, "NEXT1OR2WD")),strcmp(when, "NEXT1OR2WD")), strcmp(when, "NEXT1OR2WD")) == 0 ||
		   (strcmp((s_ct_("\t  /* when",when), when), "NEXT1OR2OR3WD"), u_ct_("\t  /* strcmp(when, \"NEXT1OR2OR3WD\")",sizeof(strcmp(when, "NEXT1OR2OR3WD")),strcmp(when, "NEXT1OR2OR3WD")), strcmp(when, "NEXT1OR2OR3WD")) == 0 ||
		   strcmp(when, "PREVWD") == 0 ||
		   strcmp(when, "PREV2WD") == 0 ||
		   strcmp(when, "PREV1OR2WD") == 0 ||
		   strcmp(when, "PREV1OR2OR3WD") == 0){ {t_ct_(" {"); t_ct_("\n824 \t    strcpy(word, split_ptr[3]);"); 
	    (strcpy(word, (s_ct_("\t    /* split_ptr[3]",split_ptr[3]), split_ptr[3])), s_ct_("\t    /* word",word), word);t_ct_("\n825 \t  }"); 
	  }}
	  else{t_ct_("\n826 \t  else"); t_ct_(" if (strcmp(when, \"SURROUNDTAG\") == 0)");  if ((strcmp((s_ct_("\t  /* when",when), when), "SURROUNDTAG"), u_ct_("\t  /* strcmp(when, \"SURROUNDTAG\")",sizeof(strcmp(when, "SURROUNDTAG")),strcmp(when, "SURROUNDTAG")), strcmp(when, "SURROUNDTAG")) == 0){ {t_ct_(" {"); t_ct_("\n827 \t    strcpy(lft, split_ptr[3]);"); 
	    (strcpy(lft, (s_ct_("\t    /* split_ptr[3]",split_ptr[3]), split_ptr[3])), s_ct_("\t    /* lft",lft), lft);t_ct_("\n828 \t    strcpy(rght, split_ptr[4]);"); 
	    (strcpy(rght, (s_ct_("\t    /* split_ptr[4]",split_ptr[4]), split_ptr[4])), s_ct_("\t    /* rght",rght), rght);t_ct_("\n829 \t  }"); 
	  }} else{t_ct_(" else"); t_ct_(" if (strcmp(when, \"PREVBIGRAM\") == 0)");  if ((strcmp((s_ct_("\t  /* when",when), when), "PREVBIGRAM"), u_ct_("\t  /* strcmp(when, \"PREVBIGRAM\")",sizeof(strcmp(when, "PREVBIGRAM")),strcmp(when, "PREVBIGRAM")), strcmp(when, "PREVBIGRAM")) == 0){ {t_ct_(" {"); t_ct_("\n830 \t    strcpy(prev1, split_ptr[3]);"); 
	    (strcpy(prev1, (s_ct_("\t    /* split_ptr[3]",split_ptr[3]), split_ptr[3])), s_ct_("\t    /* prev1",prev1), prev1);t_ct_("\n831 \t    strcpy(prev2, split_ptr[4]);"); 
	    (strcpy(prev2, (s_ct_("\t    /* split_ptr[4]",split_ptr[4]), split_ptr[4])), s_ct_("\t    /* prev2",prev2), prev2);t_ct_("\n832 \t  }"); 
	  }} else{t_ct_(" else"); t_ct_(" if (strcmp(when, \"NEXTBIGRAM\") == 0)");  if ((strcmp((s_ct_("\t  /* when",when), when), "NEXTBIGRAM"), u_ct_("\t  /* strcmp(when, \"NEXTBIGRAM\")",sizeof(strcmp(when, "NEXTBIGRAM")),strcmp(when, "NEXTBIGRAM")), strcmp(when, "NEXTBIGRAM")) == 0){ {t_ct_(" {"); t_ct_("\n833 \t    strcpy(next1, split_ptr[3]);"); 
	    (strcpy(next1, (s_ct_("\t    /* split_ptr[3]",split_ptr[3]), split_ptr[3])), s_ct_("\t    /* next1",next1), next1);t_ct_("\n834 \t    strcpy(next2, split_ptr[4]);"); 
	    (strcpy(next2, (s_ct_("\t    /* split_ptr[4]",split_ptr[4]), split_ptr[4])), s_ct_("\t    /* next2",next2), next2);t_ct_("\n835 \t  }"); 
	  }} else{t_ct_(" else"); t_ct_(" if (strcmp(when,\"LBIGRAM\") == 0||\n\t\t     strcmp(when,\"WDPREVTAG\") == 0)");  if ((strcmp((s_ct_("\t  /* when",when), when),"LBIGRAM"), u_ct_("\t  /* strcmp(when,\"LBIGRAM\")",sizeof(strcmp(when,"LBIGRAM")),strcmp(when,"LBIGRAM")), strcmp(when,"LBIGRAM")) == 0||
		     (strcmp((s_ct_("\t  /* when",when), when),"WDPREVTAG"), u_ct_("\t  /* strcmp(when,\"WDPREVTAG\")",sizeof(strcmp(when,"WDPREVTAG")),strcmp(when,"WDPREVTAG")), strcmp(when,"WDPREVTAG")) == 0){ {t_ct_(" {"); t_ct_("\n837 \t    strcpy(prev1,split_ptr[3]);"); 
	    (strcpy(prev1,(s_ct_("\t    /* split_ptr[3]",split_ptr[3]), split_ptr[3])), s_ct_("\t    /* prev1",prev1), prev1);t_ct_("\n838 \t    strcpy(word,split_ptr[4]);"); 
	    (strcpy(word,(s_ct_("\t    /* split_ptr[4]",split_ptr[4]), split_ptr[4])), s_ct_("\t    /* word",word), word); t_ct_("\n839 \t  }"); 
	  }} else{t_ct_(" else"); t_ct_(" if (strcmp(when,\"RBIGRAM\") == 0 ||\n\t\t     strcmp(when,\"WDNEXTTAG\") == 0)");  if ((strcmp((s_ct_("\t  /* when",when), when),"RBIGRAM"), u_ct_("\t  /* strcmp(when,\"RBIGRAM\")",sizeof(strcmp(when,"RBIGRAM")),strcmp(when,"RBIGRAM")), strcmp(when,"RBIGRAM")) == 0 ||
		     (strcmp((s_ct_("\t  /* when",when), when),"WDNEXTTAG"), u_ct_("\t  /* strcmp(when,\"WDNEXTTAG\")",sizeof(strcmp(when,"WDNEXTTAG")),strcmp(when,"WDNEXTTAG")), strcmp(when,"WDNEXTTAG")) == 0){ {t_ct_(" {"); t_ct_("\n841 \t    strcpy(word,split_ptr[3]);"); 
	    (strcpy(word,(s_ct_("\t    /* split_ptr[3]",split_ptr[3]), split_ptr[3])), s_ct_("\t    /* word",word), word);t_ct_("\n842 \t    strcpy(next1,split_ptr[4]);"); 
	    (strcpy(next1,(s_ct_("\t    /* split_ptr[4]",split_ptr[4]), split_ptr[4])), s_ct_("\t    /* next1",next1), next1); t_ct_("\n843 \t  }"); 
	  }} else{t_ct_(" else"); t_ct_(" if (strcmp(when,\"WDAND2BFR\")== 0 ||\n\t\t     strcmp(when,\"WDAND2TAGBFR\")== 0)");  if ((strcmp((s_ct_("\t  /* when",when), when),"WDAND2BFR"), u_ct_("\t  /* strcmp(when,\"WDAND2BFR\")",sizeof(strcmp(when,"WDAND2BFR")),strcmp(when,"WDAND2BFR")), strcmp(when,"WDAND2BFR"))== 0 ||
		     (strcmp((s_ct_("\t  /* when",when), when),"WDAND2TAGBFR"), u_ct_("\t  /* strcmp(when,\"WDAND2TAGBFR\")",sizeof(strcmp(when,"WDAND2TAGBFR")),strcmp(when,"WDAND2TAGBFR")), strcmp(when,"WDAND2TAGBFR"))== 0){ {t_ct_(" {"); t_ct_("\n845 \t    strcpy(prev2,split_ptr[3]);"); 
	    (strcpy(prev2,(s_ct_("\t    /* split_ptr[3]",split_ptr[3]), split_ptr[3])), s_ct_("\t    /* prev2",prev2), prev2);t_ct_("\n846 \t    strcpy(word,split_ptr[4]);"); 
	    (strcpy(word,(s_ct_("\t    /* split_ptr[4]",split_ptr[4]), split_ptr[4])), s_ct_("\t    /* word",word), word);t_ct_("}"); }}
	  else{t_ct_("\n847 \t  else"); t_ct_(" if (strcmp(when,\"WDAND2AFT\")== 0 ||\n\t\t   strcmp(when,\"WDAND2TAGAFT\")== 0)");  if ((strcmp((s_ct_("\t  /* when",when), when),"WDAND2AFT"), u_ct_("\t  /* strcmp(when,\"WDAND2AFT\")",sizeof(strcmp(when,"WDAND2AFT")),strcmp(when,"WDAND2AFT")), strcmp(when,"WDAND2AFT"))== 0 ||
		   (strcmp((s_ct_("\t  /* when",when), when),"WDAND2TAGAFT"), u_ct_("\t  /* strcmp(when,\"WDAND2TAGAFT\")",sizeof(strcmp(when,"WDAND2TAGAFT")),strcmp(when,"WDAND2TAGAFT")), strcmp(when,"WDAND2TAGAFT"))== 0){ {t_ct_(" {"); t_ct_("\n849 \t    strcpy(next2,split_ptr[4]);"); 
	    (strcpy(next2,(s_ct_("\t    /* split_ptr[4]",split_ptr[4]), split_ptr[4])), s_ct_("\t    /* next2",next2), next2);t_ct_("\n850 \t    strcpy(word,split_ptr[3]);"); 
	    (strcpy(word,(s_ct_("\t    /* split_ptr[3]",split_ptr[3]), split_ptr[3])), s_ct_("\t    /* word",word), word);t_ct_("}"); }}
	  }}}}}}}}t_ct_("\n852 \t  for (count = 0; count <corpuslen; ++count)"); 
	  for ((count = 0, u_ct_("\t  /* count",sizeof(count),count), count); (u_ct_("\t  /* count",sizeof(count),count), count) <(u_ct_("\t  /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen);t_ct_("\n852 \t  for (count = 0; count <corpuslen; ++count)"),(++count, u_ct_("\t  /* count",sizeof(count),count), count)){ {t_ct_(" {"); t_ct_("\n853 \t    strcpy(curtag, thetagcorpus[count]);"); 
	    (strcpy(curtag, (thetagcorpus[(u_ct_("\t    /* count",sizeof(count),count), count)], s_ct_("\t    /* thetagcorpus[count]",thetagcorpus[count]), thetagcorpus[count])), s_ct_("\t    /* curtag",curtag), curtag);t_ct_("\n854 \t    if (strcmp(curtag, old) == 0)"); 
	    if ((strcmp((s_ct_("\t    /* curtag",curtag), curtag), (s_ct_("\t    /* old",old), old)), u_ct_("\t    /* strcmp(curtag, old)",sizeof(strcmp(curtag, old)),strcmp(curtag, old)), strcmp(curtag, old)) == 0){ {t_ct_(" {"); t_ct_("\n855 \t      strcpy(curwd,thewordcorpus[count]);"); 
	      (strcpy(curwd,(thewordcorpus[(u_ct_("\t      /* count",sizeof(count),count), count)], s_ct_("\t      /* thewordcorpus[count]",thewordcorpus[count]), thewordcorpus[count])), s_ct_("\t      /* curwd",curwd), curwd);t_ct_("\n856 \t      sprintf(atempstr2,\"%s %s\",curwd,new);"); 
	      sprintf((u_ct_("\t      /* atempstr2",sizeof(atempstr2),atempstr2), atempstr2),"%s %s",(u_ct_("\t      /* curwd",sizeof(curwd),curwd), curwd),(u_ct_("\t      /* new",sizeof(new),new), new));
	      t_ct_("\n858 \t      if (! Registry_get(*wordreg,curwd) ||\n\t\t  Registry_get(*seentaggingreg,atempstr2))"); 
	      if (! Registry_get((u_ct_("\t      /* *wordreg",sizeof(*wordreg),*wordreg), *wordreg),(u_ct_("\t      /* curwd",sizeof(curwd),curwd), curwd)) ||
		  Registry_get((u_ct_("\t      /* *seentaggingreg",sizeof(*seentaggingreg),*seentaggingreg), *seentaggingreg),(u_ct_("\t      /* atempstr2",sizeof(atempstr2),atempstr2), atempstr2))){ {
		t_ct_(" {"); t_ct_("\n861 \t\tif (strcmp(when, \"SURROUNDTAG\") == 0)"); 
		if ((strcmp((s_ct_("\t\t/* when",when), when), "SURROUNDTAG"), u_ct_("\t\t/* strcmp(when, \"SURROUNDTAG\")",sizeof(strcmp(when, "SURROUNDTAG")),strcmp(when, "SURROUNDTAG")), strcmp(when, "SURROUNDTAG")) == 0){ {t_ct_(" {"); t_ct_("\n862 \t\t  if (count < corpuslen-1 && count > 0)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) < (u_ct_("\t\t  /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-1 && (u_ct_("\t\t  /* count",sizeof(count),count), count) > 0){ {t_ct_(" {"); t_ct_("\n863 \t\t    if (strcmp(lft, thetagcorpus[count - 1]) == 0 &&\n\t\t\tstrcmp(rght, thetagcorpus[count + 1]) == 0)"); 
		    if ((strcmp((s_ct_("\t\t    /* lft",lft), lft), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) - 1], s_ct_("\t\t    /* thetagcorpus[count - 1]",thetagcorpus[count - 1]), thetagcorpus[count - 1])), u_ct_("\t\t    /* strcmp(lft, thetagcorpus[count - 1])",sizeof(strcmp(lft, thetagcorpus[count - 1])),strcmp(lft, thetagcorpus[count - 1])), strcmp(lft, thetagcorpus[count - 1])) == 0 &&
			(strcmp((s_ct_("\t\t    /* rght",rght), rght), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) + 1], s_ct_("\t\t    /* thetagcorpus[count + 1]",thetagcorpus[count + 1]), thetagcorpus[count + 1])), u_ct_("\t\t    /* strcmp(rght, thetagcorpus[count + 1])",sizeof(strcmp(rght, thetagcorpus[count + 1])),strcmp(rght, thetagcorpus[count + 1])), strcmp(rght, thetagcorpus[count + 1])) == 0){ t_ct_("\n865 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n866 \t\t  }"); 
		  }}t_ct_("\n867 \t\t}"); 
		}} else{t_ct_(" else"); t_ct_(" if (strcmp(when, \"NEXTTAG\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "NEXTTAG"), u_ct_("\t\t/* strcmp(when, \"NEXTTAG\")",sizeof(strcmp(when, "NEXTTAG")),strcmp(when, "NEXTTAG")), strcmp(when, "NEXTTAG")) == 0){ {t_ct_(" {"); t_ct_("\n868 \t\t  if (count < corpuslen-1)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) < (u_ct_("\t\t  /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-1){ {t_ct_(" {"); t_ct_("\n869 \t\t    if (strcmp(tag, thetagcorpus[count + 1]) == 0)"); 
		    if ((strcmp((s_ct_("\t\t    /* tag",tag), tag), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) + 1], s_ct_("\t\t    /* thetagcorpus[count + 1]",thetagcorpus[count + 1]), thetagcorpus[count + 1])), u_ct_("\t\t    /* strcmp(tag, thetagcorpus[count + 1])",sizeof(strcmp(tag, thetagcorpus[count + 1])),strcmp(tag, thetagcorpus[count + 1])), strcmp(tag, thetagcorpus[count + 1])) == 0){ t_ct_("\n870 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n871 \t\t  }"); 
		  }}t_ct_("\n872 \t\t}"); 
		}}  
		else{t_ct_("\n873 \t\telse"); t_ct_(" if (strcmp(when, \"CURWD\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "CURWD"), u_ct_("\t\t/* strcmp(when, \"CURWD\")",sizeof(strcmp(when, "CURWD")),strcmp(when, "CURWD")), strcmp(when, "CURWD")) == 0){ {t_ct_(" {"); t_ct_("\n874 \t\t  if (strcmp(word, thewordcorpus[count]) == 0)"); 
		  if ((strcmp((s_ct_("\t\t  /* word",word), word), (thewordcorpus[(u_ct_("\t\t  /* count",sizeof(count),count), count)], s_ct_("\t\t  /* thewordcorpus[count]",thewordcorpus[count]), thewordcorpus[count])), u_ct_("\t\t  /* strcmp(word, thewordcorpus[count])",sizeof(strcmp(word, thewordcorpus[count])),strcmp(word, thewordcorpus[count])), strcmp(word, thewordcorpus[count])) == 0){t_ct_("\n875 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n876 \t\t}"); 
		}}  
		else{t_ct_("\n877 \t\telse"); t_ct_(" if (strcmp(when, \"NEXTWD\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "NEXTWD"), u_ct_("\t\t/* strcmp(when, \"NEXTWD\")",sizeof(strcmp(when, "NEXTWD")),strcmp(when, "NEXTWD")), strcmp(when, "NEXTWD")) == 0){ {t_ct_(" {"); t_ct_("\n878 \t\t  if (count < corpuslen-1)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) < (u_ct_("\t\t  /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-1){ {t_ct_(" {"); t_ct_("\n879 \t\t    if (strcmp(word, thewordcorpus[count + 1]) == 0)"); 
		    if ((strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) + 1], s_ct_("\t\t    /* thewordcorpus[count + 1]",thewordcorpus[count + 1]), thewordcorpus[count + 1])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[count + 1])",sizeof(strcmp(word, thewordcorpus[count + 1])),strcmp(word, thewordcorpus[count + 1])), strcmp(word, thewordcorpus[count + 1])) == 0){t_ct_("\n880 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n881 \t\t  }"); 
		  }}t_ct_("\n882 \t\t}"); 
		}}  else{t_ct_("  else"); t_ct_(" if (strcmp(when, \"RBIGRAM\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "RBIGRAM"), u_ct_("\t\t/* strcmp(when, \"RBIGRAM\")",sizeof(strcmp(when, "RBIGRAM")),strcmp(when, "RBIGRAM")), strcmp(when, "RBIGRAM")) == 0){ {t_ct_(" {"); t_ct_("\n883 \t\t  if (count < corpuslen-1)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) < (u_ct_("\t\t  /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-1){ {t_ct_(" {"); t_ct_("\n884 \t\t    if (strcmp(word, thewordcorpus[count]) ==\n\t\t\t0 &&\n\t\t\tstrcmp(next1, thewordcorpus[count+1]) ==\n\t\t\t0)"); 
		    if ((strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count)], s_ct_("\t\t    /* thewordcorpus[count]",thewordcorpus[count]), thewordcorpus[count])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[count])",sizeof(strcmp(word, thewordcorpus[count])),strcmp(word, thewordcorpus[count])), strcmp(word, thewordcorpus[count])) ==
			0 &&
			(strcmp((s_ct_("\t\t    /* next1",next1), next1), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count)+1], s_ct_("\t\t    /* thewordcorpus[count+1]",thewordcorpus[count+1]), thewordcorpus[count+1])), u_ct_("\t\t    /* strcmp(next1, thewordcorpus[count+1])",sizeof(strcmp(next1, thewordcorpus[count+1])),strcmp(next1, thewordcorpus[count+1])), strcmp(next1, thewordcorpus[count+1])) ==
			0){t_ct_("\n888 \t\t    change_the_tag(thetagcorpus,new,count);"); 
		    change_the_tag((u_ct_("\t\t    /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t    /* new",sizeof(new),new), new),(u_ct_("\t\t    /* count",sizeof(count),count), count));}t_ct_("\n889 \t\t  }"); 
		  }}t_ct_("\n890 \t\t}"); 
		}} 
		else{t_ct_("\n891 \t\telse"); t_ct_(" if (strcmp(when, \"WDNEXTTAG\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "WDNEXTTAG"), u_ct_("\t\t/* strcmp(when, \"WDNEXTTAG\")",sizeof(strcmp(when, "WDNEXTTAG")),strcmp(when, "WDNEXTTAG")), strcmp(when, "WDNEXTTAG")) == 0){ {t_ct_(" {"); t_ct_("\n892 \t\t  if (count < corpuslen-1)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) < (u_ct_("\t\t  /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-1){ {t_ct_(" {"); t_ct_("\n893 \t\t    if (strcmp(word, thewordcorpus[count]) ==\n\t\t\t0 &&\n\t\t\tstrcmp(next1, thetagcorpus[count+1]) ==\n\t\t\t0)"); 
		    if ((strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count)], s_ct_("\t\t    /* thewordcorpus[count]",thewordcorpus[count]), thewordcorpus[count])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[count])",sizeof(strcmp(word, thewordcorpus[count])),strcmp(word, thewordcorpus[count])), strcmp(word, thewordcorpus[count])) ==
			0 &&
			(strcmp((s_ct_("\t\t    /* next1",next1), next1), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count)+1], s_ct_("\t\t    /* thetagcorpus[count+1]",thetagcorpus[count+1]), thetagcorpus[count+1])), u_ct_("\t\t    /* strcmp(next1, thetagcorpus[count+1])",sizeof(strcmp(next1, thetagcorpus[count+1])),strcmp(next1, thetagcorpus[count+1])), strcmp(next1, thetagcorpus[count+1])) ==
			0){t_ct_("\n897 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n898 \t\t  }"); 
		  }}t_ct_("\n899 \t\t}"); 
		}}
		
		else{t_ct_("\n901 \t\telse"); t_ct_(" if (strcmp(when, \"WDAND2AFT\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "WDAND2AFT"), u_ct_("\t\t/* strcmp(when, \"WDAND2AFT\")",sizeof(strcmp(when, "WDAND2AFT")),strcmp(when, "WDAND2AFT")), strcmp(when, "WDAND2AFT")) == 0){ {t_ct_(" {"); t_ct_("\n902 \t\t  if (count < corpuslen-2)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) < (u_ct_("\t\t  /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-2){ {t_ct_(" {"); t_ct_("\n903 \t\t    if (strcmp(word, thewordcorpus[count]) ==\n\t\t\t0 &&\n\t\t\tstrcmp(next2,thewordcorpus[count+2]) ==\n\t\t\t0)"); 
		    if ((strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count)], s_ct_("\t\t    /* thewordcorpus[count]",thewordcorpus[count]), thewordcorpus[count])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[count])",sizeof(strcmp(word, thewordcorpus[count])),strcmp(word, thewordcorpus[count])), strcmp(word, thewordcorpus[count])) ==
			0 &&
			(strcmp((s_ct_("\t\t    /* next2",next2), next2),(thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count)+2], s_ct_("\t\t    /* thewordcorpus[count+2]",thewordcorpus[count+2]), thewordcorpus[count+2])), u_ct_("\t\t    /* strcmp(next2,thewordcorpus[count+2])",sizeof(strcmp(next2,thewordcorpus[count+2])),strcmp(next2,thewordcorpus[count+2])), strcmp(next2,thewordcorpus[count+2])) ==
			0){t_ct_("\n907 \t\t    change_the_tag(thetagcorpus,new,count);"); 
		    change_the_tag((u_ct_("\t\t    /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t    /* new",sizeof(new),new), new),(u_ct_("\t\t    /* count",sizeof(count),count), count));}t_ct_("\n908 \t\t  }"); 
		  }}t_ct_("\n909 \t\t}"); 
		}}
		else{t_ct_("\n910 \t\telse"); t_ct_(" if (strcmp(when, \"WDAND2TAGAFT\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "WDAND2TAGAFT"), u_ct_("\t\t/* strcmp(when, \"WDAND2TAGAFT\")",sizeof(strcmp(when, "WDAND2TAGAFT")),strcmp(when, "WDAND2TAGAFT")), strcmp(when, "WDAND2TAGAFT")) == 0){ {t_ct_(" {"); t_ct_("\n911 \t\t  if (count < corpuslen-2)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) < (u_ct_("\t\t  /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-2){ {t_ct_(" {"); t_ct_("\n912 \t\t    if (strcmp(word, thewordcorpus[count]) ==\n\t\t\t0 &&\n\t\t\tstrcmp(next2, thetagcorpus[count+2]) ==\n\t\t\t0)"); 
		    if ((strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count)], s_ct_("\t\t    /* thewordcorpus[count]",thewordcorpus[count]), thewordcorpus[count])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[count])",sizeof(strcmp(word, thewordcorpus[count])),strcmp(word, thewordcorpus[count])), strcmp(word, thewordcorpus[count])) ==
			0 &&
			(strcmp((s_ct_("\t\t    /* next2",next2), next2), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count)+2], s_ct_("\t\t    /* thetagcorpus[count+2]",thetagcorpus[count+2]), thetagcorpus[count+2])), u_ct_("\t\t    /* strcmp(next2, thetagcorpus[count+2])",sizeof(strcmp(next2, thetagcorpus[count+2])),strcmp(next2, thetagcorpus[count+2])), strcmp(next2, thetagcorpus[count+2])) ==
			0){t_ct_("\n916 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n917 \t\t  }"); 
		  }}t_ct_("\n918 \t\t}"); 
		}}
		else{t_ct_("\n919 \t\telse"); t_ct_(" if (strcmp(when, \"NEXT2TAG\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "NEXT2TAG"), u_ct_("\t\t/* strcmp(when, \"NEXT2TAG\")",sizeof(strcmp(when, "NEXT2TAG")),strcmp(when, "NEXT2TAG")), strcmp(when, "NEXT2TAG")) == 0){ {t_ct_(" {"); t_ct_("\n920 \t\t  if (count < corpuslen-2)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) < (u_ct_("\t\t  /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-2){ {t_ct_(" {"); t_ct_("\n921 \t\t    if (strcmp(tag,thetagcorpus[count + 2]) == 0)"); 
		    if ((strcmp((s_ct_("\t\t    /* tag",tag), tag),(thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) + 2], s_ct_("\t\t    /* thetagcorpus[count + 2]",thetagcorpus[count + 2]), thetagcorpus[count + 2])), u_ct_("\t\t    /* strcmp(tag,thetagcorpus[count + 2])",sizeof(strcmp(tag,thetagcorpus[count + 2])),strcmp(tag,thetagcorpus[count + 2])), strcmp(tag,thetagcorpus[count + 2])) == 0){t_ct_("\n922 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n923 \t\t  }"); 
		  }}t_ct_("\n924 \t\t}"); 
		}} else{t_ct_(" else"); t_ct_(" if (strcmp(when, \"NEXT2WD\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "NEXT2WD"), u_ct_("\t\t/* strcmp(when, \"NEXT2WD\")",sizeof(strcmp(when, "NEXT2WD")),strcmp(when, "NEXT2WD")), strcmp(when, "NEXT2WD")) == 0){ {t_ct_(" {"); t_ct_("\n925 \t\t  if (count < corpuslen-2)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) < (u_ct_("\t\t  /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-2){ {t_ct_(" {"); t_ct_("\n926 \t\t    if (strcmp(word, thewordcorpus[count + 2]) == 0)"); 
		    if ((strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) + 2], s_ct_("\t\t    /* thewordcorpus[count + 2]",thewordcorpus[count + 2]), thewordcorpus[count + 2])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[count + 2])",sizeof(strcmp(word, thewordcorpus[count + 2])),strcmp(word, thewordcorpus[count + 2])), strcmp(word, thewordcorpus[count + 2])) == 0){t_ct_("\n927 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n928 \t\t  }"); 
		  }}t_ct_("\n929 \t\t}"); 
		}} else{t_ct_(" else"); t_ct_(" if (strcmp(when, \"NEXTBIGRAM\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "NEXTBIGRAM"), u_ct_("\t\t/* strcmp(when, \"NEXTBIGRAM\")",sizeof(strcmp(when, "NEXTBIGRAM")),strcmp(when, "NEXTBIGRAM")), strcmp(when, "NEXTBIGRAM")) == 0){ {t_ct_(" {"); t_ct_("\n930 \t\t  if (count < corpuslen-2)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) < (u_ct_("\t\t  /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-2){ {t_ct_(" {"); t_ct_("\n931 \t\t    if\n\t\t      (strcmp(next1, thetagcorpus[count + 1]) == 0 &&\n\t\t       strcmp(next2, thetagcorpus[count + 2]) == 0)"); 
		    if
		      ((strcmp((s_ct_("\t\t    /* next1",next1), next1), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) + 1], s_ct_("\t\t    /* thetagcorpus[count + 1]",thetagcorpus[count + 1]), thetagcorpus[count + 1])), u_ct_("\t\t    /* strcmp(next1, thetagcorpus[count + 1])",sizeof(strcmp(next1, thetagcorpus[count + 1])),strcmp(next1, thetagcorpus[count + 1])), strcmp(next1, thetagcorpus[count + 1])) == 0 &&
		       (strcmp((s_ct_("\t\t    /* next2",next2), next2), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) + 2], s_ct_("\t\t    /* thetagcorpus[count + 2]",thetagcorpus[count + 2]), thetagcorpus[count + 2])), u_ct_("\t\t    /* strcmp(next2, thetagcorpus[count + 2])",sizeof(strcmp(next2, thetagcorpus[count + 2])),strcmp(next2, thetagcorpus[count + 2])), strcmp(next2, thetagcorpus[count + 2])) == 0){t_ct_("\n934 \t\t\tchange_the_tag(thetagcorpus,new,count);"); 
			change_the_tag((u_ct_("\t\t\t/* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t\t/* new",sizeof(new),new), new),(u_ct_("\t\t\t/* count",sizeof(count),count), count));}t_ct_("\n935 \t\t  }"); 
		  }}t_ct_("\n936 \t\t}"); 
		}} else{t_ct_(" else"); t_ct_(" if (strcmp(when, \"NEXT1OR2TAG\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "NEXT1OR2TAG"), u_ct_("\t\t/* strcmp(when, \"NEXT1OR2TAG\")",sizeof(strcmp(when, "NEXT1OR2TAG")),strcmp(when, "NEXT1OR2TAG")), strcmp(when, "NEXT1OR2TAG")) == 0){ {t_ct_(" {"); t_ct_("\n937 \t\t  if (count < corpuslen-1)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) < (u_ct_("\t\t  /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-1){ {t_ct_(" {"); t_ct_("\n938 \t\t    if (count < corpuslen-2)"); 
		    if ((u_ct_("\t\t    /* count",sizeof(count),count), count) < (u_ct_("\t\t    /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-2){ t_ct_("\n939 \t\t      tempcount1 = count+2;"); 
		      (tempcount1 = (u_ct_("\t\t      /* count",sizeof(count),count), count)+2, u_ct_("\t\t      /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1);}
		    else{t_ct_("\n940 \t\t    else");  t_ct_("\n941 \t\t      tempcount1 = count+1;"); 
		      (tempcount1 = (u_ct_("\t\t      /* count",sizeof(count),count), count)+1, u_ct_("\t\t      /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1);}t_ct_("\n942 \t\t    if\n\t\t    (strcmp(tag, thetagcorpus[count + 1]) == 0 ||\n\t\t     strcmp(tag, thetagcorpus[tempcount1]) == 0)"); 
		    if
		    ((strcmp((s_ct_("\t\t    /* tag",tag), tag), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) + 1], s_ct_("\t\t    /* thetagcorpus[count + 1]",thetagcorpus[count + 1]), thetagcorpus[count + 1])), u_ct_("\t\t    /* strcmp(tag, thetagcorpus[count + 1])",sizeof(strcmp(tag, thetagcorpus[count + 1])),strcmp(tag, thetagcorpus[count + 1])), strcmp(tag, thetagcorpus[count + 1])) == 0 ||
		     (strcmp((s_ct_("\t\t    /* tag",tag), tag), (thetagcorpus[(u_ct_("\t\t    /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1)], s_ct_("\t\t    /* thetagcorpus[tempcount1]",thetagcorpus[tempcount1]), thetagcorpus[tempcount1])), u_ct_("\t\t    /* strcmp(tag, thetagcorpus[tempcount1])",sizeof(strcmp(tag, thetagcorpus[tempcount1])),strcmp(tag, thetagcorpus[tempcount1])), strcmp(tag, thetagcorpus[tempcount1])) == 0){t_ct_("\n945 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n946 \t\t  }"); 
		  }}t_ct_("\n947 \t\t}"); 
		}}  else{t_ct_("  else"); t_ct_(" if (strcmp(when, \"NEXT1OR2WD\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "NEXT1OR2WD"), u_ct_("\t\t/* strcmp(when, \"NEXT1OR2WD\")",sizeof(strcmp(when, "NEXT1OR2WD")),strcmp(when, "NEXT1OR2WD")), strcmp(when, "NEXT1OR2WD")) == 0){ {t_ct_(" {"); t_ct_("\n948 \t\t  if (count < corpuslen-1)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) < (u_ct_("\t\t  /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-1){ {t_ct_(" {"); t_ct_("\n949 \t\t    if (count < corpuslen-2)"); 
		    if ((u_ct_("\t\t    /* count",sizeof(count),count), count) < (u_ct_("\t\t    /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-2){ t_ct_("\n950 \t\t      tempcount1 = count+2;"); 
		      (tempcount1 = (u_ct_("\t\t      /* count",sizeof(count),count), count)+2, u_ct_("\t\t      /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1);}
		    else{t_ct_("\n951 \t\t    else");  t_ct_("\n952 \t\t      tempcount1 = count+1;"); 
		      (tempcount1 = (u_ct_("\t\t      /* count",sizeof(count),count), count)+1, u_ct_("\t\t      /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1);}t_ct_("\n953 \t\t    if\n\t\t    (strcmp(word, thewordcorpus[count + 1]) == 0 ||\n\t\t     strcmp(word, thewordcorpus[tempcount1]) == 0)"); 
		    if
		    ((strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) + 1], s_ct_("\t\t    /* thewordcorpus[count + 1]",thewordcorpus[count + 1]), thewordcorpus[count + 1])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[count + 1])",sizeof(strcmp(word, thewordcorpus[count + 1])),strcmp(word, thewordcorpus[count + 1])), strcmp(word, thewordcorpus[count + 1])) == 0 ||
		     (strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1)], s_ct_("\t\t    /* thewordcorpus[tempcount1]",thewordcorpus[tempcount1]), thewordcorpus[tempcount1])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[tempcount1])",sizeof(strcmp(word, thewordcorpus[tempcount1])),strcmp(word, thewordcorpus[tempcount1])), strcmp(word, thewordcorpus[tempcount1])) == 0){t_ct_("\n956 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n957 \t\t  }"); 
		  }}t_ct_("\n958 \t\t}"); 
		}}   else{t_ct_("   else"); t_ct_(" if (strcmp(when, \"NEXT1OR2OR3TAG\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "NEXT1OR2OR3TAG"), u_ct_("\t\t/* strcmp(when, \"NEXT1OR2OR3TAG\")",sizeof(strcmp(when, "NEXT1OR2OR3TAG")),strcmp(when, "NEXT1OR2OR3TAG")), strcmp(when, "NEXT1OR2OR3TAG")) == 0){ {t_ct_(" {"); t_ct_("\n959 \t\t  if (count < corpuslen-1)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) < (u_ct_("\t\t  /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-1){ {t_ct_(" {"); t_ct_("\n960 \t\t    if (count < corpuslen-2)"); 
		    if ((u_ct_("\t\t    /* count",sizeof(count),count), count) < (u_ct_("\t\t    /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-2){t_ct_("\n961 \t\t      tempcount1 = count+2;"); 
		      (tempcount1 = (u_ct_("\t\t      /* count",sizeof(count),count), count)+2, u_ct_("\t\t      /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1);}
		    else{t_ct_("\n962 \t\t    else");  t_ct_("\n963 \t\t      tempcount1 = count+1;"); 
		      (tempcount1 = (u_ct_("\t\t      /* count",sizeof(count),count), count)+1, u_ct_("\t\t      /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1);}t_ct_("\n964 \t\t    if (count < corpuslen-3)"); 
		    if ((u_ct_("\t\t    /* count",sizeof(count),count), count) < (u_ct_("\t\t    /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-3){t_ct_("\n965 \t\t      tempcount2 = count+3;"); 
		      (tempcount2 = (u_ct_("\t\t      /* count",sizeof(count),count), count)+3, u_ct_("\t\t      /* tempcount2",sizeof(tempcount2),tempcount2), tempcount2);}
		    else{t_ct_("\n966 \t\t    else");  t_ct_("\n967 \t\t      tempcount2 =count+1;"); 
		      (tempcount2 =(u_ct_("\t\t      /* count",sizeof(count),count), count)+1, u_ct_("\t\t      /* tempcount2",sizeof(tempcount2),tempcount2), tempcount2);}t_ct_("\n968 \t\t    if\n\t\t      (strcmp(tag, thetagcorpus[count + 1]) == 0 ||\n\t\t       strcmp(tag, thetagcorpus[tempcount1]) == 0 ||\n\t\t       strcmp(tag, thetagcorpus[tempcount2]) == 0)"); 
		    if
		      ((strcmp((s_ct_("\t\t    /* tag",tag), tag), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) + 1], s_ct_("\t\t    /* thetagcorpus[count + 1]",thetagcorpus[count + 1]), thetagcorpus[count + 1])), u_ct_("\t\t    /* strcmp(tag, thetagcorpus[count + 1])",sizeof(strcmp(tag, thetagcorpus[count + 1])),strcmp(tag, thetagcorpus[count + 1])), strcmp(tag, thetagcorpus[count + 1])) == 0 ||
		       (strcmp((s_ct_("\t\t    /* tag",tag), tag), (thetagcorpus[(u_ct_("\t\t    /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1)], s_ct_("\t\t    /* thetagcorpus[tempcount1]",thetagcorpus[tempcount1]), thetagcorpus[tempcount1])), u_ct_("\t\t    /* strcmp(tag, thetagcorpus[tempcount1])",sizeof(strcmp(tag, thetagcorpus[tempcount1])),strcmp(tag, thetagcorpus[tempcount1])), strcmp(tag, thetagcorpus[tempcount1])) == 0 ||
		       strcmp((s_ct_("\t\t    /* tag",tag), tag), thetagcorpus[(u_ct_("\t\t    /* tempcount2",sizeof(tempcount2),tempcount2), tempcount2)]) == 0){t_ct_("\n972 \t\t\tchange_the_tag(thetagcorpus,new,count);"); 
			change_the_tag((u_ct_("\t\t\t/* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t\t/* new",sizeof(new),new), new),(u_ct_("\t\t\t/* count",sizeof(count),count), count));}t_ct_("\n973 \t\t  }"); 
		  }}t_ct_("\n974 \t\t}"); 
		}} else{t_ct_(" else"); t_ct_(" if (strcmp(when, \"NEXT1OR2OR3WD\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "NEXT1OR2OR3WD"), u_ct_("\t\t/* strcmp(when, \"NEXT1OR2OR3WD\")",sizeof(strcmp(when, "NEXT1OR2OR3WD")),strcmp(when, "NEXT1OR2OR3WD")), strcmp(when, "NEXT1OR2OR3WD")) == 0){ {t_ct_(" {"); t_ct_("\n975 \t\t  if (count < corpuslen-1)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) < (u_ct_("\t\t  /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-1){ {t_ct_(" {"); t_ct_("\n976 \t\t    if (count < corpuslen-2)"); 
		    if ((u_ct_("\t\t    /* count",sizeof(count),count), count) < (u_ct_("\t\t    /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-2){t_ct_("\n977 \t\t      tempcount1 = count+2;"); 
		      (tempcount1 = (u_ct_("\t\t      /* count",sizeof(count),count), count)+2, u_ct_("\t\t      /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1);}
		    else{t_ct_("\n978 \t\t    else");  t_ct_("\n979 \t\t      tempcount1 = count+1;"); 
		      (tempcount1 = (u_ct_("\t\t      /* count",sizeof(count),count), count)+1, u_ct_("\t\t      /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1);}t_ct_("\n980 \t\t    if (count < corpuslen-3)"); 
		    if ((u_ct_("\t\t    /* count",sizeof(count),count), count) < (u_ct_("\t\t    /* corpuslen",sizeof(corpuslen),corpuslen), corpuslen)-3){t_ct_("\n981 \t\t      tempcount2 = count+3;"); 
		      (tempcount2 = (u_ct_("\t\t      /* count",sizeof(count),count), count)+3, u_ct_("\t\t      /* tempcount2",sizeof(tempcount2),tempcount2), tempcount2);}
		    else{t_ct_("\n982 \t\t    else");  t_ct_("\n983 \t\t      tempcount2 =count+1;"); 
		      (tempcount2 =(u_ct_("\t\t      /* count",sizeof(count),count), count)+1, u_ct_("\t\t      /* tempcount2",sizeof(tempcount2),tempcount2), tempcount2);}t_ct_("\n984 \t\t    if\n\t\t      (strcmp(word, thewordcorpus[count + 1]) == 0 ||\n\t\t       strcmp(word, thewordcorpus[tempcount1]) == 0 ||\n\t\t       strcmp(word, thewordcorpus[tempcount2]) == 0)"); 
		    if
		      ((strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) + 1], s_ct_("\t\t    /* thewordcorpus[count + 1]",thewordcorpus[count + 1]), thewordcorpus[count + 1])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[count + 1])",sizeof(strcmp(word, thewordcorpus[count + 1])),strcmp(word, thewordcorpus[count + 1])), strcmp(word, thewordcorpus[count + 1])) == 0 ||
		       (strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1)], s_ct_("\t\t    /* thewordcorpus[tempcount1]",thewordcorpus[tempcount1]), thewordcorpus[tempcount1])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[tempcount1])",sizeof(strcmp(word, thewordcorpus[tempcount1])),strcmp(word, thewordcorpus[tempcount1])), strcmp(word, thewordcorpus[tempcount1])) == 0 ||
		       strcmp((s_ct_("\t\t    /* word",word), word), thewordcorpus[(u_ct_("\t\t    /* tempcount2",sizeof(tempcount2),tempcount2), tempcount2)]) == 0){t_ct_("\n988 \t\t\tchange_the_tag(thetagcorpus,new,count);"); 
			change_the_tag((u_ct_("\t\t\t/* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t\t/* new",sizeof(new),new), new),(u_ct_("\t\t\t/* count",sizeof(count),count), count));}t_ct_("\n989 \t\t  }"); 
		  }}t_ct_("\n990 \t\t}"); 
		}}  else{t_ct_("  else"); t_ct_(" if (strcmp(when, \"PREVTAG\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "PREVTAG"), u_ct_("\t\t/* strcmp(when, \"PREVTAG\")",sizeof(strcmp(when, "PREVTAG")),strcmp(when, "PREVTAG")), strcmp(when, "PREVTAG")) == 0){ {t_ct_(" {"); t_ct_("\n991 \t\t  if (count > 0)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) > 0){ {t_ct_(" {"); t_ct_("\n992 \t\t    if (strcmp(tag, thetagcorpus[count - 1]) == 0)"); 
		    if ((strcmp((s_ct_("\t\t    /* tag",tag), tag), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) - 1], s_ct_("\t\t    /* thetagcorpus[count - 1]",thetagcorpus[count - 1]), thetagcorpus[count - 1])), u_ct_("\t\t    /* strcmp(tag, thetagcorpus[count - 1])",sizeof(strcmp(tag, thetagcorpus[count - 1])),strcmp(tag, thetagcorpus[count - 1])), strcmp(tag, thetagcorpus[count - 1])) == 0){ {t_ct_(" {"); t_ct_("\n993 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));t_ct_("\n994 \t\t    }"); 
		    }}t_ct_("\n995 \t\t  }"); 
		  }}t_ct_("\n996 \t\t}"); 
		}} else{t_ct_(" else"); t_ct_(" if (strcmp(when, \"PREVWD\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "PREVWD"), u_ct_("\t\t/* strcmp(when, \"PREVWD\")",sizeof(strcmp(when, "PREVWD")),strcmp(when, "PREVWD")), strcmp(when, "PREVWD")) == 0){ {t_ct_(" {"); t_ct_("\n997 \t\t  if (count > 0)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) > 0){ {t_ct_(" {"); t_ct_("\n998 \t\t    if (strcmp(word, thewordcorpus[count - 1]) == 0)"); 
		    if ((strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) - 1], s_ct_("\t\t    /* thewordcorpus[count - 1]",thewordcorpus[count - 1]), thewordcorpus[count - 1])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[count - 1])",sizeof(strcmp(word, thewordcorpus[count - 1])),strcmp(word, thewordcorpus[count - 1])), strcmp(word, thewordcorpus[count - 1])) == 0){ {t_ct_(" {"); t_ct_("\n999 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));t_ct_("\n1000 \t\t    }"); 
		    }}t_ct_("\n1001 \t\t  }"); 
		  }}t_ct_("\n1002 \t\t}"); 
		}}  else{t_ct_("  else"); t_ct_(" if (strcmp(when, \"LBIGRAM\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "LBIGRAM"), u_ct_("\t\t/* strcmp(when, \"LBIGRAM\")",sizeof(strcmp(when, "LBIGRAM")),strcmp(when, "LBIGRAM")), strcmp(when, "LBIGRAM")) == 0){ {t_ct_(" {"); t_ct_("\n1003 \t\t  if (count > 0)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) > 0){ {t_ct_(" {"); t_ct_("\n1004 \t\t    if (strcmp(word, thewordcorpus[count]) ==\n\t\t\t0 &&\n\t\t\tstrcmp(prev1, thewordcorpus[count-1]) ==\n\t\t\t0)"); 
		    if ((strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count)], s_ct_("\t\t    /* thewordcorpus[count]",thewordcorpus[count]), thewordcorpus[count])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[count])",sizeof(strcmp(word, thewordcorpus[count])),strcmp(word, thewordcorpus[count])), strcmp(word, thewordcorpus[count])) ==
			0 &&
			(strcmp((s_ct_("\t\t    /* prev1",prev1), prev1), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count)-1], s_ct_("\t\t    /* thewordcorpus[count-1]",thewordcorpus[count-1]), thewordcorpus[count-1])), u_ct_("\t\t    /* strcmp(prev1, thewordcorpus[count-1])",sizeof(strcmp(prev1, thewordcorpus[count-1])),strcmp(prev1, thewordcorpus[count-1])), strcmp(prev1, thewordcorpus[count-1])) ==
			0){t_ct_("\n1008 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n1009 \t\t  }"); 
		  }}t_ct_("\n1010 \t\t}"); 
		}}
		else{t_ct_("\n1011 \t\telse"); t_ct_(" if (strcmp(when, \"WDPREVTAG\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "WDPREVTAG"), u_ct_("\t\t/* strcmp(when, \"WDPREVTAG\")",sizeof(strcmp(when, "WDPREVTAG")),strcmp(when, "WDPREVTAG")), strcmp(when, "WDPREVTAG")) == 0){ {t_ct_(" {"); t_ct_("\n1012 \t\t  if (count > 0)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) > 0){ {t_ct_(" {"); t_ct_("\n1013 \t\t    if (strcmp(word, thewordcorpus[count]) ==\n\t\t\t0 &&\n\t\t\tstrcmp(prev1, thetagcorpus[count-1]) ==\n\t\t\t0)"); 
		    if ((strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count)], s_ct_("\t\t    /* thewordcorpus[count]",thewordcorpus[count]), thewordcorpus[count])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[count])",sizeof(strcmp(word, thewordcorpus[count])),strcmp(word, thewordcorpus[count])), strcmp(word, thewordcorpus[count])) ==
			0 &&
			(strcmp((s_ct_("\t\t    /* prev1",prev1), prev1), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count)-1], s_ct_("\t\t    /* thetagcorpus[count-1]",thetagcorpus[count-1]), thetagcorpus[count-1])), u_ct_("\t\t    /* strcmp(prev1, thetagcorpus[count-1])",sizeof(strcmp(prev1, thetagcorpus[count-1])),strcmp(prev1, thetagcorpus[count-1])), strcmp(prev1, thetagcorpus[count-1])) ==
			0){t_ct_("\n1017 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n1018 \t\t  }"); 
		  }}t_ct_("\n1019 \t\t}"); 
		}}
		else{t_ct_("\n1020 \t\telse"); t_ct_(" if (strcmp(when, \"WDAND2BFR\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "WDAND2BFR"), u_ct_("\t\t/* strcmp(when, \"WDAND2BFR\")",sizeof(strcmp(when, "WDAND2BFR")),strcmp(when, "WDAND2BFR")), strcmp(when, "WDAND2BFR")) == 0){ {t_ct_(" {"); t_ct_("\n1021 \t\t  if (count > 1)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) > 1){ {t_ct_(" {"); t_ct_("\n1022 \t\t    if (strcmp(word, thewordcorpus[count]) ==\n\t\t\t0 &&\n\t\t\tstrcmp(prev2, thewordcorpus[count-2]) ==\n\t\t\t0)"); 
		    if ((strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count)], s_ct_("\t\t    /* thewordcorpus[count]",thewordcorpus[count]), thewordcorpus[count])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[count])",sizeof(strcmp(word, thewordcorpus[count])),strcmp(word, thewordcorpus[count])), strcmp(word, thewordcorpus[count])) ==
			0 &&
			(strcmp((s_ct_("\t\t    /* prev2",prev2), prev2), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count)-2], s_ct_("\t\t    /* thewordcorpus[count-2]",thewordcorpus[count-2]), thewordcorpus[count-2])), u_ct_("\t\t    /* strcmp(prev2, thewordcorpus[count-2])",sizeof(strcmp(prev2, thewordcorpus[count-2])),strcmp(prev2, thewordcorpus[count-2])), strcmp(prev2, thewordcorpus[count-2])) ==
			0){t_ct_("\n1026 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n1027 \t\t  }"); 
		  }}t_ct_("\n1028 \t\t}"); 
		}}
		else{t_ct_("\n1029 \t\telse"); t_ct_(" if (strcmp(when, \"WDAND2TAGBFR\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "WDAND2TAGBFR"), u_ct_("\t\t/* strcmp(when, \"WDAND2TAGBFR\")",sizeof(strcmp(when, "WDAND2TAGBFR")),strcmp(when, "WDAND2TAGBFR")), strcmp(when, "WDAND2TAGBFR")) == 0){ {t_ct_(" {"); t_ct_("\n1030 \t\t  if (count > 1)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) > 1){ {t_ct_(" {"); t_ct_("\n1031 \t\t    if (strcmp(word, thewordcorpus[count]) ==\n\t\t\t0 &&\n\t\t\tstrcmp(prev2, thetagcorpus[count-2]) ==\n\t\t\t0)"); 
		    if ((strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count)], s_ct_("\t\t    /* thewordcorpus[count]",thewordcorpus[count]), thewordcorpus[count])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[count])",sizeof(strcmp(word, thewordcorpus[count])),strcmp(word, thewordcorpus[count])), strcmp(word, thewordcorpus[count])) ==
			0 &&
			(strcmp((s_ct_("\t\t    /* prev2",prev2), prev2), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count)-2], s_ct_("\t\t    /* thetagcorpus[count-2]",thetagcorpus[count-2]), thetagcorpus[count-2])), u_ct_("\t\t    /* strcmp(prev2, thetagcorpus[count-2])",sizeof(strcmp(prev2, thetagcorpus[count-2])),strcmp(prev2, thetagcorpus[count-2])), strcmp(prev2, thetagcorpus[count-2])) ==
			0){t_ct_("\n1035 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n1036 \t\t  }"); 
		  }}t_ct_("\n1037 \t\t}"); 
		}}
		else{t_ct_("\n1038 \t\telse"); t_ct_(" if (strcmp(when, \"PREV2TAG\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "PREV2TAG"), u_ct_("\t\t/* strcmp(when, \"PREV2TAG\")",sizeof(strcmp(when, "PREV2TAG")),strcmp(when, "PREV2TAG")), strcmp(when, "PREV2TAG")) == 0){ {t_ct_(" {"); t_ct_("\n1039 \t\t  if (count > 1)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) > 1){ {t_ct_(" {"); t_ct_("\n1040 \t\t    if (strcmp(tag, thetagcorpus[count - 2]) == 0)"); 
		    if ((strcmp((s_ct_("\t\t    /* tag",tag), tag), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) - 2], s_ct_("\t\t    /* thetagcorpus[count - 2]",thetagcorpus[count - 2]), thetagcorpus[count - 2])), u_ct_("\t\t    /* strcmp(tag, thetagcorpus[count - 2])",sizeof(strcmp(tag, thetagcorpus[count - 2])),strcmp(tag, thetagcorpus[count - 2])), strcmp(tag, thetagcorpus[count - 2])) == 0){t_ct_("\n1041 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n1042 \t\t  }"); 
		  }}t_ct_("\n1043 \t\t}"); 
		}} else{t_ct_(" else"); t_ct_(" if (strcmp(when, \"PREV2WD\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "PREV2WD"), u_ct_("\t\t/* strcmp(when, \"PREV2WD\")",sizeof(strcmp(when, "PREV2WD")),strcmp(when, "PREV2WD")), strcmp(when, "PREV2WD")) == 0){ {t_ct_(" {"); t_ct_("\n1044 \t\t  if (count > 1)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) > 1){ {t_ct_(" {"); t_ct_("\n1045 \t\t    if (strcmp(word, thewordcorpus[count - 2]) == 0)"); 
		    if ((strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) - 2], s_ct_("\t\t    /* thewordcorpus[count - 2]",thewordcorpus[count - 2]), thewordcorpus[count - 2])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[count - 2])",sizeof(strcmp(word, thewordcorpus[count - 2])),strcmp(word, thewordcorpus[count - 2])), strcmp(word, thewordcorpus[count - 2])) == 0){t_ct_("\n1046 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n1047 \t\t  }"); 
		  }}t_ct_("\n1048 \t\t}"); 
		}} else{t_ct_(" else"); t_ct_(" if (strcmp(when, \"PREV1OR2TAG\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "PREV1OR2TAG"), u_ct_("\t\t/* strcmp(when, \"PREV1OR2TAG\")",sizeof(strcmp(when, "PREV1OR2TAG")),strcmp(when, "PREV1OR2TAG")), strcmp(when, "PREV1OR2TAG")) == 0){ {t_ct_(" {"); t_ct_("\n1049 \t\t  if (count > 0)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) > 0){ {t_ct_(" {"); t_ct_("\n1050 \t\t    if (count > 1)"); 
		    if ((u_ct_("\t\t    /* count",sizeof(count),count), count) > 1){ t_ct_("\n1051 \t\t      tempcount1 = count-2;"); 
		      (tempcount1 = (u_ct_("\t\t      /* count",sizeof(count),count), count)-2, u_ct_("\t\t      /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1);}
		    else{t_ct_("\n1052 \t\t    else"); t_ct_("\n1053 \t\t      tempcount1 = count-1;"); 
		      (tempcount1 = (u_ct_("\t\t      /* count",sizeof(count),count), count)-1, u_ct_("\t\t      /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1);}t_ct_("\n1054 \t\t    if (strcmp(tag, thetagcorpus[count - 1]) == 0 ||\n\t\t\tstrcmp(tag, thetagcorpus[tempcount1]) == 0)"); 
		    if ((strcmp((s_ct_("\t\t    /* tag",tag), tag), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) - 1], s_ct_("\t\t    /* thetagcorpus[count - 1]",thetagcorpus[count - 1]), thetagcorpus[count - 1])), u_ct_("\t\t    /* strcmp(tag, thetagcorpus[count - 1])",sizeof(strcmp(tag, thetagcorpus[count - 1])),strcmp(tag, thetagcorpus[count - 1])), strcmp(tag, thetagcorpus[count - 1])) == 0 ||
			(strcmp((s_ct_("\t\t    /* tag",tag), tag), (thetagcorpus[(u_ct_("\t\t    /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1)], s_ct_("\t\t    /* thetagcorpus[tempcount1]",thetagcorpus[tempcount1]), thetagcorpus[tempcount1])), u_ct_("\t\t    /* strcmp(tag, thetagcorpus[tempcount1])",sizeof(strcmp(tag, thetagcorpus[tempcount1])),strcmp(tag, thetagcorpus[tempcount1])), strcmp(tag, thetagcorpus[tempcount1])) == 0){t_ct_("\n1056 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n1057 \t\t  }"); 
		  }}t_ct_("\n1058 \t\t}"); 
		}} else{t_ct_(" else"); t_ct_(" if (strcmp(when, \"PREV1OR2WD\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "PREV1OR2WD"), u_ct_("\t\t/* strcmp(when, \"PREV1OR2WD\")",sizeof(strcmp(when, "PREV1OR2WD")),strcmp(when, "PREV1OR2WD")), strcmp(when, "PREV1OR2WD")) == 0){ {t_ct_(" {"); t_ct_("\n1059 \t\t  if (count > 0)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) > 0){ {t_ct_(" {"); t_ct_("\n1060 \t\t    if (count > 1)"); 
		    if ((u_ct_("\t\t    /* count",sizeof(count),count), count) > 1){ t_ct_("\n1061 \t\t      tempcount1 = count-2;"); 
		      (tempcount1 = (u_ct_("\t\t      /* count",sizeof(count),count), count)-2, u_ct_("\t\t      /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1);}
		    else{t_ct_("\n1062 \t\t    else"); t_ct_("\n1063 \t\t      tempcount1 = count-1;"); 
		      (tempcount1 = (u_ct_("\t\t      /* count",sizeof(count),count), count)-1, u_ct_("\t\t      /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1);}t_ct_("\n1064 \t\t    if (strcmp(word, thewordcorpus[count - 1]) == 0 ||\n\t\t\tstrcmp(word, thewordcorpus[tempcount1]) == 0)"); 
		    if ((strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) - 1], s_ct_("\t\t    /* thewordcorpus[count - 1]",thewordcorpus[count - 1]), thewordcorpus[count - 1])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[count - 1])",sizeof(strcmp(word, thewordcorpus[count - 1])),strcmp(word, thewordcorpus[count - 1])), strcmp(word, thewordcorpus[count - 1])) == 0 ||
			(strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1)], s_ct_("\t\t    /* thewordcorpus[tempcount1]",thewordcorpus[tempcount1]), thewordcorpus[tempcount1])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[tempcount1])",sizeof(strcmp(word, thewordcorpus[tempcount1])),strcmp(word, thewordcorpus[tempcount1])), strcmp(word, thewordcorpus[tempcount1])) == 0){t_ct_("\n1066 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n1067 \t\t  }"); 
		  }}t_ct_("\n1068 \t\t}"); 
		}} else{t_ct_(" else"); t_ct_(" if (strcmp(when, \"PREV1OR2OR3TAG\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "PREV1OR2OR3TAG"), u_ct_("\t\t/* strcmp(when, \"PREV1OR2OR3TAG\")",sizeof(strcmp(when, "PREV1OR2OR3TAG")),strcmp(when, "PREV1OR2OR3TAG")), strcmp(when, "PREV1OR2OR3TAG")) == 0){ {t_ct_(" {"); t_ct_("\n1069 \t\t  if (count > 0)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) > 0){ {t_ct_(" {"); t_ct_("\n1070 \t\t    if (count>1)"); 
		    if ((u_ct_("\t\t    /* count",sizeof(count),count), count)>1){ t_ct_("\n1071 \t\t      tempcount1 = count-2;"); 
		      (tempcount1 = (u_ct_("\t\t      /* count",sizeof(count),count), count)-2, u_ct_("\t\t      /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1);}
		    else{t_ct_("\n1072 \t\t    else");  t_ct_("\n1073 \t\t      tempcount1 = count-1;"); 
		      (tempcount1 = (u_ct_("\t\t      /* count",sizeof(count),count), count)-1, u_ct_("\t\t      /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1);}t_ct_("\n1074 \t\t    if (count >2)"); 
		    if ((u_ct_("\t\t    /* count",sizeof(count),count), count) >2){ t_ct_("\n1075 \t\t      tempcount2 = count-3;"); 
		      (tempcount2 = (u_ct_("\t\t      /* count",sizeof(count),count), count)-3, u_ct_("\t\t      /* tempcount2",sizeof(tempcount2),tempcount2), tempcount2);}
		    else{t_ct_("\n1076 \t\t    else");  t_ct_("\n1077 \t\t      tempcount2 = count-1;"); 
		      (tempcount2 = (u_ct_("\t\t      /* count",sizeof(count),count), count)-1, u_ct_("\t\t      /* tempcount2",sizeof(tempcount2),tempcount2), tempcount2);}t_ct_("\n1078 \t\t    if (strcmp(tag, thetagcorpus[count - 1]) == 0 ||\n\t\t\tstrcmp(tag, thetagcorpus[tempcount1]) == 0 ||\n\t\t\tstrcmp(tag, thetagcorpus[tempcount2]) == 0)"); 
		    if ((strcmp((s_ct_("\t\t    /* tag",tag), tag), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) - 1], s_ct_("\t\t    /* thetagcorpus[count - 1]",thetagcorpus[count - 1]), thetagcorpus[count - 1])), u_ct_("\t\t    /* strcmp(tag, thetagcorpus[count - 1])",sizeof(strcmp(tag, thetagcorpus[count - 1])),strcmp(tag, thetagcorpus[count - 1])), strcmp(tag, thetagcorpus[count - 1])) == 0 ||
			(strcmp((s_ct_("\t\t    /* tag",tag), tag), (thetagcorpus[(u_ct_("\t\t    /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1)], s_ct_("\t\t    /* thetagcorpus[tempcount1]",thetagcorpus[tempcount1]), thetagcorpus[tempcount1])), u_ct_("\t\t    /* strcmp(tag, thetagcorpus[tempcount1])",sizeof(strcmp(tag, thetagcorpus[tempcount1])),strcmp(tag, thetagcorpus[tempcount1])), strcmp(tag, thetagcorpus[tempcount1])) == 0 ||
			strcmp((s_ct_("\t\t    /* tag",tag), tag), thetagcorpus[(u_ct_("\t\t    /* tempcount2",sizeof(tempcount2),tempcount2), tempcount2)]) == 0){t_ct_("\n1081 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n1082 \t\t  }"); 
		  }}t_ct_("\n1083 \t\t}"); 
		}} else{t_ct_(" else"); t_ct_(" if (strcmp(when, \"PREV1OR2OR3WD\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "PREV1OR2OR3WD"), u_ct_("\t\t/* strcmp(when, \"PREV1OR2OR3WD\")",sizeof(strcmp(when, "PREV1OR2OR3WD")),strcmp(when, "PREV1OR2OR3WD")), strcmp(when, "PREV1OR2OR3WD")) == 0){ {t_ct_(" {"); t_ct_("\n1084 \t\t  if (count > 0)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) > 0){ {t_ct_(" {"); t_ct_("\n1085 \t\t    if (count>1)"); 
		    if ((u_ct_("\t\t    /* count",sizeof(count),count), count)>1){ t_ct_("\n1086 \t\t      tempcount1 = count-2;"); 
		      (tempcount1 = (u_ct_("\t\t      /* count",sizeof(count),count), count)-2, u_ct_("\t\t      /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1);}
		    else{t_ct_("\n1087 \t\t    else");  t_ct_("\n1088 \t\t      tempcount1 = count-1;"); 
		      (tempcount1 = (u_ct_("\t\t      /* count",sizeof(count),count), count)-1, u_ct_("\t\t      /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1);}t_ct_("\n1089 \t\t    if (count >2)"); 
		    if ((u_ct_("\t\t    /* count",sizeof(count),count), count) >2){ t_ct_("\n1090 \t\t      tempcount2 = count-3;"); 
		      (tempcount2 = (u_ct_("\t\t      /* count",sizeof(count),count), count)-3, u_ct_("\t\t      /* tempcount2",sizeof(tempcount2),tempcount2), tempcount2);}
		    else{t_ct_("\n1091 \t\t    else");  t_ct_("\n1092 \t\t      tempcount2 = count-1;"); 
		      (tempcount2 = (u_ct_("\t\t      /* count",sizeof(count),count), count)-1, u_ct_("\t\t      /* tempcount2",sizeof(tempcount2),tempcount2), tempcount2);}t_ct_("\n1093 \t\t    if (strcmp(word, thewordcorpus[count - 1]) == 0 ||\n\t\t\tstrcmp(word, thewordcorpus[tempcount1]) == 0 ||\n\t\t\tstrcmp(word, thewordcorpus[tempcount2]) == 0)"); 
		    if ((strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) - 1], s_ct_("\t\t    /* thewordcorpus[count - 1]",thewordcorpus[count - 1]), thewordcorpus[count - 1])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[count - 1])",sizeof(strcmp(word, thewordcorpus[count - 1])),strcmp(word, thewordcorpus[count - 1])), strcmp(word, thewordcorpus[count - 1])) == 0 ||
			(strcmp((s_ct_("\t\t    /* word",word), word), (thewordcorpus[(u_ct_("\t\t    /* tempcount1",sizeof(tempcount1),tempcount1), tempcount1)], s_ct_("\t\t    /* thewordcorpus[tempcount1]",thewordcorpus[tempcount1]), thewordcorpus[tempcount1])), u_ct_("\t\t    /* strcmp(word, thewordcorpus[tempcount1])",sizeof(strcmp(word, thewordcorpus[tempcount1])),strcmp(word, thewordcorpus[tempcount1])), strcmp(word, thewordcorpus[tempcount1])) == 0 ||
			strcmp((s_ct_("\t\t    /* word",word), word), thewordcorpus[(u_ct_("\t\t    /* tempcount2",sizeof(tempcount2),tempcount2), tempcount2)]) == 0){t_ct_("\n1096 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n1097 \t\t  }"); 
		  }}t_ct_("\n1098 \t\t}"); 
		}} else{t_ct_(" else"); t_ct_(" if (strcmp(when, \"PREVBIGRAM\") == 0)");  if ((strcmp((s_ct_("\t\t/* when",when), when), "PREVBIGRAM"), u_ct_("\t\t/* strcmp(when, \"PREVBIGRAM\")",sizeof(strcmp(when, "PREVBIGRAM")),strcmp(when, "PREVBIGRAM")), strcmp(when, "PREVBIGRAM")) == 0){ {t_ct_(" {"); t_ct_("\n1099 \t\t  if (count > 1)"); 
		  if ((u_ct_("\t\t  /* count",sizeof(count),count), count) > 1){ {t_ct_(" {"); t_ct_("\n1100 \t\t    if (strcmp(prev1, thetagcorpus[count - 2]) == 0 &&\n\t\t\tstrcmp(prev2, thetagcorpus[count - 1]) == 0)"); 
		    if ((strcmp((s_ct_("\t\t    /* prev1",prev1), prev1), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) - 2], s_ct_("\t\t    /* thetagcorpus[count - 2]",thetagcorpus[count - 2]), thetagcorpus[count - 2])), u_ct_("\t\t    /* strcmp(prev1, thetagcorpus[count - 2])",sizeof(strcmp(prev1, thetagcorpus[count - 2])),strcmp(prev1, thetagcorpus[count - 2])), strcmp(prev1, thetagcorpus[count - 2])) == 0 &&
			(strcmp((s_ct_("\t\t    /* prev2",prev2), prev2), (thetagcorpus[(u_ct_("\t\t    /* count",sizeof(count),count), count) - 1], s_ct_("\t\t    /* thetagcorpus[count - 1]",thetagcorpus[count - 1]), thetagcorpus[count - 1])), u_ct_("\t\t    /* strcmp(prev2, thetagcorpus[count - 1])",sizeof(strcmp(prev2, thetagcorpus[count - 1])),strcmp(prev2, thetagcorpus[count - 1])), strcmp(prev2, thetagcorpus[count - 1])) == 0){t_ct_("\n1102 \t\t      change_the_tag(thetagcorpus,new,count);"); 
		      change_the_tag((u_ct_("\t\t      /* thetagcorpus",sizeof(thetagcorpus),thetagcorpus), thetagcorpus),(u_ct_("\t\t      /* new",sizeof(new),new), new),(u_ct_("\t\t      /* count",sizeof(count),count), count));}t_ct_("\n1103 \t\t  }"); 
		  }}t_ct_("\n1104 \t\t}"); 
		}}
		else{t_ct_("\n1105 \t\telse");  t_ct_("\n1106 \t\t  fprintf(stderr,\n\t\t\t  \"ERROR: %s is not an allowable transform type\\n\",\n\t\t\t  when);"); 
		  fprintf(stderr,
			  "ERROR: %s is not an allowable transform type\n",
			  (u_ct_("\t\t  /* when",sizeof(when),when), when));}}}}}}}}}}}}}}}}}}}}}}}}}}}}t_ct_("\n1109 \t      }"); 
	      }}t_ct_("\n1110 \t    }"); 
	    }}t_ct_("\n1111 \t    }"); 
	    }}t_ct_("\n1112 \t    free(split_ptr);"); 
	    free((u_ct_("\t    /* split_ptr",sizeof(split_ptr),split_ptr), split_ptr));t_ct_("\n1113 \t  free(new);"); 
	  free((u_ct_("\t  /* new",sizeof(new),new), new));t_ct_("\n1114 \t  }"); 
	  }}t_ct_("\n    /* return */"); 
      }
#include <signal.h>

#undef stdout
#ifdef __STDC__
#	define stdout	(&__iob[1])
#else
#	define stdout	(&_iob[1])
#endif
#include <setjmp.h>
#define VM_CT_ 10
#define PF_CT_ printf(
#define LM_CT_ 20
#line 1 "/disk2/SUNWspro/bin/../SC4.2/bin/runtime.c"
/*
 * Copyright 13 Apr 1996 Sun Microsystems, Inc. All Rights Reserved
 */

/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident "@(#)RELEASE VERSION WorkShop Compilers 4.2 31 Oct 1996"

/*	ctrace - C program debugging tool
 *
 *	run-time package of trace functions
 *
 */

#ifndef B_CT_

/* signal catching function used by u_ct_ */
static jmp_buf sj_ct_;
static
f_ct_()
{
	longjmp(sj_ct_, 1);
}
#endif

#ifdef LM_CT_
#define I_CT_(x)	((x + LM_CT_) % LM_CT_)

/* global data used by loop detection code */
static	int	ts_ct_;	/* trace state */
#endif

/* global data used by duplicate variable trace code */
static	int	vc_ct_;	/* var trace count within statement */

static	struct	{	/* var values within statement */
	char	*vn_ct_;	/* var name */
	int	vt_ct_;		/* var type (0 is string, > 0 is size) */
	union	{		/* var value */
		char	*vs_ct_;/* string */
		int	vi_ct_;	/* int */
		long	vl_ct_;	/* long */
		double	vd_ct_;	/* double */
	} vv_ct_;
} v_ct_[VM_CT_];

/* trace on/off control */
static	int	tr_ct_ = 1;

static
ctron()
{
	tr_ct_ = 1;
	PF_CT_" \b\n    /* trace on */ \b");
}

static
ctroff()
{
	tr_ct_ = 0;
	PF_CT_" \b\n    /* trace off */ \b");
}
/* print the statement text */

static
t_ct_(text)
register char	*text;
{
#ifdef LM_CT_
	static	int	loop_start, next_stmt;
	static	char	*stmt[LM_CT_];
	static	long	loops;
	register int	i;
	register char	*s;
	register char	c;
#endif

	/* return if tracing is off */
	if (!tr_ct_) {
		return;
	}
#ifdef LM_CT_
	if (ts_ct_ == 2)	/* if not tracing */
		if (strcmp(text, stmt[next_stmt]) == 0) {
			if (strcmp(text, stmt[loop_start]) == 0) {
				++loops;
				if (loops % 1000 == 0)
					PF_CT_" \b\n    /* still repeating after %ld times */ \b", loops);
				next_stmt = loop_start;
			}
			next_stmt = I_CT_(next_stmt + 1);
			vc_ct_ = 0;	/* reset the var count */
			return;
		}
		else {	/* doesn't match next statement */
			if (loops == 0)
				PF_CT_" \b\n    /* repeated < 1 time */ \b");
			else
				PF_CT_" \b\n    /* repeated %ld times */ \b", loops);
			loops = 0;
			PF_CT_" \b%s \b", stmt[I_CT_(next_stmt - 1)]); /* print last statement */
			ts_ct_ = 4;	/* force var printing */
			for (i = 0; i < vc_ct_; ++i) /* print its vars */
				if (v_ct_[i].vt_ct_ == 0) /* string? */
					s_ct_(v_ct_[i].vn_ct_, v_ct_[i].vv_ct_.vs_ct_); /* yes */
				else if (v_ct_[i].vt_ct_ == sizeof(int))
					u_ct_(v_ct_[i].vn_ct_, v_ct_[i].vt_ct_, v_ct_[i].vv_ct_.vi_ct_);
				else if (v_ct_[i].vt_ct_ == sizeof(long))
					u_ct_(v_ct_[i].vn_ct_, v_ct_[i].vt_ct_, v_ct_[i].vv_ct_.vl_ct_);
				else	/* double */
					u_ct_(v_ct_[i].vn_ct_, v_ct_[i].vt_ct_, v_ct_[i].vv_ct_.vd_ct_);
			ts_ct_ = 0;	/* start tracing */
		}
#endif
	vc_ct_ = 0;	/* reset the var count */

#ifdef LM_CT_
	if (ts_ct_ == 0) {	/* if looking for the start of a loop */
		/* if statement in list */
		for (i = I_CT_(next_stmt - 2); i != I_CT_(next_stmt - 1); i = I_CT_(i - 1))
			if ((s = stmt[i]) != 0 &&	/* saved text could be null */
			    strcmp(text, s) == 0 &&	/* if text matches */
			    (c = s[strlen(s) - 1]) != '{' && c != '}') { /* and is not a brace */
				ts_ct_ = 1;	/* look for the loop end */
				loop_start = i;
				next_stmt = I_CT_(loop_start + 1);
				goto print_stmt;
			}
	}
	else	/* if looking for the loop end */
		if (strcmp(text, stmt[loop_start]) == 0) { /* if start stmt */
			ts_ct_ = 2;			/* stop tracing */
			PF_CT_" \b\n    /* repeating */ \b");
			stmt[next_stmt] = text;	/* save as end marker */
			next_stmt = I_CT_(loop_start + 1);
			return;
		}
		else if (strcmp(text, stmt[next_stmt]) != 0) /* if not next stmt */
			ts_ct_ = 0; /* look for the start of a loop */
	stmt[next_stmt] = text;	/* save this statement */
	next_stmt = I_CT_(next_stmt + 1); /* inc the pointer */
print_stmt:
#endif
	PF_CT_" \b%s \b", text); /* print this statement */
#ifndef B_CT_
	(void) fflush(stdout);		/* flush the output buffer */
#endif
}
/* dump a string variable */

static
s_ct_(name, value)
register char	*name;
register char	*value;
{
	/* return if tracing is off */
	if (!tr_ct_) {
		return;
	}
#ifdef LM_CT_
	/* save the var name and value */
	if (ts_ct_ != 4) {	/* if not forcing var printing */
		v_ct_[vc_ct_].vn_ct_ = name;
		v_ct_[vc_ct_].vt_ct_ = 0;	/* var type is string */
		v_ct_[vc_ct_].vv_ct_.vs_ct_ = value;
		++vc_ct_;
	}

	if (ts_ct_ == 2)	/* if not tracing */
		return;
#endif

	PF_CT_" \b\n    %s == \"", name);
	/* flush before printing the string because it may cause an
	   abort if it is not null terminated */
#ifndef B_CT_
	(void) fflush(stdout);
#endif
	PF_CT_"%s\" */ \b", value);
#ifndef B_CT_
	(void) fflush(stdout);
#endif
}
/* dump a variable of an unknown type */



static void
u_ct_(char *name, int _size, ...)	/* size is a macro in <macros.h> */
{
#ifndef isprint
#include <ctype.h>
#endif
	va_list plist;
	union {
		char	*p;
		int	i;
		long	l;
		double	d;
	} value;
	register int	i;
	register char	*s;
	register char	c;

	/* return if tracing is off */
	if (!tr_ct_) {
		return;
	}

	va_start(plist, char*);

	/* normalize the size (pointer and float are the same size as either int or long) */
	if (_size == sizeof(char) || _size == sizeof(short) || _size ==sizeof(int)) {
		_size = sizeof(int);
		value.i = va_arg(plist,int);
	}
	else if (_size == sizeof(long) ) {
		_size = sizeof(int);
		value.l = va_arg(plist,long);
	}
	else if (_size == sizeof(double) ) {
		_size = sizeof(int);
		value.d = va_arg(plist,double);
	}
	else {
	/* this is an extern pointer (size=0), or array or struct address */
		_size = sizeof(char *);
		value.p = va_arg(plist,char *);
	}
#ifdef LM_CT_
	if (ts_ct_ != 4) {	/* if not forcing var printing */
#endif
		/* don't dump the variable if its value is the same */
		for (i = 0; i < vc_ct_; ++i)
			if (_size == v_ct_[i].vt_ct_ && strcmp(name, v_ct_[i].vn_ct_) == 0)
				if (_size == sizeof(int)) {
					if (value.i == v_ct_[i].vv_ct_.vi_ct_)
						return;
				}
				else if (_size == sizeof(long)) {
					if (value.l == v_ct_[i].vv_ct_.vl_ct_)
						return;
				}
				else /* double */
					if (value.d == v_ct_[i].vv_ct_.vd_ct_)
						return;
	
		/* save the var name and value */
		v_ct_[vc_ct_].vn_ct_ = name;
		v_ct_[vc_ct_].vt_ct_ = _size;
		if (_size == sizeof(int)) {
			v_ct_[vc_ct_].vv_ct_.vi_ct_ = value.i;
		}
		else if (_size == sizeof(long)) {
			v_ct_[vc_ct_].vv_ct_.vl_ct_ = value.l;
		}
		else /* double */
			v_ct_[vc_ct_].vv_ct_.vd_ct_ = value.d;
		++vc_ct_;
#ifdef LM_CT_
	}

	if (ts_ct_ == 2)	/* if not tracing */
		return;
#endif
	/* determine the variable type and print it */
	PF_CT_" \b\n    %s == ", name);
	if (_size == sizeof(int)) {
		PF_CT_"%d", value.i);	/* decimal */
#ifdef O_CT_
		if ((unsigned) value.i > 7)	/* octal */
			PF_CT_" or 0%o", value.i);
#endif
#ifdef X_CT_
		if ((unsigned) value.i > 9)	/* hexadecimal */
			PF_CT_" or 0x%x", value.i);
#endif
#ifdef U_CT_
		if (value.i < 0)		/* unsigned */
			PF_CT_" or %u", value.i);
#endif
#ifdef E_CT_
		if (_size == sizeof(float))	/* float */
			PF_CT_" or %e", value.i);
#endif
		if ((unsigned) value.i <= 255) /* character */
			if (isprint(value.i))
				PF_CT_" or '%c'", value.i);
			else if (iscntrl(value.i)) {
				switch (value.i) {
					case '\n': c = 'n'; break;
					case '\t': c = 't'; break;
					case '\b': c = 'b'; break;
					case '\r': c = 'r'; break;
					case '\f': c = 'f'; break;
					case '\v': c = 'v'; break;
					default:    c = '\0';
				}
				if (c != '\0')
					PF_CT_" or '\\%c'", c);
			}
	}
	else if (_size == sizeof(long)) {
		PF_CT_"%ld", value.l);	/* decimal */
#ifdef O_CT_
		if ((unsigned) value.l > 7)	/* octal */
			PF_CT_" or 0%lo", value.l);
#endif
#ifdef X_CT_
	if ((unsigned) value.l > 9)	/* hexadecimal */
			PF_CT_" or 0x%lx", value.l);
#endif
#ifdef U_CT_
		if (value.l < 0)		/* unsigned */
			PF_CT_" or %lu", value.l);
#endif
#ifdef E_CT_
		if (_size == sizeof(float))	/* float */
			PF_CT_" or %e", value.l);
#endif
	}
	else if (_size == sizeof(double))	/* double */
		PF_CT_"%e", value.d);
#ifndef B_CT_
	/* check for a possible non-null pointer */
	if (_size == sizeof(char *) && value.p != 0) {
		int	(*sigbus)(), (*sigsegv)();

		/* see if this is a non-null string */
		if (setjmp(sj_ct_) == 0) {
			sigbus = (int (*)()) signal(SIGBUS, (void (*)())f_ct_);
			sigsegv = (int (*)()) signal(SIGSEGV, (void (*)())f_ct_);
			if (*value.p != '\0')
				for (s = value.p; ; ++s) {
					if ((c = *s) == '\0') {
						PF_CT_" or \"%s\"", value.p);
						break;
					}
					/* don't use isspace(3) because \v and others will not print properly */
					if (!isprint(c) && c != '\t' && c != '\n')
						break;	/* not string */
				}
		}
		signal(SIGBUS, (void (*)())sigbus);
		signal(SIGSEGV, (void (*)())sigsegv);
	}
#endif
	PF_CT_" */ \b");
#ifndef B_CT_
	(void) fflush(stdout);
#endif
}
