# 
#        PorterEnglishStemmer/creole_config.tcl - configuration file
#
#        Wednesday July 02 13:54:23 (GTB Daylight Time) 2003
#        
#        $Id: template_config.tcl, Ellogon, version 1.5... 
#            (Georgios Petasis, 23/11/1998), petasis@iit.demokritos.gr   $


set creole_config(PorterEnglishStemmer) \
{  
    title {English Stemmer (Porter Algorithm)}
    pre_conditions {
        collection_attributes      {}
        document_attributes        {language_english}
        annotations                {token}
    }
    post_conditions {
        collection_attributes      {}
        document_attributes        {PorterEnglishStemmer }
        annotations                {{token stem}} 
    }
    viewers {
      {} AnnotationExplorer {Explore Annotations...}
    }
    parameters {
      
    }
    coupling dynamic
    description {Author: Georgios Sigletos & Georgios Petasis, Sat Jul 26 20:25:19 2003.  This Component was originally written by Georgios Sigletos, but adapted by Georgios Petasis so as to give an example on how to program a Component that uses the C or the C++ CDM interface.}
};# PorterEnglishStemmer

## Compatibility Mode: Use 0 for Ellogon mode, 1 for GATE compatibility
## mode...
set ::CDM::ComponentMode(creole_PorterEnglishStemmer) 0

#
# End of File
#
