# 
#	SimpleTokeniser/creole_config.tcl - configuration file
#
#	Monday February 26 19:32:06 (EET) 2001
#	
#	$Id: template_config.tcl, Ellogon, version 1.00... 
#            (Georgios Petasis, 23/11/1998), petasis@iit.demokritos.gr   $


set creole_config(SimpleTokeniser) \
{  
    title {Simple Tokeniser}
    pre_conditions
    {
	collection_attributes	{}
	document_attributes	{language_any}
	annotations		{}
    }
    post_conditions
    {
	collection_attributes	{}
	document_attributes	{SimpleTokeniser}
	annotations		{token sentence {sentence constituents}} 
    }
    viewers
    {
      {token type}  single_span {Token Type}
      {token}       raw         {Token Annotations...}
      {sentence}    raw         {Sentence Annotations...}
    }
    parameters {
      {Generate sentences on new-line characters} %BOOLEAN% 0
    }
    coupling loose
    description {Author: petasis, Mon Feb 26 19:30:35 EET 2001}
}

## Compatibility Mode: Use 0 for Ellogon mode, 1 for GATE compatibility
## mode...
set ::CDM::ComponentMode(creole_SimpleTokeniser) 0

#
# End of File
#

