/*****************************************************************************
 *  Document.java:                                                           *
 * ----------------------------------                                        *
 *  This file contains support code for offering Compatibility modes for     *
 *  other platforms.                                                         *
 *  This class was designed and implemented by Georgios Petasis,             *
 *  e-mail: petasis@iit.demokritos.gr                                        *
 *  URL:    http://www.iit.demokritos.gr/~petasis                            *
 *                                                                           *
 *  Copyright 1998-2003 by:                                                  *
 *  Georgios Petasis,                                                        *
 *  Software and Knowledge Engineering Laboratory,                           *
 *  Institute of Informatics and Telecommunications,                         *
 *  National Center for Scientific Research (N.C.S.R.) "Demokritos",         *
 *  Athens, Greece.                                                          *
 *  E-mail: petasis@iit.demokritos.gr                                        *
 *                                                                           *
 *  This file is part of the "Ellogon" Text Engineering Platform.            *
 *  For licencing information, please refer to the licence conditions of     *
 *  "Ellogon" Text Engineering Platform.                                     *
 *****************************************************************************/

package gate;
import tcl.lang.*;
import Ellogon.JCDM.*;

public class Document extends OCDM_Document {

  public Document() {
  }; /* Document */

  public Document(OCDM_Document doc) {
    super(doc);
  }; /* Document */

  public Integer getNextAnnotationId() {
    return new Integer(0);
  }; /* getNextAnnotationId */

  public Integer add(Annotation obj) {
    return new Integer(0);
  }; /* add */

}; /* class Document */
