###########################################################################
# tip_AnnotationSet #######################################################
###########################################################################

##############################################################################
##  tip_SelectAnnotationsSorted.tcl:                                        ##
## ----------------------------------                                       ##
##  This file implements tip_SelectAnnotationsSorted.                       ##
##                                                                          ##
##  Copyright 1998-2004 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Software and Knowledge Engineering Laboratory,                          ##
##  Institute of Informatics and Telecommunications,                        ##
##  N.C.S.R. "Demokritos"                                                   ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Text Engineering Platform.                                    ##
##############################################################################

## tip_SelectAnnotationsSorted
#  Author: George Petasis, petasis@iit.demokritos.gr
proc tip_SelectAnnotationsSorted {args} {
  ## Sort the Annotations according to their span
  lsort -command tip_CompareAnnotations [eval tip_SelectAnnotations $args]
};# tip_SelectAnnotationsSorted
## SelectAnnotationsSorted
#  Author: George Petasis, petasis@iit.demokritos.gr
#proc SelectAnnotationsSorted {args} {
#  ## Sort the Annotations according to their span
#  lsort -command tip_CompareAnnotations [eval tip_SelectAnnotations $args]
#};# SelectAnnotationsSorted
## tip_SortAnnotationSet
#  Author: George Petasis, petasis@iit.demokritos.gr
proc tip_SortAnnotationSet {Set {mode -increasing}} {
  lsort $mode -command tip_CompareAnnotations $Set
}
## SortAnnotationSet
#  Author: George Petasis, petasis@iit.demokritos.gr
proc SortAnnotationSet {Set {mode -increasing}} {
  lsort $mode -command tip_CompareAnnotations $Set
}
#proc tip_CompareAnnotations {Ann1 Ann2} {
#  set span1 [tip_GetFirstSpan $Ann1]
#  set span2 [tip_GetFirstSpan $Ann2]
#  set start1 [lindex $span1 0]
#  set start2 [lindex $span2 0]
#
#  if {$start1 >  $start2} {return  1}
#  if {$start1 <  $start2} {return -1}
#  if {$start1 == $start2} {
#    set end1 [lindex $span1 1]
#    set end2 [lindex $span2 1]
#    if {$end1 == $end2} {return 0}
#    if {$end1 >  $end2} {return 1}
#    return -1
#  }
#};# tip_SortAnnotations
