
namespace eval ::redland {
  proc load {dir} {
    switch $::tcl_platform(platform) {
      windows {
        load_windows $dir
      }
      default {
      }
    }
  };# load

  proc load_windows {dir} {
    set CWD [pwd]
    cd $dir/Windows
    ::load $dir/Windows/dll.dll
    source $dir/Windows/dll_tcl.tcl
    foreach dll {libxml2.dll libxslt.dll libcurl.dll raptor.dll librdf.dll} {
      dll::load [file native $dir/Windows/$dll]
    }
    ::load [file native $dir/Windows/redland.dll]
    cd $CWD
  };# load_windows
  
};# namespace ::redland

package ifneeded redland 1.0.4 [list ::redland::load $dir]
