##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::ComponentBase library package.         ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval ComponentBase {
  };# namespace  ComponentBase
};# namespace  ::ELEP

package ifneeded ELEP::ComponentBase 1.0 \
        [list source [file join $dir ComponentBase.tcl]]
package ifneeded ELEP::ComponentBase::ProcessingComponent 1.0 \
        [list source [file join $dir ProcessingComponent.tcl]]
