package require Tk
wm withdraw .
  set HomeDir [file dirname [file normalize [info script]]]
  set lib_elep [file dirname $HomeDir]
  set lib [file dirname $lib_elep]/lib
  lappend auto_path $lib_elep $lib

  package require ELEP::Base::Utilities
  package require ELEP::FlowControl::Canvas
  set toplevel .evolutionToolkit
  toplevel $toplevel
  bind $toplevel <Destroy> exit
  wm title $toplevel {Evolution Toolkit version 1.0}
  set canvas [ELEP::FlowControl::Canvas create [ELEP::Base::auto C] \
                                 $toplevel -background white]
  pack [$canvas getframe] -fill both -expand 1
  set c [$canvas canvas]

  image create photo tile -data {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  }
  #$canvas tile tile

  package require ELEP::FlowControl::ComponentItem
  package require ELEP::FlowControl::ConnectionItem
  wm geometry $toplevel 800x500

  ##
  ## Evolution Pattern Selector
  ##
  set selector [ELEP::FlowControl::ComponentItem create \
    [ELEP::Base::auto C] $c \
    -inputNodeNumber 0 -outputNodeNumber 4 -label {Evolution Pattern Selector}]
  $selector place 400  50; $selector setSize 600 80
  $selector draw; $selector locked true
  $selector setState enabled

  ##
  ## Configure evolution patterns...
  ##
  set P(1) { {Instance Matching} {Instance Grouping} {}
             {ABox Validation} {ABox Assimilation}}
  set P(2) { {Instance Matching} {Instance Grouping} {ABox Refinment}
             {ABox Validation} {ABox Assimilation}}
  set P(3) { {Concept Learning} {Concept Enhancement} {Concept Definition}
             {Concept Validation} {Concept Assimilation}}
  set P(4) { {Concept Learning} {} {Concept Definition}
             {Concept Validation} {Concept Assimilation}}

  set width 90
  set height 50
  foreach pattern {1 2 3 4} {
    set selector_output_node [expr {$pattern-1}]
    set x [lindex [$selector getOutputNodeCoordinates $selector_output_node] 0]
    set y 170
    set prev_item $selector
    set first 1
    foreach component $P($pattern) {
      if {[string length $component]} {
        set item [ELEP::FlowControl::ComponentItem create [ELEP::Base::auto C] $c -label $component]
        $item place $x $y; $item setSize $width $height
        $item draw; $item locked true
        if {$first} {
          set first 0
          set arc [ELEP::FlowControl::ConnectionItem create [ELEP::Base::auto C] $c \
                         $selector $selector_output_node \
                         $item 0 -label P$pattern]
        } else {
          set arc [ELEP::FlowControl::ConnectionItem create [ELEP::Base::auto C] $c $prev_item 0 \
                         $item 0]
        }
        $arc draw
        set prev_item $item
      }
      ## Configure the last item to not have an output node!
      $item configure -outputNodeNumber 0; $item draw
      incr y [expr {$height + 20}]
    }
  }

  $canvas update
  $selector configure -col Col -doc Doc

if {0} {
  ##
  ## Instance Matching
  ##
  set item2 [ELEP::FlowControl::ComponentItem create [ELEP::Base::auto C] $c -inputNodeNumber 2 \
    -outputNodeNumber 2 -label {Instance Matching}]
  $item2 place 250 170; $item2 setSize 300 80

  set arc1 [ELEP::FlowControl::ConnectionItem create [ELEP::Base::auto C] $c $item1 0 $item2 0 \
    -label { P1 }]
  set arc2 [ELEP::FlowControl::ConnectionItem create [ELEP::Base::auto C] $c $item1 1 $item2 1 \
    -label { P2 }]

  ##
  ## Instance Grouping
  ##
  set item3 [ELEP::FlowControl::ComponentItem create [ELEP::Base::auto C] $c -inputNodeNumber 2 \
    -outputNodeNumber 2 -label {Instance Grouping}]
  $item3 place 250 290; $item3 setSize 300 80

  set arc3 [ELEP::FlowControl::ConnectionItem create [ELEP::Base::auto C] $c $item2 0 $item3 0 \
    -label { P1 }]
  set arc4 [ELEP::FlowControl::ConnectionItem create [ELEP::Base::auto C] $c $item2 1 $item3 1 \
    -label { P2 }]

  ##
  ## ABox Refinment
  ##
  set item4 [ELEP::FlowControl::ComponentItem create [ELEP::Base::auto C] $c -inputNodeNumber 1 \
    -outputNodeNumber 1 -label {ABox Refinment}]
  $item4 place 301 410; $item4 setSize 150 80

  set arc5 [ELEP::FlowControl::ConnectionItem create [ELEP::Base::auto C] $c $item3 1 $item4 0 \
    -label { P2 }]

  ##
  ## ABox Validation
  ##
  set item5 [ELEP::FlowControl::ComponentItem create [ELEP::Base::auto C] $c -inputNodeNumber 2 \
    -outputNodeNumber 2 -label {ABox Validation}]
  $item5 place 250 530; $item5 setSize 300 80

  set arc6 [ELEP::FlowControl::ConnectionItem create [ELEP::Base::auto C] $c $item3 0 $item5 0 \
    -label { P1 }]
  set arc7 [ELEP::FlowControl::ConnectionItem create [ELEP::Base::auto C] $c $item4 0 $item5 1 \
    -label { P2 }]

  ##
  ## ABox Assimilation
  ##
  set item6 [ELEP::FlowControl::ComponentItem create [ELEP::Base::auto C] $c -inputNodeNumber 2 \
    -outputNodeNumber 0 -label {ABox Assimilation}]
  $item6 place 250 650; $item6 setSize 300 80

  set arc8 [ELEP::FlowControl::ConnectionItem create [ELEP::Base::auto C] $c $item5 0 $item6 0 \
    -label { P1 }]
  set arc9 [ELEP::FlowControl::ConnectionItem create [ELEP::Base::auto C] $c $item5 1 $item6 1 \
    -label { P2 }]

  foreach one [info globals item*] {
    [set $one] draw
    [set $one] locked true
  }
  foreach one [info globals arc*] {
    [set $one] draw
  }
  $canvas update
}
