console show
package require grammar::fa
package require grammar::fa::dexec

grammar::fa fa
fa fromRegex {. {S a} {+ {S b}} {S a}}

fa determinize
puts "Final states: [fa finalstates]"

proc executor_callback {op args} {
  puts "$op: $args"; update
  switch $op {
    error {parser reset}
    final {parser reset}
  }
}

::grammar::fa::dexec parser fa -command executor_callback

foreach token {c c c a b b a c c} {
  parser put $token
}
