##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::PatternEngine library package.         ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval PatternEngine {
    namespace eval temp {
    };# namespace  temp
    namespace eval grammars {
    };# namespace  grammars
  };# namespace  PatternEngine
};# namespace  ::ELEP

package ifneeded ELEP::PatternEngine::GrammarCompilerGenerator 1.0 \
        [list source [file join $dir GrammarCompilerGenerator.tcl]]
package ifneeded ELEP::PatternEngine::GrammarCompiler 1.0 \
        [list source [file join $dir GrammarCompiler.tcl]]
package ifneeded ELEP::PatternEngine::GrammarExecutor 1.0 \
        [list source [file join $dir GrammarExecutor.tcl]]
package ifneeded ELEP::PatternEngine::EBNFScanner 1.0 \
        [list source [file join $dir EBNFScanner.tcl]]
package ifneeded ELEP::PatternEngine::EBNFParser 1.0 \
        [list source [file join $dir EBNFParser.tcl]]
