##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::System library package.                ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval System {
  };# namespace  System
};# namespace  ::ELEP

package ifneeded ELEP::System::System 1.0 \
        [list source [file join $dir System.tcl]]
package ifneeded ELEP::System::SystemDesign 1.0 \
        [list source [file join $dir SystemDesign.tcl]]
package ifneeded ELEP::System::SystemDeploy 1.0 \
        [list source [file join $dir SystemDeploy.tcl]]
package ifneeded ELEP::System::SystemExpose 1.0 \
        [list source [file join $dir SystemExpose.tcl]]
package ifneeded ELEP::System::CollectionManager 1.0 \
        [list source [file join $dir CollectionManager.tcl]]
package ifneeded ELEP::System::SystemManager 1.0 \
        [list source [file join $dir SystemManager.tcl]]
package ifneeded ELEP::System::Component 1.0 \
        [list source [file join $dir Component.tcl]]
package ifneeded ELEP::System::ComponentRunner 1.0 \
        [list source [file join $dir ComponentRunner.tcl]]
package ifneeded ELEP::System::ComponentOptionsEditor 1.0 \
        [list source [file join $dir ComponentOptionsEditor.tcl]]
package ifneeded ELEP::System::Progress 1.0 \
        [list source [file join $dir Progress.tcl]]
