##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::VisualAnnotators library package.      ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval VisualAnnotators {
  };# namespace  VisualAnnotators
};# namespace  ::ELEP

package ifneeded ELEP::VisualAnnotators::VisualRegexp 1.0 \
        [list source [file join $dir VisualRegexp.tcl]]
package ifneeded ELEP::VisualAnnotators::TextAnnotator 1.0 \
        [list source [file join $dir TextAnnotator.tcl]]
package ifneeded ELEP::VisualAnnotators::HtmlAnnotator 1.0 \
        [list source [file join $dir HtmlAnnotator.tcl]]
package ifneeded ELEP::VisualAnnotators::TextTemplateFiller 1.0 \
        [list source [file join $dir TextTemplateFiller.tcl]]
package ifneeded ELEP::VisualAnnotators::HtmlTemplateFiller 1.0 \
        [list source [file join $dir HtmlTemplateFiller.tcl]]
package ifneeded ELEP::VisualAnnotators::TextAnnotatorWithAnnotationSelector 1.0 \
        [list source [file join $dir TextAnnotatorWithAnnotationSelector.tcl]]
package ifneeded ELEP::VisualAnnotators::HtmlAnnotatorWithAnnotationSelector 1.0 \
        [list source [file join $dir HtmlAnnotatorWithAnnotationSelector.tcl]]
package ifneeded ELEP::VisualAnnotators::TextAnnotatorAlignment 1.0 \
        [list source [file join $dir TextAnnotatorAlignment.tcl]]
package ifneeded ELEP::VisualAnnotators::TextCoreferenceAnnotator 1.0 \
        [list source [file join $dir TextCoreferenceAnnotator.tcl]]
package ifneeded ELEP::VisualAnnotators::TextCoreferenceAnnotatorAlignment 1.0 \
        [list source [file join $dir TextCoreferenceAnnotatorAlignment.tcl]]
package ifneeded ELEP::VisualAnnotators::TextAnnotatorWithEvents 1.0 \
        [list source [file join $dir TextAnnotatorWithEvents.tcl]]
