##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::Widgets library package.               ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval Widgets {
  };# namespace  Widgets
};# namespace  ::ELEP

package ifneeded ELEP::Widgets 1.0 "\
    package require BWidget;\
    [list tclPkgSetup $dir ELEP::Widgets 1.0 {
{buttonnotebook.tcl source {ButtonNoteBook ButtonNoteBook::create ButtonNoteBook::use}}
    }]"
