#include <stdlib.h>
#include "EmbedAPI.h"

int main(int argc, char **argv) {
  int instance;
  char *arguments[5];
  /* Initialise the Ellogon embeding API... */
  Tcl_Interp *interp = Ellogon_Init(argc, argv);
  if (interp == NULL) {
    /* An error ocuured! */
    exit(-1);
  }

  /* Start an Ellogon instance... */
  arguments[0] = "-gui";
  arguments[1] = "true";
  instance = Ellogon_CreateInstance(interp, "../../../ellogon", 2, arguments);
  printf("Ellogon instance created with id: %d\n", instance);
  /* Start a second ellogon instance! */
  instance = Ellogon_CreateInstance(interp, "../../../ellogon", 2, arguments);
  printf("Ellogon instance created with id: %d\n", instance);
  /* Open the Ellogon console... */
  Ellogon_InstanceEval(interp, instance, "gut_Console");
  /* sleep for 1 minute... */
  Ellogon_InstanceEval(interp, instance, "after 60000");
  return 0;
}; /* main */
