######################################################################
## This is the package index file for the tBuild Tcl extension.
## tBuild tries to provide a Tcl interface that can be used to
## build Tcl extensions in a portable way. tBuild will try to 
## identify how compilation and linkage of dynamic libraries can
## be done under a specific operating system.
##
## tBuild can be configured in two ways: It can operate by executing
## OS commands that build the shared object, or writes a makefile that
## can be used to build the extension.
##
## tBuild is copyrighted by:
## George Petasis, National Centre for Scientific Research "Demokritos",
## Aghia Paraskevi, Athens, Greece.
## e-mail: petasis@iit.demokritos.gr
##
## The following terms apply to all files associated
## with the software unless explicitly disclaimed in individual files.
##
## The authors hereby grant permission to use, copy, modify, distribute,
## and license this software and its documentation for any purpose, provided
## that existing copyright notices are retained in all copies and that this
## notice is included verbatim in any distributions. No written agreement,
## license, or royalty fee is required for any of the authorized uses.
## Modifications to this software may be copyrighted by their authors
## and need not follow the licensing terms described here, provided that
## the new terms are clearly indicated on the first page of each file where
## they apply.
## 
## IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
## FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
## ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
## DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
## POSSIBILITY OF SUCH DAMAGE.
## 
## THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
## INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
## FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
## IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
## NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
## MODIFICATIONS.
##

package ifneeded tBuild 1.0 [list \
    source [file join $dir tBuild.tcl]]
package ifneeded tBuild::Extension 1.0 [list \
    source [file join $dir tExtension.tcl]]
