## Emulate the mci package under Unix, using "xanim"
namespace eval ::xanim {
  variable XANIM_Executable Info
  set XANIM_Executable xanim

  proc mci {string args} {
    variable XANIM_Executable
    variable Info
    switch -glob $string {
      play* {
        ## play $win from 0:0:0
	## Do the actual play...
	set alias [lindex $string 1]
	exec $XANIM_Executable +W$Info($alias:Window) +Wr +Av90 +Ze \
	     $Info($alias:File)
	puts "$XANIM_Executable +W$Info($alias:Window) +Wr +Av90 +Ze \
	     $Info($alias:File)"
      }
      stop* {
        ## stop $win
      }
      configure* {
        ## configure $win
      }
      pause* {
        ## pause $win
      }
      resume* {
        ## resume $win
      }
      open* {
        ## open \"$VideoFile\" alias $win
	set Info([lindex $string 3]:File)   [lindex $string 1]
	puts "Info([lindex $string 3]:File) $Info([lindex $string 3]:File)"
      }
      window* {
        ## window $win handle $id
        set Info([lindex $string 1]:Window) [lindex $string 3]
	puts "Info([lindex $string 1]:Window) $Info([lindex $string 1]:Window)"
      }
      close* {
        ## close $win
      }
    }
  };# mci
};# namespace eval ::xanim

proc mci {string args} {::xanim::mci $string $args}
