# 
#        %%ModuleName%%/creole_config.tcl - configuration file
#
#        %%Date%%
#        
#        $Id: template_config.tcl, %%Program%%, version %%Version%%... 
#            (Georgios Petasis, 23/11/1998), petasis@iit.demokritos.gr   $


set creole_config(%%ModuleName%%) \
{  
    title {%%Title%%}
    pre_conditions {
        collection_attributes      {%%PreColAttr%%}
        document_attributes        {%%PreDocAttr%%}
        annotations                {%%PreAnns%%}
    }
    post_conditions {
        collection_attributes      {%%PostColAttr%%}
        document_attributes        {%%ModuleName%% %%PostDocAttr%%}
        annotations                {%%PostAnns%%} 
    }
    viewers {
      %%Viewers%%
    }
    parameters {
      %%Parameters%%
    }
    coupling %%Coupling%%
    description %%Description%%
    module_encoding %%Encoding%%
    type %%ModuleType%%
};# %%ModuleName%%

## Compatibility Mode: Use 0 for %%Program%% mode, 1 for GATE compatibility
## mode...
set ::CDM::ComponentMode(creole_%%ModuleName%%) 0

#
# End of File
#
