set ThemeDir DefaultNoAlphaChannel
set HomeDir [file dirname [info script]]
cd $HomeDir
catch {file delete -force $ThemeDir}
file mkdir $ThemeDir
foreach file [glob -type f -directory $HomeDir/Default *] {
  set tail [file tail $file]
  set root [file root $tail]
  switch -glob $file {
    *.gif {
      puts "GIF: $file"
      file copy -force $file $ThemeDir/$tail
    }
    *.png {
      puts "PNG: $file"
      exec convert $file $ThemeDir/$root.gif
    }
    default {
      file copy -force $file $ThemeDir
    }
  }
}
