# 
#        WEKA_Loader/creole_config.tcl - configuration file
#
#        Saturday November 06 23:00:43 (GTB Standard Time) 2004
#        
#        $Id: template_config.tcl, Ellogon, version 1.7.0... 
#            (Georgios Petasis, 23/11/1998), petasis@iit.demokritos.gr   $

## How to load WEKA:
## Either place the file weka.jar in the weka directory, or update the field
## "classpath" below to point to the file weka.jar (using unix notation even
## under windows, as in:
##  classpath {C:/Program Files/weka-3-4/weka.jar}
## Of course, none of the above actions is necessary if the environmental
## variable "CLASSPATH" is defined, and already contains weka.jar.

set ::WEKA_HOME {C:/Program Files/weka-3-4/weka.jar}

set creole_config(WEKA_Loader) \
{  
    title {Weka Loader}
    pre_conditions {
        collection_attributes      {}
        document_attributes        {language_hellenic}
        annotations                {}
    }
    post_conditions {
        collection_attributes      {}
        document_attributes        {WEKA_Loader }
        annotations                {} 
    }
    viewers {
      {} AnnotationExplorer {Explore Annotations...}
    }
    parameters {
      
    }
    coupling java
    description {Author: George, Sat Nov 06 23:00:14 GTB Standard Time 2004}
    module_encoding cp1253
    classpath "$creole_WEKA_Loader_home/weka/weka.jar;$WEKA_HOME"
    type module
};# WEKA_Loader

## Compatibility Mode: Use 0 for Ellogon mode, 1 for GATE compatibility
## mode...
set ::CDM::ComponentMode(creole_WEKA_Loader) 0
catch {gut_RegisterTool WEKA_Loader {Machine Learning...}}

#
# End of File
#
