# 
#	AddSentenceConstituents/creole_config.tcl - configuration file
#
#	Sunday March 05 09:06:31 (EET) 2000
#	
#	$Id: template_config.tcl, Ellogon, version 1.0... 
#            (Georgios Petasis, 23/11/1998), petasis@iit.demokritos.gr   $


set creole_config(AddSentenceConstituents) \
{  
    title {Add Sentence Constituents}
    pre_conditions
    {
	collection_attributes	{}
	document_attributes	{language_any}
	annotations		{token sentence}
    }
    post_conditions
    {
	collection_attributes	{}
	document_attributes	{AddSentenceConstituents}
	annotations		{{sentence constituents}} 
    }
    viewers
    {
      {token} raw {Token Annotations...}
    }
    parameters
    {
      
    }
    coupling loose
    description {Author: petasis, Sun Mar 05 09:05:13 EET 2000}
}

## Compatibility Mode: Use 0 for Ellogon mode, 1 for GATE compatibility
## mode...
set ::CDM::ComponentMode(creole_AddSentenceConstituents) 0

#
# End of File
#

