# 
#	HGazetteer/creole_config.tcl - configuration file
#
#	Friday October 08 23:15:00 (EEST) 1999
#	
#	$Id: template_config.tcl, Ellogon, version 1.0... 
#            (Georgios Petasis, 23/11/1998), petasis@iit.demokritos.gr   $


set creole_config(HGazetteer) \
{  
    title {Greek List Lookup Module}
    pre_conditions
    {
	collection_attributes	{}
	document_attributes	{language_hellenic}
	annotations		{{token pos} {token stem}}
    }
    post_conditions
    {
	collection_attributes	{}
	document_attributes	{HGazetteer}
	annotations		{lookup {lookup type} {lookup tag}} 
    }
    viewers
    {
      {lookup type} single_span {Types}
      {lookup} raw {Raw Lookup Annotations}
    }
    parameters
    {
      {Use "token" attribute:} %COMBO% {stem lemma}
      {Convert to lowercase}   ToLower   1
    }
    coupling dynamic
    description {Author: petasis, Fri Oct 08 23:10:40 EEST 1999, petasis@iit.demokritos.gr}
    module_encoding iso8859-7
}

## Compatibility Mode: Use 0 for Ellogon mode, 1 for GATE compatibility
## mode...
set ::CDM::ComponentMode(creole_HGazetteer) 0

#
# End of File
#

