# 
#	HTokenizer/creole_config.tcl - configuration file
#
#	Monday February 15 10:04:06 (EET) 1999
#
#        $Id: template_config.tcl, Ellogon, version 1.5... 
#            (Georgios Petasis, 23/11/1998), petasis@iit.demokritos.gr   $

set creole_config(HTokenizer) \
{  
    title {Greek Tokenizer Splitter}
    type  module
    image HTokenizer.gif
    pre_conditions
    {
	collection_attributes	{}
	document_attributes	{language_hellenic}
	annotations		{}
    }
    post_conditions
    {
	collection_attributes	{}
	document_attributes	{HTokenizer}
	annotations		{token {token type}
	                         sentence {sentence constituents}} 
    }
    viewers
    {
      {token type}      single_span {Token Type}
      {token}           raw         {Raw Token}
      {sentence}        single_span {Sentences}
      {sentence}        raw         {Raw Sentences}
      {token}           AnnotationExplorer {Explore Annotations...}
    }
    parameters
    {
      {Do not Update Status Bar (faster)} 1 {}
    }
    coupling dynamic
    description {This is the Greek Tokenizer/Sentence Splitter Module}
    module_encoding iso8859-7
}

## Compatibility Mode: Use 0 for Ellogon mode, 1 for GATE compatibility
## mode...
set ::CDM::ComponentMode(creole_HTokenizer) 0
#
# End of File
#
