# 
#	JavaTokeniserSplitter/creole_config.tcl - configuration file
#
#	Tuesday November 19 22:31:58 (EET) 2002
#	
#	$Id: template_config.tcl, Ellogon, version 1.5... 
#            (Alexandros Dais, 23/11/1998), adais@iit.demokritos.gr   $


set creole_config(JavaTokeniserSplitter) \
{  
    title {Simple Java Tokeniser/Sentence Splitter}
    pre_conditions
    {
	collection_attributes	{}
	document_attributes	{language_any}
	annotations		{}
    }
    post_conditions
    {
	collection_attributes	{}
	document_attributes	{JavaTokeniserSplitter}
	annotations		{token    {token type}
                                 sentence {sentence constituents}} 
    }
    viewers
    {
      {token type}      single_span        {Token Type}
      {token}           raw                {Raw Token}
      {sentence}        single_span        {Sentences}
      {sentence}        raw                {Raw Sentences}
      {token}           AnnotationExplorer {Explore Annotations...}
    }
    parameters {}
    coupling java
    classpath {}
    description {Author: adais, Tue Nov 19 10:30:02 PM EET 2002}
    image JavaModule.gif
};# JavaTokeniserSplitter

## Compatibility Mode: Use 0 for Ellogon mode, 1 for GATE compatibility
## mode...
set ::CDM::ComponentMode(creole_JavaTokeniserSplitter) 0

#
# End of File
#

