# 
#        LanguageIdentifier/creole_config.tcl - configuration file
#
#        Monday September 21 21:31:37 (EEST) 2009
#        
#        $Id: template_config.tcl, Ellogon, version 1.8.1... 
#            (Georgios Petasis, 23/11/1998), petasis@iit.demokritos.gr   $


set creole_config(LanguageIdentifier) \
{  
    title {Automatic Language Identifier}
    pre_conditions {
        collection_attributes      {}
        document_attributes        {language_any}
        annotations                {}
    }
    post_conditions {
        collection_attributes      {}
        document_attributes        {LanguageIdentifier auto-language
                                                       auto-language-detail}
        annotations                {} 
    }
    viewers {
      {} AnnotationExplorer {Explore Annotations...}
    }
    parameters {
      {Language Models} %DIRECTORY% {$::creole_LanguageIdentifier_home/LM}
    }
    coupling loose
    description {Author: George Petasis, Mon Sep 21 21:30:02 EEST 2009}
    module_encoding cp1253
    type module
};# LanguageIdentifier

## Compatibility Mode: Use 0 for Ellogon mode, 1 for GATE compatibility
## mode...
set ::CDM::ComponentMode(creole_LanguageIdentifier) 0

#
# End of File
#
