# 
#	UnicodeListLookup/creole_config.tcl - configuration file
#
#	Wednesday November 21 22:02:16 (EET) 2001
#	
#	$Id: template_config.tcl, Ellogon, version 1.00... 
#            (Georgios Petasis, 23/11/1998), petasis@iit.demokritos.gr   $


set creole_config(UnicodeListLookup) \
{  
    title {Unicode List Lookup Component}
    pre_conditions
    {
	collection_attributes	{}
	document_attributes	{language_any}
	annotations		{token}
    }
    post_conditions
    {
	collection_attributes	{}
	document_attributes	{UnicodeListLookup}
	annotations		{lookup} 
    }
    viewers
    {
      {lookup type} single_span {Lookup Types...}
       lookup       raw         {Raw Lookup Annotations...}
       {$creole_UnicodeListLookup_home/Rules.txt utf-8} text_file {Rule File}
    }
    parameters
    {
      {Lookup Rule File:} %FILE% "$creole_UnicodeListLookup_home/Rules.txt"
      {Lookup Rule File Encoding:} %ENCODING% utf-8
      {Create Rule File} %COMMAND% {-command creole_UnicodeListLookupCreateFile}
    }
    coupling loose
    description {Author: petasis, Wed Nov 21 22:01:12 EET 2001
Part of the Ellogon Text Engineering Platform}
    module_encoding utf-8
};# UnicodeListLookup

## Compatibility Mode: Use 0 for Ellogon mode, 1 for GATE compatibility
## mode...
set ::CDM::ComponentMode(creole_UnicodeListLookup) 0

#
# End of File
#

